Registro de cambios
*******************


Python siguiente
================

*Release date: XXXX-XX-XX*


Seguridad
---------

* gh-101727: Updated the OpenSSL version used in Windows and macOS
  binary release builds to 1.1.1t to address CVE-2023-0286,
  CVE-2022-4303, and CVE-2022-4303 per the OpenSSL 2023-02-07 security
  advisory.

* gh-101283: "subprocess.Popen" now uses a safer approach to find
  "cmd.exe" when launching with "shell=True". Patch by Eryk Sun, based
  on a patch by Oleg Iarygin.


Núcleo y elementos integrados
-----------------------------

* gh-102416: Do not memoize incorrectly automatically generated loop
  rules in the parser. Patch by Pablo Galindo.

* gh-102356: Fix a bug that caused a crash when deallocating deeply
  nested filter objects. Patch by Marta Gómez Macías.

* gh-102397: Fix segfault from race condition in signal handling
  during garbage collection. Patch by Kumar Aditya.

* gh-102126: Fix deadlock at shutdown when clearing thread states if
  any finalizer tries to acquire the runtime head lock. Patch by Kumar
  Aditya.

* gh-102027: Fix SSE2 and SSE3 detection in "_blake2" internal module.
  Patch by Max Bachmann.

* gh-101967: Fix possible segfault in
  "positional_only_passed_as_keyword" function, when new list created.

* gh-101765: Fix SystemError / segmentation fault in iter "__reduce__"
  when internal access of "builtins.__dict__" keys mutates the iter
  object.


Biblioteca
----------

* gh-102947: Improve traceback when "dataclasses.fields()" is called
  on a non-dataclass. Patch by Alex Waygood

* gh-101979: Fix a bug where parentheses in the "metavar" argument to
  "argparse.ArgumentParser.add_argument()" were dropped. Patch by
  Yeojin Kim.

* gh-102179: Fix "os.dup2()" error message for negative fds.

* gh-101961: For the binary mode, "fileinput.hookcompressed()" doesn't
  set the "encoding" value even if the value is "None". Patch by
  Gihwan Kim.

* gh-101936: The default value of "fp" becomes "io.BytesIO" if
  "HTTPError" is initialized without a designated "fp" parameter.
  Patch by Long Vo.

* gh-101566: In zipfile, apply fix for extractall on the underlying
  zipfile after being wrapped in "Path".

* gh-101997: Upgrade pip wheel bundled with ensurepip (pip 23.0.1)

* gh-101892: Callable iterators no longer raise "SystemError" when the
  callable object exhausts the iterator but forgets to either return a
  sentinel value or raise "StopIteration".

* gh-97786: Fix potential undefined behaviour in corner cases of
  floating-point-to-time conversions.

* gh-101517: Fixed bug where "bdb" looks up the source line with
  "linecache" with a "lineno=None", which causes it to fail with an
  unhandled exception.

* gh-101673: Fix a "pdb" bug where "ll" clears the changes to local
  variables.

* gh-96931: Fix incorrect results from
  "ssl.SSLSocket.shared_ciphers()"

* gh-88233: Correctly preserve "extra" fields in "zipfile" regardless
  of their ordering relative to a zip64 "extra."

* gh-95495: When built against OpenSSL 3.0, the "ssl" module had a bug
  where it reported unauthenticated EOFs (i.e. without close_notify)
  as a clean TLS-level EOF. It now raises "SSLEOFError", matching the
  behavior in previous versions of OpenSSL. The "options" attribute on
  "SSLContext" also no longer includes "OP_IGNORE_UNEXPECTED_EOF" by
  default. This option may be set to specify the previous OpenSSL 3.0
  behavior.

* gh-94440: Fix a "concurrent.futures.process" bug where
  "ProcessPoolExecutor" shutdown could hang after a future has been
  quickly submitted and canceled.


Documentación
-------------

* gh-103112: Add docstring to "http.client.HTTPResponse.read()" to fix
  "pydoc" output.

* gh-85417: Update "cmath" documentation to clarify behaviour on
  branch cuts.

* gh-97725: Fix "asyncio.Task.print_stack()" description for
  "file=None". Patch by Oleg Iarygin.


Pruebas
-------

* gh-102980: Improve test coverage on "pdb".

* gh-102537: Adjust the error handling strategy in
  "test_zoneinfo.TzPathTest.python_tzpath_context". Patch by Paul
  Ganssle.

* gh-101377: Improved test_locale_calendar_formatweekday of calendar.


Construir
---------

* gh-102711: Fix "-Wstrict-prototypes" compiler warnings.


Ventanas
--------

* gh-101759: Update Windows installer to SQLite 3.40.1.

* gh-101614: Correctly handle extensions built against debug binaries
  that reference "python3_d.dll".


Mac OS
------

* gh-103207: Add instructions to the macOS installer welcome display
  on how to workaround the macOS 13 Ventura “The installer encountered
  an error” failure.

* gh-101759: Update macOS installer to SQLite 3.40.1.

* gh-87235: On macOS "python3 /dev/fd/9 9</path/to/script.py" failed
  for any script longer than a couple of bytes.


Python 3.10.10 final
====================

*Release date: 2023-02-07*


Núcleo y elementos integrados
-----------------------------

* gh-101400: Fix wrong lineno in exception message on "continue" or
  "break" which are not in a loop. Patch by Dong-hee Na.

* gh-101372: Fix "is_normalized()" to properly handle the UCD 3.2.0
  cases. Patch by Dong-hee Na.

* gh-101046: Fix a possible memory leak in the parser when raising
  "MemoryError". Patch by Pablo Galindo

* gh-100942: Fixed segfault in property.getter/setter/deleter that
  occurred when a property subclass overrode the "__new__" method to
  return a non-property instance.

* gh-100892: Fix race while iterating over thread states in clearing
  "threading.local". Patch by Kumar Aditya.

* gh-100776: Fix misleading default value in "input()"'s
  "__text_signature__".

* gh-100374: Fix incorrect result and delay in "socket.getfqdn()".
  Patch by Dominic Socular.

* gh-100050: Honor existing errors obtained when searching for
  mismatching parentheses in the tokenizer. Patch by Pablo Galindo

* bpo-32782: "ctypes" arrays of length 0 now report a correct itemsize
  when a "memoryview" is constructed from them, rather than always
  giving a value of 0.


Biblioteca
----------

* gh-100795: Avoid potential unexpected "freeaddrinfo" call (double
  free) in "socket" when when a libc "getaddrinfo()" implementation
  leaves garbage in an output pointer when returning an error.
  Original patch by Sergey G. Brester.

* gh-101143: Remove unused references to "TimerHandle" in
  "asyncio.base_events.BaseEventLoop._add_callback".

* gh-101144: Make "zipfile.Path.open()" and "zipfile.Path.read_text()"
  also accept "encoding" as a positional argument. This was the
  behavior in Python 3.9 and earlier. Earlier 3.10 versions had a
  regression where supplying it as a positional argument would lead to
  a "TypeError".

* gh-100573: Fix a Windows "asyncio" bug with named pipes where a
  client doing "os.stat()" on the pipe would cause an error in the
  server that disabled serving future requests.

* gh-90104: Avoid RecursionError on "repr" if a dataclass field
  definition has a cyclic reference.

* gh-100689: Fix crash in "pyexpat" by statically allocating
  "PyExpat_CAPI" capsule.

* gh-100740: Fix "unittest.mock.Mock" not respecting the spec for
  attribute names prefixed with "assert".

* gh-86508: Fix "asyncio.open_connection()" to skip binding to local
  addresses of different family. Patch by Kumar Aditya.

* gh-100287: Fix the interaction of "unittest.mock.seal()" with
  "unittest.mock.AsyncMock".

* gh-100474: "http.server" now checks that an index page is actually a
  regular file before trying to serve it.  This avoids issues with
  directories named "index.html".

* gh-100160: Remove any deprecation warnings in
  "asyncio.get_event_loop()". They are deferred to Python 3.12.

* gh-99952: Fix a reference undercounting issue in "ctypes.Structure"
  with "from_param()" results larger than a C pointer.

* gh-98778: Update "HTTPError" to be initialized properly, even if the
  "fp" is "None". Patch by Dong-hee Na.

* gh-83035: Fix "inspect.getsource()" handling of decorator calls with
  nested parentheses.

* gh-99240: Fix double-free bug in Argument Clinic "str_converter" by
  extracting memory clean up to a new "post_parsing" section.

* gh-85267: Several improvements to "inspect.signature()"'s handling
  of "__text_signature". - Fixes a case where "inspect.signature()"
  dropped parameters - Fixes a case where "inspect.signature()" raised
  "tokenize.TokenError" - Allows "inspect.signature()" to understand
  defaults involving binary operations of constants -
  "inspect.signature()" is documented as only raising "TypeError" or
  "ValueError", but sometimes raised "RuntimeError". These cases now
  raise "ValueError" - Removed a dead code path

* gh-96192: Fix handling of "bytes" *path-like objects* in
  "os.ismount()".

* bpo-44817: Ignore WinError 53 (ERROR_BAD_NETPATH), 65
  (ERROR_NETWORK_ACCESS_DENIED) and 161 (ERROR_BAD_PATHNAME) when
  using ntpath.realpath().

* bpo-40447: Accept "os.PathLike" (such as "pathlib.Path") in the
  "stripdir" arguments of "compileall.compile_file()" and
  "compileall.compile_dir()".

* bpo-36880: Fix a reference counting issue when a "ctypes" callback
  with return type "py_object" returns "None", which could cause
  crashes.


Documentación
-------------

* gh-100616: Document existing "attr" parameter to
  "curses.window.vline()" function in "curses".

* gh-100472: Remove claim in documentation that the "stripdir",
  "prependdir" and "limit_sl_dest" parameters of
  "compileall.compile_dir()" and "compileall.compile_file()" could be
  "bytes".


Pruebas
-------

* gh-101334: "test_tarfile" has been updated to pass when run as a
  high UID.

* gh-96002: Add functional test for Argument Clinic.


Construir
---------

* gh-101522: Allow overriding Windows dependencies versions and paths
  using MSBuild properties.


Ventanas
--------

* gh-82052: Fixed an issue where writing more than 32K of Unicode
  output to the console screen in one go can result in mojibake.

* gh-100180: Update Windows installer to OpenSSL 1.1.1s

* bpo-43984: "winreg.SetValueEx()" now leaves the target value
  untouched in the case of conversion errors. Previously, "-1" would
  be written in case of such errors.


Mac OS
------

* gh-100180: Update macOS installer to OpenSSL 1.1.1s


API C
-----

* gh-99240: In argument parsing, after deallocating newly allocated
  memory, reset its pointer to NULL.


Python 3.10.9 final
===================

*Release date: 2022-12-06*


Seguridad
---------

* gh-100001: "python -m http.server" no longer allows terminal control
  characters sent within a garbage request to be printed to the stderr
  server log.

  This is done by changing the "http.server" "BaseHTTPRequestHandler"
  ".log_message" method to replace control characters with a "\xHH"
  hex escape before printing.

* gh-87604: Avoid publishing list of active per-interpreter audit
  hooks via the "gc" module

* gh-98433: The IDNA codec decoder used on DNS hostnames by "socket"
  or "asyncio" related name resolution functions no longer involves a
  quadratic algorithm. This prevents a potential CPU denial of service
  if an out-of-spec excessive length hostname involving bidirectional
  characters were decoded. Some protocols such as "urllib" http "3xx"
  redirects potentially allow for an attacker to supply such a name.

* gh-98739: Update bundled libexpat to 2.5.0

* gh-98517: Port XKCP's fix for the buffer overflows in SHA-3
  (CVE-2022-37454).

* gh-97514: On Linux the "multiprocessing" module returns to using
  filesystem backed unix domain sockets for communication with the
  *forkserver* process instead of the Linux abstract socket namespace.
  Only code that chooses to use the "forkserver" start method is
  affected.

  Abstract sockets have no permissions and could allow any user on the
  system in the same network namespace (often the whole system) to
  inject code into the multiprocessing *forkserver* process. This was
  a potential privilege escalation. Filesystem based socket
  permissions restrict this to the *forkserver* process user as was
  the default in Python 3.8 and earlier.

  This prevents Linux CVE-2022-42919.


Núcleo y elementos integrados
-----------------------------

* gh-99578: Fix a reference bug in "_imp.create_builtin()" after the
  creation of the first sub-interpreter for modules "builtins" and
  "sys". Patch by Victor Stinner.

* gh-99581: Fixed a bug that was causing a buffer overflow if the
  tokenizer copies a line missing the newline caracter from a file
  that is as long as the available tokenizer buffer. Patch by Pablo
  galindo

* gh-96055: Update "faulthandler" to emit an error message with the
  proper unexpected signal number. Patch by Dong-hee Na.

* gh-98852: Fix subscription of "types.GenericAlias" instances
  containing bare generic types: for example "tuple[A, T][int]", where
  "A" is a generic type, and "T" is a type variable.

* gh-98415: Fix detection of MAC addresses for "uuid" on certain OSs.
  Patch by Chaim Sanders

* gh-92119: Print exception class name instead of its string
  representation when raising errors from "ctypes" calls.

* gh-93696: Allow "pdb" to locate source for frozen modules in the
  standard library.

* bpo-31718: Raise "ValueError" instead of "SystemError" when methods
  of uninitialized "io.IncrementalNewlineDecoder" objects are called.
  Patch by Oren Milman.

* bpo-38031: Fix a possible assertion failure in "io.FileIO" when the
  opener returns an invalid file descriptor.


Biblioteca
----------

* gh-100001: Also escape s in the http.server
  BaseHTTPRequestHandler.log_message so that it is technically
  possible to parse the line and reconstruct what the original data
  was.  Without this a xHH is ambiguious as to if it is a hex
  replacement we put in or the characters r"x" came through in the
  original request line.

* gh-93453: "asyncio.get_event_loop()" now only emits a deprecation
  warning when a new event loop was created implicitly. It no longer
  emits a deprecation warning if the current event loop was set.

* gh-51524: Fix bug when calling trace.CoverageResults with valid
  infile.

* gh-99645: Fix a bug in handling class cleanups in
  "unittest.TestCase".  Now "addClassCleanup()" uses separate lists
  for different "TestCase" subclasses, and "doClassCleanups()" only
  cleans up the particular class.

* gh-97001: Release the GIL when calling termios APIs to avoid
  blocking threads.

* gh-99341: Fix "ast.increment_lineno()" to also cover
  "ast.TypeIgnore" when changing line numbers.

* gh-74044: Fixed bug where "inspect.signature()" reported incorrect
  arguments for decorated methods.

* gh-99275: Fix "SystemError" in "ctypes" when exception was not set
  during "__initsubclass__".

* gh-99155: Fix "statistics.NormalDist" pickle with "0" and "1"
  protocols.

* gh-99134: Update the bundled copy of pip to version 22.3.1.

* gh-99130: Apply bugfixes from importlib_metadata 4.11.4, namely: In
  "PathDistribution._name_from_stem", avoid including parts of the
  extension in the result. In "PathDistribution._normalized_name",
  ensure names loaded from the stem of the filename are also
  normalized, ensuring duplicate entry points by packages varying only
  by non-normalized name are hidden.

* gh-83004: Clean up refleak on failed module initialisation in
  "_zoneinfo"

* gh-83004: Clean up refleaks on failed module initialisation in in
  "_pickle"

* gh-83004: Clean up refleak on failed module initialisation in "_io".

* gh-98897: Fix memory leak in "math.dist()" when both points don't
  have the same dimension. Patch by Kumar Aditya.

* gh-98793: Fix argument typechecks in "_overlapped.WSAConnect()" and
  "_overlapped.Overlapped.WSASendTo()" functions.

* gh-98740: Fix internal error in the "re" module which in very rare
  circumstances prevented compilation of a regular expression
  containing a conditional expression without the "else" branch.

* gh-98703: Fix "asyncio.StreamWriter.drain()" to call
  "protocol.connection_lost" callback only once on Windows.

* gh-98624: Add a mutex to unittest.mock.NonCallableMock to protect
  concurrent access to mock attributes.

* gh-89237: Fix hang on Windows in "subprocess.wait_closed()" in
  "asyncio" with "ProactorEventLoop". Patch by Kumar Aditya.

* gh-98458: Fix infinite loop in unittest when a self-referencing
  chained exception is raised

* gh-97928: "tkinter.Text.count()" raises now an exception for options
  starting with "-" instead of silently ignoring them.

* gh-97966: On "uname_result", restored expectation that "_fields" and
  "_asdict" would include all six properties including "processor".

* gh-98331: Update the bundled copies of pip and setuptools to
  versions 22.3 and 65.5.0 respectively.

* gh-96035: Fix bug in "urllib.parse.urlparse()" that causes certain
  port numbers containing whitespace, underscores, plus and minus
  signs, or non-ASCII digits to be incorrectly accepted.

* gh-98251: Allow "venv" to pass along "PYTHON*" variables to
  "ensurepip" and "pip" when they do not impact path resolution

* gh-98178: On macOS, fix a crash in "syslog.syslog()" in multi-
  threaded applications. On macOS, the libc "syslog()" function is not
  thread-safe, so "syslog.syslog()" no longer releases the GIL to call
  it. Patch by Victor Stinner.

* gh-96151: Allow "BUILTINS" to be a valid field name for frozen
  dataclasses.

* gh-98086: Make sure "patch.dict()" can be applied on async
  functions.

* gh-88863: To avoid apparent memory leaks when
  "asyncio.open_connection()" raises, break reference cycles generated
  by local exception and future instances (which has exception
  instance as its member var). Patch by Dong Uk, Kang.

* gh-93858: Prevent error when activating venv in nested fish
  instances.

* bpo-46364: Restrict use of sockets instead of pipes for stdin of
  subprocesses created by "asyncio" to AIX platform only.

* bpo-38523: "shutil.copytree()" now applies the
  *ignore_dangling_symlinks* argument recursively.

* bpo-36267: Fix IndexError in "argparse.ArgumentParser" when a
  "store_true" action is given an explicit argument.


Documentación
-------------

* gh-92892: Document that calling variadic functions with ctypes
  requires special care on macOS/arm64 (and possibly other platforms).


Pruebas
-------

* gh-99892: Skip test_normalization() of test_unicodedata if it fails
  to download NormalizationTest.txt file from pythontest.net. Patch by
  Victor Stinner.

* bpo-34272: Some C API tests were moved into the new
  Lib/test/test_capi/ directory.


Construir
---------

* gh-99086: Fix "-Wimplicit-int", "-Wstrict-prototypes", and
  "-Wimplicit-function-declaration" compiler warnings in **configure**
  checks.

* gh-99086: Fix "-Wimplicit-int" compiler warning in **configure**
  check for "PTHREAD_SCOPE_SYSTEM".

* gh-97731: Specify the full path to the source location for "make
  docclean" (needed for cross-builds).

* gh-98671: Fix "NO_MISALIGNED_ACCESSES" being not defined for the
  SHA3 extension when "HAVE_ALIGNED_REQUIRED" is set. Allowing builds
  on hardware that unaligned memory accesses are not allowed.


Ventanas
--------

* gh-99345: Use faster initialization functions to detect install
  location for Windows Store package

* gh-98689: Update Windows builds to zlib v1.2.13.  v1.2.12 has
  CVE-2022-37434, but the vulnerable "inflateGetHeader" API is not
  used by Python.

* gh-94328: Update Windows installer to use SQLite 3.39.4.

* bpo-40882: Fix a memory leak in
  "multiprocessing.shared_memory.SharedMemory" on Windows.


Mac OS
------

* gh-94328: Update macOS installer to SQLite 3.39.4.


INACTIVO
--------

* gh-97527: Fix a bug in the previous bugfix that caused IDLE to not
  start when run with 3.10.8, 3.12.0a1, and at least Microsoft Python
  3.10.2288.0 installed without the Lib/test package.  3.11.0 was
  never affected.


Herramientas / Demos
--------------------

* gh-95731: Fix handling of module docstrings in
  "Tools/i18n/pygettext.py".


Python 3.10.8 final
===================

*Release date: 2022-10-11*


Seguridad
---------

* gh-97616: Fix multiplying a list by an integer ("list *= int"):
  detect the integer overflow when the new allocated length is close
  to the maximum size. Issue reported by Jordan Limor.  Patch by
  Victor Stinner.

* gh-97612: Fix a shell code injection vulnerability in the "get-
  remote-certificate.py" example script. The script no longer uses a
  shell to run "openssl" commands. Issue reported and initial fix by
  Caleb Shortt. Patch by Victor Stinner.

* gh-68966: The deprecated mailcap module now refuses to inject unsafe
  text (filenames, MIME types, parameters) into shell commands.
  Instead of using such text, it will warn and act as if a match was
  not found (or for test commands, as if the test failed).


Núcleo y elementos integrados
-----------------------------

* gh-96078: "os.sched_yield()" now release the GIL while calling
  sched_yield(2). Patch by Dong-hee Na.

* gh-97943: Bugfix: "PyFunction_GetAnnotations()" should return a
  borrowed reference. It was returning a new reference.

* gh-97591: Fixed a missing incref/decref pair in
  "Exception.__setstate__()". Patch by Ofey Chan.

* gh-96848: Fix command line parsing: reject "-X int_max_str_digits"
  option with no value (invalid) when the "PYTHONINTMAXSTRDIGITS"
  environment variable is set to a valid limit. Patch by Victor
  Stinner.

* gh-95921: Fix overly-broad source position information for chained
  comparisons used as branching conditions.

* gh-96821: Fix undefined behaviour in "_testcapimodule.c".

* gh-95778: When "ValueError" is raised if an integer is larger than
  the limit, mention the "sys.set_int_max_str_digits()" function in
  the error message. Patch by Victor Stinner.

* gh-96387: At Python exit, sometimes a thread holding the GIL can
  wait forever for a thread (usually a daemon thread) which requested
  to drop the GIL, whereas the thread already exited. To fix the race
  condition, the thread which requested the GIL drop now resets its
  request before exiting. Issue discovered and analyzed by Mingliang
  ZHAO. Patch by Victor Stinner.

* gh-96864: Fix a possible assertion failure, fatal error, or
  "SystemError" if a line tracing event raises an exception while
  opcode tracing is enabled.

* gh-96678: Fix undefined behaviour in C code of null pointer
  arithmetic.

* gh-96641: Do not expose "KeyWrapper" in "_functools".

* gh-96611: When loading a file with invalid UTF-8 inside a multi-line
  string, a correct SyntaxError is emitted.

* gh-95196: Disable incorrect pickling of the C implemented
  classmethod descriptors.

* gh-96352: Fix "AttributeError" missing "name" and "obj" attributes
  in "object.__getattribute__()". Patch by Philip Georgi.

* bpo-42316: Document some places where an assignment expression needs
  parentheses.


Biblioteca
----------

* gh-87730: Wrap network errors consistently in urllib FTP support, so
  the test suite doesn't fail when a network is available but the
  public internet is not reachable.

* gh-97825: Fixes "AttributeError" when "subprocess.check_output()" is
  used with argument "input=None" and either of the arguments
  *encoding* or *errors* are used.

* gh-96827: Avoid spurious tracebacks from "asyncio" when default
  executor cleanup is delayed until after the event loop is closed
  (e.g. as the result of a keyboard interrupt).

* gh-97592: Avoid a crash in the C version of
  "asyncio.Future.remove_done_callback()" when an evil argument is
  passed.

* gh-97639: Remove "tokenize.NL" check from "tabnanny".

* gh-97545: Make Semaphore run faster.

* gh-73588: Fix generation of the default name of
  "tkinter.Checkbutton". Previously, checkbuttons in different parent
  widgets could have the same short name and share the same state if
  arguments "name" and "variable" are not specified. Now they are
  globally unique.

* gh-97005: Update bundled libexpat to 2.4.9

* gh-85760: Fix race condition in "asyncio" where "process_exited()"
  called before the "pipe_data_received()" leading to inconsistent
  output. Patch by Kumar Aditya.

* gh-96819: Fixed check in "multiprocessing.resource_tracker" that
  guarantees that the length of a write to a pipe is not greater than
  "PIPE_BUF".

* gh-96741: Corrected type annotation for dataclass attribute
  "pstats.FunctionProfile.ncalls" to be "str".

* gh-96652: Fix the faulthandler implementation of
  "faulthandler.register(signal, chain=True)" if the "sigaction()"
  function is not available: don't call the previous signal handler if
  it's NULL. Patch by Victor Stinner.

* gh-96073: In "inspect", fix overeager replacement of ""typing."" in
  formatting annotations.

* gh-90467: Fix "asyncio.streams.StreamReaderProtocol" to keep a
  strong reference to the created task, so that it's not garbage
  collected

* gh-96052: Fix handling compiler warnings (SyntaxWarning and
  DeprecationWarning) in "codeop.compile_command()" when checking for
  incomplete input. Previously it emitted warnings and raised a
  SyntaxError. Now it always returns "None" for incomplete input
  without emitting any warnings.

* gh-91212: Fixed flickering of the turtle window when the tracer is
  turned off. Patch by Shin-myoung-serp.

* gh-74116: Allow "asyncio.StreamWriter.drain()" to be awaited
  concurrently by multiple tasks. Patch by Kumar Aditya.

* gh-90155: Fix broken "asyncio.Semaphore" when acquire is cancelled.

* gh-92986: Fix "ast.unparse()" when "ImportFrom.level" is None

* gh-91539: Improve performance of
  "urllib.request.getproxies_environment" when there are many
  environment variables


Documentación
-------------

* gh-97741: Fix "!" in c domain ref target syntax via a "conf.py"
  patch, so it works as intended to disable ref target resolution.

* gh-95588: Clarified the conflicting advice given in the "ast"
  documentation about "ast.literal_eval()" being "safe" for use on
  untrusted input while at the same time warning that it can crash the
  process. The latter statement is true and is deemed unfixable
  without a large amount of work unsuitable for a bugfix. So we keep
  the warning and no longer claim that "literal_eval" is safe.

* gh-93031: Update tutorial introduction output to use 3.10+
  SyntaxError invalid range.


Construir
---------

* gh-96729: Ensure that Windows releases built with
  "Tools\msi\buildrelease.bat" are upgradable to and from official
  Python releases.


Ventanas
--------

* gh-97728: Fix possible crashes caused by the use of uninitialized
  variables when pass invalid arguments in "os.system()" on Windows
  and in Windows-specific modules (like "winreg").

* gh-90989: Clarify some text in the Windows installer.

* gh-96577: Fixes a potential buffer overrun in "msilib".


Mac OS
------

* gh-97897: The macOS 13 SDK includes support for the "mkfifoat" and
  "mknodat" system calls. Using the "dir_fd" option with either
  "os.mkfifo()" or "os.mknod()" could result in a segfault if cpython
  is built with the macOS 13 SDK but run on an earlier version of
  macOS. Prevent this by adding runtime support for detection of these
  system calls ("weaklinking") as is done for other newer syscalls on
  macOS.


Python 3.10.7 final
===================

*Release date: 2022-09-05*


Seguridad
---------

* gh-95778: Converting between "int" and "str" in bases other than 2
  (binary), 4, 8 (octal), 16 (hexadecimal), or 32 such as base 10
  (decimal) now raises a "ValueError" if the number of digits in
  string form is above a limit to avoid potential denial of service
  attacks due to the algorithmic complexity. This is a mitigation for
  CVE-2020-10735.

  This new limit can be configured or disabled by environment
  variable, command line flag, or "sys" APIs. See the integer string
  conversion length limitation documentation.  The default limit is
  4300 digits in string form.

  Patch by Gregory P. Smith [Google] and Christian Heimes [Red Hat]
  with feedback from Victor Stinner, Thomas Wouters, Steve Dower, Ned
  Deily, and Mark Dickinson.


Núcleo y elementos integrados
-----------------------------

* gh-96187: Fixed a bug that caused "_PyCode_GetExtra" to return
  garbage for negative indexes. Patch by Pablo Galindo

* gh-95876: Fix format string in "_PyPegen_raise_error_known_location"
  that can lead to memory corruption on some 64bit systems. The
  function was building a tuple with "i" (int) instead of "n"
  (Py_ssize_t) for Py_ssize_t arguments.

* gh-95605: Fix misleading contents of error message when converting
  an all-whitespace string to "float".

* gh-93592: "coroutine.throw()" now properly initializes the
  "frame.f_back" when resuming a stack of coroutines. This allows e.g.
  "traceback.print_stack()" to work correctly when an exception (such
  as "CancelledError") is thrown into a coroutine.

* gh-94996: "ast.parse()" will no longer parse function definitions
  with positional-only params when passed "feature_version" less than
  "(3, 8)". Patch by Shantanu Jain.


Biblioteca
----------

* gh-68163: Correct conversion of "numbers.Rational"'s to "float".

* gh-96159: Fix a performance regression in logging
  TimedRotatingFileHandler. Only check for special files when the
  rollover time has passed.

* gh-96175: Fix unused "localName" parameter in the "Attr" class in
  "xml.dom.minidom".

* gh-95609: Update bundled pip to 22.2.2.

* gh-95231: Fail gracefully if "EPERM" or "ENOSYS" is raised when
  loading "crypt" methods. This may happen when trying to load "MD5"
  on a Linux kernel with FIPS (Federal Information Processing
  Standard) enabled.


Documentación
-------------

* gh-96098: Improve discoverability of the higher level
  concurrent.futures module by providing clearer links from the lower
  level threading and multiprocessing modules.

* gh-95789: Update the default RFC base URL from deprecated
  tools.ietf.org to datatracker.ietf.org

* gh-91207: Fix stylesheet not working in Windows CHM htmlhelp docs.
  Contributed by C.A.M. Gerlach.

* bpo-47115: The documentation now lists which members of C structs
  are part of the Limited API/Stable ABI.


Pruebas
-------

* gh-95243: Mitigate the inherent race condition from using
  find_unused_port() in testSockName() by trying to find an unused
  port a few times before failing. Patch by Ross Burton.


Construir
---------

* gh-94682: Build and test with OpenSSL 1.1.1q


INACTIVO
--------

* gh-65802: Document handling of extensions in Save As dialogs.

* gh-95191: Include prompts when saving Shell (interactive input and
  output).


Python 3.10.6 final
===================

*Release date: 2022-08-01*


Seguridad
---------

* gh-87389: "http.server": Fix an open redirection vulnerability in
  the HTTP server when an URI path starts with "//".  Vulnerability
  discovered, and initial fix proposed, by Hamza Avvan.

* gh-92888: Fix "memoryview" use after free when accessing the backing
  buffer in certain cases.


Núcleo y elementos integrados
-----------------------------

* gh-95355: "_PyPegen_Parser_New" now properly detects token memory
  allocation errors. Patch by Honglin Zhu.

* gh-94938: Fix error detection in some builtin functions when keyword
  argument name is an instance of a str subclass with overloaded
  "__eq__" and "__hash__". Previously it could cause SystemError or
  other undesired behavior.

* gh-94949: "ast.parse()" will no longer parse parenthesized context
  managers when passed "feature_version" less than "(3, 9)". Patch by
  Shantanu Jain.

* gh-94947: "ast.parse()" will no longer parse assignment expressions
  when passed "feature_version" less than "(3, 8)". Patch by Shantanu
  Jain.

* gh-94869: Fix the column offsets for some expressions in multi-line
  f-strings "ast" nodes. Patch by Pablo Galindo.

* gh-91153: Fix an issue where a "bytearray" item assignment could
  crash if it's resized by the new value's "__index__()" method.

* gh-94329: Compile and run code with unpacking of extremely large
  sequences (1000s of elements). Such code failed to compile. It now
  compiles and runs correctly.

* gh-94360: Fixed a tokenizer crash when reading encoded files with
  syntax errors from "stdin" with non utf-8 encoded text. Patch by
  Pablo Galindo

* gh-94192: Fix error for dictionary literals with invalid expression
  as value.

* gh-93964: Strengthened compiler overflow checks to prevent crashes
  when compiling very large source files.

* gh-93671: Fix some exponential backtrace case happening with deeply
  nested sequence patterns in match statements. Patch by Pablo Galindo

* gh-93021: Fix the "__text_signature__" for "__get__()" methods
  implemented in C. Patch by Jelle Zijlstra.

* gh-92930: Fixed a crash in "_pickle.c" from mutating collections
  during "__reduce__" or "persistent_id".

* gh-92914: Always round the allocated size for lists up to the
  nearest even number.

* gh-92858: Improve error message for some suites with syntax error
  before ':'


Biblioteca
----------

* gh-95339: Update bundled pip to 22.2.1.

* gh-95045: Fix GC crash when deallocating "_lsprof.Profiler" by
  untracking it before calling any callbacks. Patch by Kumar Aditya.

* gh-95087: Fix IndexError in parsing invalid date in the "email"
  module.

* gh-95199: Upgrade bundled setuptools to 63.2.0.

* gh-95194: Upgrade bundled pip to 22.2.

* gh-93899: Fix check for existence of "os.EFD_CLOEXEC",
  "os.EFD_NONBLOCK" and "os.EFD_SEMAPHORE" flags on older kernel
  versions where these flags are not present. Patch by Kumar Aditya.

* gh-95166: Fix "concurrent.futures.Executor.map()" to cancel the
  currently waiting on future on an error - e.g. TimeoutError or
  KeyboardInterrupt.

* gh-93157: Fix "fileinput" module didn't support "errors" option when
  "inplace" is true.

* gh-94821: Fix binding of unix socket to empty address on Linux to
  use an available address from the abstract namespace, instead of
  "0".

* gh-94736: Fix crash when deallocating an instance of a subclass of
  "_multiprocessing.SemLock". Patch by Kumar Aditya.

* gh-94637: "SSLContext.set_default_verify_paths()" now releases the
  GIL around "SSL_CTX_set_default_verify_paths" call. The function
  call performs I/O and CPU intensive work.

* gh-94510: Re-entrant calls to "sys.setprofile()" and
  "sys.settrace()" now raise "RuntimeError". Patch by Pablo Galindo.

* gh-92336: Fix bug where "linecache.getline()" fails on bad files
  with "UnicodeDecodeError" or "SyntaxError". It now returns an empty
  string as per the documentation.

* gh-89988: Fix memory leak in "pickle.Pickler" when looking up
  "dispatch_table". Patch by Kumar Aditya.

* gh-94254: Fixed types of "struct" module to be immutable. Patch by
  Kumar Aditya.

* gh-94245: Fix pickling and copying of "typing.Tuple[()]".

* gh-94207: Made "_struct.Struct" GC-tracked in order to fix a
  reference leak in the "_struct" module.

* gh-94101: Manual instantiation of "ssl.SSLSession" objects is no
  longer allowed as it lead to misconfigured instances that crashed
  the interpreter when attributes where accessed on them.

* gh-84753: "inspect.iscoroutinefunction()",
  "inspect.isgeneratorfunction()", and "inspect.isasyncgenfunction()"
  now properly return "True" for duck-typed function-like objects like
  instances of "unittest.mock.AsyncMock".

  This makes "inspect.iscoroutinefunction()" consistent with the
  behavior of "asyncio.iscoroutinefunction()".  Patch by Mehdi
  ABAAKOUK.

* gh-83499: Fix double closing of file description in "tempfile".

* gh-79512: Fixed names and "__module__" value of "weakref" classes
  "ReferenceType", "ProxyType", "CallableProxyType". It makes them
  pickleable.

* gh-90494: "copy.copy()" and "copy.deepcopy()" now always raise a
  TypeError if "__reduce__()" returns a tuple with length 6 instead of
  silently ignore the 6th item or produce incorrect result.

* gh-90549: Fix a multiprocessing bug where a global named resource
  (such as a semaphore) could leak when a child process is spawned (as
  opposed to forked).

* gh-79579: "sqlite3" now correctly detects DML queries with leading
  comments. Patch by Erlend E. Aasland.

* gh-93421: Update "sqlite3.Cursor.rowcount" when a DML statement has
  run to completion. This fixes the row count for SQL queries like
  "UPDATE ... RETURNING". Patch by Erlend E. Aasland.

* gh-91810: Suppress writing an XML declaration in open files in
  "ElementTree.write()" with "encoding='unicode'" and
  "xml_declaration=None".

* gh-93353: Fix the "importlib.resources.as_file()" context manager to
  remove the temporary file if destroyed late during Python
  finalization: keep a local reference to the "os.remove()" function.
  Patch by Victor Stinner.

* gh-83658: Make "multiprocessing.Pool" raise an exception if
  "maxtasksperchild" is not "None" or a positive int.

* gh-74696: "shutil.make_archive()" no longer temporarily changes the
  current working directory during creation of standard ".zip" or tar
  archives.

* gh-91577: Move imports in "SharedMemory" methods to module level so
  that they can be executed late in python finalization.

* bpo-47231: Fixed an issue with inconsistent trailing slashes in
  tarfile longname directories.

* bpo-46755: In "QueueHandler", clear "stack_info" from "LogRecord" to
  prevent stack trace from being written twice.

* bpo-46053: Fix OSS audio support on NetBSD.

* bpo-46197: Fix "ensurepip" environment isolation for subprocess
  running "pip".

* bpo-45924: Fix "asyncio" incorrect traceback when future's exception
  is raised multiple times. Patch by Kumar Aditya.

* bpo-34828: "sqlite3.Connection.iterdump()" now handles databases
  that use "AUTOINCREMENT" in one or more tables.


Documentación
-------------

* gh-94321: Document the **PEP 246** style protocol type
  "sqlite3.PrepareProtocol".

* gh-86128: Document a limitation in ThreadPoolExecutor where its exit
  handler is executed before any handlers in atexit.

* gh-61162: Clarify "sqlite3" behavior when How to use the connection
  context manager.

* gh-87260: Align "sqlite3" argument specs with the actual
  implementation.

* gh-86986: The minimum Sphinx version required to build the
  documentation is now 3.2.

* gh-88831: Augmented documentation of asyncio.create_task().
  Clarified the need to keep strong references to tasks and added a
  code snippet detailing how to do this.

* bpo-47161: Document that "pathlib.PurePath" does not collapse
  initial double slashes because they denote UNC paths.


Pruebas
-------

* gh-95280: Fix problem with "test_ssl" "test_get_ciphers" on systems
  that require perfect forward secrecy (PFS) ciphers.

* gh-95212: Make multiprocessing test case
  "test_shared_memory_recreate" parallel-safe.

* gh-91330: Added more tests for "dataclasses" to cover behavior with
  data descriptor-based fields.

* gh-94208: "test_ssl" is now checking for supported TLS version and
  protocols in more tests.

* gh-93951: In test_bdb.StateTestCase.test_skip, avoid including
  auxiliary importers.

* gh-93957: Provide nicer error reporting from subprocesses in
  test_venv.EnsurePipTest.test_with_pip.

* gh-57539: Increase calendar test coverage for
  "calendar.LocaleTextCalendar.formatweekday()".

* gh-92886: Fixing tests that fail when running with optimizations
  ("-O") in "test_zipimport.py"

* bpo-47016: Create a GitHub Actions workflow for verifying bundled
  pip and setuptools. Patch by Illia Volochii and Adam Turner.


Construir
---------

* gh-94841: Fix the possible performance regression of
  "PyObject_Free()" compiled with MSVC version 1932.

* bpo-45816: Python now supports building with Visual Studio 2022
  (MSVC v143, VS Version 17.0). Patch by Jeremiah Vivian.


Ventanas
--------

* gh-90844: Allow virtual environments to correctly launch when they
  have spaces in the path.

* gh-92841: "asyncio" no longer throws "RuntimeError: Event loop is
  closed" on interpreter exit after asynchronous socket activity.
  Patch by Oleg Iarygin.

* bpo-42658: Support native Windows case-insensitive path comparisons
  by using "LCMapStringEx" instead of "str.lower()" in
  "ntpath.normcase()". Add "LCMapStringEx" to the "_winapi" module.


INACTIVO
--------

* gh-95511: Fix the Shell context menu copy-with-prompts bug of
  copying an extra line when one selects whole lines.

* gh-95471: In the Edit menu, move "Select All" and add a new
  separator.

* gh-95411: Enable using IDLE's module browser with .pyw files.

* gh-89610: Add .pyi as a recognized extension for IDLE on macOS. This
  allows opening stub files by double clicking on them in the Finder.


Herramientas / Demos
--------------------

* gh-94538: Fix Argument Clinic output to custom file destinations.
  Patch by Erlend E. Aasland.

* gh-94430: Allow parameters named "module" and "self" with custom C
  names in Argument Clinic. Patch by Erlend E. Aasland


API C
-----

* gh-94930: Fix "SystemError" raised when
  "PyArg_ParseTupleAndKeywords()" is used with "#" in "(...)" but
  without "PY_SSIZE_T_CLEAN" defined.

* gh-94864: Fix "PyArg_Parse*" with deprecated format units "u" and
  "Z". It returned 1 (success) when warnings are turned into
  exceptions.


Python 3.10.5 final
===================

*Release date: 2022-06-06*


Núcleo y elementos integrados
-----------------------------

* gh-93418: Fixed an assert where an f-string has an equal sign '='
  following an expression, but there's no trailing brace. For example,
  f"{i=".

* gh-91924: Fix "__ltrace__" debug feature if the stdout encoding is
  not UTF-8. Patch by Victor Stinner.

* gh-93061: Backward jumps after "async for" loops are no longer given
  dubious line numbers.

* gh-93065: Fix contextvars HAMT implementation to handle iteration
  over deep trees.

  The bug was discovered and fixed by Eli Libman. See
  MagicStack/immutables#84 for more details.

* gh-92311: Fixed a bug where setting "frame.f_lineno" to jump over a
  list comprehension could misbehave or crash.

* gh-92112: Fix crash triggered by an evil custom "mro()" on a
  metaclass.

* gh-92036: Fix a crash in subinterpreters related to the garbage
  collector. When a subinterpreter is deleted, untrack all objects
  tracked by its GC. To prevent a crash in deallocator functions
  expecting objects to be tracked by the GC, leak a strong reference
  to these objects on purpose, so they are never deleted and their
  deallocator functions are not called. Patch by Victor Stinner.

* gh-91421: Fix a potential integer overflow in _Py_DecodeUTF8Ex.

* bpo-47212: Raise "IndentationError" instead of "SyntaxError" for a
  bare "except" with no following indent. Improve "SyntaxError"
  locations for an un-parenthesized generator used as arguments. Patch
  by Matthieu Dartiailh.

* bpo-47182: Fix a crash when using a named unicode character like
  ""\N{digit nine}"" after the main interpreter has been initialized a
  second time.

* bpo-46775: Some Windows system error codes(>= 10000) are now mapped
  into the correct errno and may now raise a subclass of "OSError".
  Patch by Dong-hee Na.

* bpo-47117: Fix a crash if we fail to decode characters in
  interactive mode if the tokenizer buffers are uninitialized. Patch
  by Pablo Galindo.

* bpo-39829: Removed the "__len__()" call when initializing a list and
  moved initializing to "list_extend". Patch by Jeremiah Pascual.

* bpo-46962: Classes and functions that unconditionally declared their
  docstrings ignoring the "--without-doc-strings" compilation flag no
  longer do so.

  The classes affected are "ctypes.UnionType", "pickle.PickleBuffer",
  "testcapi.RecursingInfinitelyError", and "types.GenericAlias".

  The functions affected are 24 methods in "ctypes".

  Patch by Oleg Iarygin.

* bpo-36819: Fix crashes in built-in encoders with error handlers that
  return position less or equal than the starting position of non-
  encodable characters.


Biblioteca
----------

* gh-93156: Accessing the "pathlib.PurePath.parents" sequence of an
  absolute path using negative index values produced incorrect
  results.

* gh-89973: Fix "re.error" raised in "fnmatch" if the pattern contains
  a character range with upper bound lower than lower bound (e.g.
  "[c-a]"). Now such ranges are interpreted as empty ranges.

* gh-93010: In a very special case, the email package tried to append
  the nonexistent "InvalidHeaderError" to the defect list. It should
  have been "InvalidHeaderDefect".

* gh-92839: Fixed crash resulting from calling bisect.insort() or
  bisect.insort_left() with the key argument not equal to None.

* gh-91581: "utcfromtimestamp()" no longer attempts to resolve "fold"
  in the pure Python implementation, since the fold is never 1 in UTC.
  In addition to being slightly faster in the common case, this also
  prevents some errors when the timestamp is close to "datetime.min".
  Patch by Paul Ganssle.

* gh-92530: Fix an issue that occurred after interrupting
  "threading.Condition.notify()".

* gh-92049: Forbid pickling constants "re._constants.SUCCESS" etc.
  Previously, pickling did not fail, but the result could not be
  unpickled.

* bpo-47029: Always close the read end of the pipe used by
  "multiprocessing.Queue" *after* the last write of buffered data to
  the write end of the pipe to avoid "BrokenPipeError" at garbage
  collection and at "multiprocessing.Queue.close()" calls. Patch by
  Géry Ogam.

* gh-91401: Provide a fail-safe way to disable "subprocess" use of
  "vfork()" via a private "subprocess._USE_VFORK" attribute. While
  there is currently no known need for this, if you find a need please
  only set it to "False". File a CPython issue as to why you needed it
  and link to that from a comment in your code. This attribute is
  documented as a footnote in 3.11.

* gh-91910: Add missing f prefix to f-strings in error messages from
  the "multiprocessing" and "asyncio" modules.

* gh-91810: "ElementTree" method "write()" and function "tostring()"
  now use the text file's encoding ("UTF-8" if not available) instead
  of locale encoding in XML declaration when "encoding="unicode"" is
  specified.

* gh-91832: Add "required" attribute to "argparse.Action" repr output.

* gh-91734: Fix OSS audio support on Solaris.

* gh-91700: Compilation of regular expression containing a conditional
  expression "(?(group)...)" now raises an appropriate "re.error" if
  the group number refers to not defined group. Previously an internal
  RuntimeError was raised.

* gh-91676: Fix "unittest.IsolatedAsyncioTestCase" to shutdown the per
  test event loop executor before returning from its "run" method so
  that a not yet stopped or garbage collected executor state does not
  persist beyond the test.

* gh-90568: Parsing "\N" escapes of Unicode Named Character Sequences
  in a "regular expression" raises now "re.error" instead of
  "TypeError".

* gh-91595: Fix the comparison of character and integer inside
  "Tools.gdb.libpython.write_repr()". Patch by Yu Liu.

* gh-90622: Worker processes for
  "concurrent.futures.ProcessPoolExecutor" are no longer spawned on
  demand (a feature added in 3.9) when the multiprocessing context
  start method is ""fork"" as that can lead to deadlocks in the child
  processes due to a fork happening while threads are running.

* gh-91575: Update case-insensitive matching in the "re" module to the
  latest Unicode version.

* gh-91581: Remove an unhandled error case in the C implementation of
  calls to "datetime.fromtimestamp" with no time zone (i.e. getting a
  local time from an epoch timestamp). This should have no user-facing
  effect other than giving a possibly more accurate error message when
  called with timestamps that fall on 10000-01-01 in the local time.
  Patch by Paul Ganssle.

* bpo-47260: Fix "os.closerange()" potentially being a no-op in a
  Linux seccomp sandbox.

* bpo-39064: "zipfile.ZipFile" now raises "zipfile.BadZipFile" instead
  of "ValueError" when reading a corrupt zip file in which the central
  directory offset is negative.

* bpo-47151: When subprocess tries to use vfork, it now falls back to
  fork if vfork returns an error. This allows use in situations where
  vfork isn't allowed by the OS kernel.

* bpo-27929: Fix "asyncio.loop.sock_connect()" to only resolve names
  for "socket.AF_INET" or "socket.AF_INET6" families. Resolution may
  not make sense for other families, like "socket.AF_BLUETOOTH" and
  "socket.AF_UNIX".

* bpo-43323: Fix errors in the "email" module if the charset itself
  contains undecodable/unencodable characters.

* bpo-47101: "hashlib.algorithms_available" now lists only algorithms
  that are provided by activated crypto providers on OpenSSL 3.0.
  Legacy algorithms are not listed unless the legacy provider has been
  loaded into the default OSSL context.

* bpo-46787: Fix "concurrent.futures.ProcessPoolExecutor" exception
  memory leak

* bpo-45393: Fix the formatting for "await x" and "not x" in the
  operator precedence table when using the "help()" system.

* bpo-46415: Fix ipaddress.ip_{address,interface,network} raising
  TypeError instead of ValueError if given invalid tuple as address
  parameter.

* bpo-28249: Set "doctest.DocTest.lineno" to "None" when object does
  not have "__doc__".

* bpo-45138: Fix a regression in the "sqlite3" trace callback where
  bound parameters were not expanded in the passed statement string.
  The regression was introduced in Python 3.10 by bpo-40318. Patch by
  Erlend E. Aasland.

* bpo-44493: Add missing terminated NUL in sockaddr_un's length

  This was potentially observable when using non-abstract AF_UNIX
  datagram sockets to processes written in another programming
  language.

* bpo-42627: Fix incorrect parsing of Windows registry proxy settings

* bpo-36073: Raise "ProgrammingError" instead of segfaulting on
  recursive usage of cursors in "sqlite3" converters. Patch by Sergey
  Fedoseev.


Documentación
-------------

* gh-86438: Clarify that "-W" and "PYTHONWARNINGS" are matched
  literally and case-insensitively, rather than as regular
  expressions, in "warnings".

* gh-92240: Added release dates for "What's New in Python 3.X" for
  3.0, 3.1, 3.2, 3.8 and 3.10

* gh-91888: Add a new "gh" role to the documentation to link to GitHub
  issues.

* gh-91783: Document security issues concerning the use of the
  function "shutil.unpack_archive()"

* gh-91547: Remove "Undocumented modules" page.

* bpo-44347: Clarify the meaning of *dirs_exist_ok*, a kwarg of
  "shutil.copytree()".

* bpo-38668: Update the introduction to documentation for "os.path" to
  remove warnings that became irrelevant after the implementations of
  **PEP 383** and **PEP 529**.

* bpo-47138: Pin Jinja to a version compatible with Sphinx version
  3.2.1.

* bpo-46962: All docstrings in code snippets are now wrapped into
  "PyDoc_STR()" to follow the guideline of PEP 7's Documentation
  Strings paragraph. Patch by Oleg Iarygin.

* bpo-26792: Improve the docstrings of "runpy.run_module()" and
  "runpy.run_path()". Original patch by Andrew Brezovsky.

* bpo-40838: Document that "inspect.getdoc()", "inspect.getmodule()",
  and "inspect.getsourcefile()" might return "None".

* bpo-45790: Adjust inaccurate phrasing in Definición de tipos de
  extensión: Tutorial about the "ob_base" field and the macros used to
  access its contents.

* bpo-42340: Document that in some circumstances "KeyboardInterrupt"
  may cause the code to enter an inconsistent state. Provided a sample
  workaround to avoid it if needed.

* bpo-41233: Link the errnos referenced in
  "Doc/library/exceptions.rst" to their respective section in
  "Doc/library/errno.rst", and vice versa. Previously this was only
  done for EINTR and InterruptedError. Patch by Yan "yyyyyyyan"
  Orestes.

* bpo-38056: Overhaul the Manejadores de errores documentation in
  "codecs".

* bpo-13553: Document tkinter.Tk args.


Pruebas
-------

* gh-92886: Fixing tests that fail when running with optimizations
  ("-O") in "test_imaplib.py".

* gh-92670: Skip "test_shutil.TestCopy.test_copyfile_nonexistent_dir"
  test on AIX as the test uses a trailing slash to force the OS
  consider the path as a directory, but on AIX the trailing slash has
  no effect and is considered as a file.

* gh-91904: Fix initialization of "PYTHONREGRTEST_UNICODE_GUARD" which
  prevented running regression tests on non-UTF-8 locale.

* gh-91607: Fix "test_concurrent_futures" to test the correct
  multiprocessing start method context in several cases where the test
  logic mixed this up.

* bpo-47205: Skip test for "sched_getaffinity()" and
  "sched_setaffinity()" error case on FreeBSD.

* bpo-47104: Rewrite "asyncio.to_thread()" tests to use
  "unittest.IsolatedAsyncioTestCase".

* bpo-29890: Add tests for "ipaddress.IPv4Interface" and
  "ipaddress.IPv6Interface" construction with tuple arguments.
  Original patch and tests by louisom.


Construir
---------

* bpo-47103: Windows "PGInstrument" builds now copy a required DLL
  into the output directory, making it easier to run the profile stage
  of a PGO build.


Ventanas
--------

* gh-92984: Explicitly disable incremental linking for non-Debug
  builds

* bpo-47194: Update "zlib" to v1.2.12 to resolve CVE-2018-25032.

* bpo-46785: Fix race condition between "os.stat()" and unlinking a
  file on Windows, by using errors codes returned by
  "FindFirstFileW()" when appropriate in "win32_xstat_impl".

* bpo-40859: Update Windows build to use xz-5.2.5


Herramientas / Demos
--------------------

* gh-91583: Fix regression in the code generated by Argument Clinic
  for functions with the "defining_class" parameter.


Python 3.10.4 final
===================

*Release date: 2022-03-23*


Núcleo y elementos integrados
-----------------------------

* bpo-46968: Check for the existence of the "sys/auxv.h" header in
  "faulthandler" to avoid compilation problems in systems where this
  header doesn't exist. Patch by Pablo Galindo


Biblioteca
----------

* bpo-23691: Protect the "re.finditer()" iterator from re-entering.

* bpo-42369: Fix thread safety of "zipfile._SharedFile.tell()" to
  avoid a "zipfile.BadZipFile: Bad CRC-32 for file" exception when
  reading a "ZipFile" from multiple threads.

* bpo-38256: Fix "binascii.crc32()" when it is compiled to use zlib'c
  crc32 to work properly on inputs 4+GiB in length instead of
  returning the wrong result. The workaround prior to this was to
  always feed the function data in increments smaller than 4GiB or to
  just call the zlib module function.

* bpo-39394: A warning about inline flags not at the start of the
  regular expression now contains the position of the flag.

* bpo-47061: Deprecate the various modules listed by **PEP 594**:

  aifc, asynchat, asyncore, audioop, cgi, cgitb, chunk, crypt, imghdr,
  msilib, nntplib, nis, ossaudiodev, pipes, smtpd, sndhdr, spwd,
  sunau, telnetlib, uu, xdrlib

* bpo-2604: Fix bug where doctests using globals would fail when run
  multiple times.

* bpo-45997: Fix "asyncio.Semaphore" re-aquiring FIFO order.

* bpo-47022: The "asynchat", "asyncore" and  "smtpd" modules have been
  deprecated since at least Python 3.6. Their documentation and
  deprecation warnings and have now been updated to note they will
  removed in Python 3.12 (**PEP 594**).

* bpo-46421: Fix a unittest issue where if the command was invoked as
  "python -m unittest" and the filename(s) began with a dot (.), a
  "ValueError" is returned.

* bpo-40296: Fix supporting generic aliases in "pydoc".


Python 3.10.3 final
===================

*Release date: 2022-03-16*


Núcleo y elementos integrados
-----------------------------

* bpo-46940: Avoid overriding "AttributeError" metadata information
  for nested attribute access calls. Patch by Pablo Galindo.

* bpo-46852: Rename the private undocumented "float.__set_format__()"
  method to "float.__setformat__()" to fix a typo introduced in Python
  3.7. The method is only used by test_float. Patch by Victor Stinner.

* bpo-46794: Bump up the libexpat version into 2.4.6

* bpo-46820: Fix parsing a numeric literal immediately (without
  spaces) followed by "not in" keywords, like in "1not in x". Now the
  parser only emits a warning, not a syntax error.

* bpo-46762: Fix an assert failure in debug builds when a '<', '>', or
  '=' is the last character in an f-string that's missing a closing
  right brace.

* bpo-46724: Make sure that all backwards jumps use the
  "JUMP_ABSOLUTE" instruction, rather than "JUMP_FORWARD" with an
  argument of "(2**32)+offset".

* bpo-46732: Correct the docstring for the "__bool__()" method. Patch
  by Jelle Zijlstra.

* bpo-46707: Avoid potential exponential backtracking when producing
  some syntax errors involving lots of brackets. Patch by Pablo
  Galindo.

* bpo-40479: Add a missing call to "va_end()" in
  "Modules/_hashopenssl.c".

* bpo-46615: When iterating over sets internally in "setobject.c",
  acquire strong references to the resulting items from the set.  This
  prevents crashes in corner-cases of various set operations where the
  set gets mutated.

* bpo-45773: Remove two invalid "peephole" optimizations from the
  bytecode compiler.

* bpo-43721: Fix docstrings of "getter", "setter", and "deleter" to
  clarify that they create a new copy of the property.

* bpo-46503: Fix an assert when parsing some invalid N escape
  sequences in f-strings.

* bpo-46417: Fix a race condition on setting a type "__bases__"
  attribute: the internal function "add_subclass()" now gets the
  "PyTypeObject.tp_subclasses" member after calling
  "PyWeakref_NewRef()" which can trigger a garbage collection which
  can indirectly modify "PyTypeObject.tp_subclasses". Patch by Victor
  Stinner.

* bpo-46383: Fix invalid signature of "_zoneinfo"'s "module_free"
  function to resolve a crash on wasm32-emscripten platform.

* bpo-46070: "Py_EndInterpreter()" now explicitly untracks all objects
  currently tracked by the GC. Previously, if an object was used later
  by another interpreter, calling "PyObject_GC_UnTrack()" on the
  object crashed if the previous or the next object of the "PyGC_Head"
  structure became a dangling pointer. Patch by Victor Stinner.

* bpo-46339: Fix a crash in the parser when retrieving the error text
  for multi-line f-strings expressions that do not start in the first
  line of the string. Patch by Pablo Galindo

* bpo-46240: Correct the error message for unclosed parentheses when
  the tokenizer doesn't reach the end of the source when the error is
  reported. Patch by Pablo Galindo

* bpo-46091: Correctly calculate indentation levels for lines with
  whitespace character that are ended by line continuation characters.
  Patch by Pablo Galindo


Biblioteca
----------

* bpo-43253: Fix a crash when closing transports where the underlying
  socket handle is already invalid on the Proactor event loop.

* bpo-47004: Apply bugfixes from importlib_metadata 4.11.3, including
  bugfix for EntryPoint.extras, which was returning match objects and
  not the extras strings.

* bpo-46985: Upgrade pip wheel bundled with ensurepip (pip 22.0.4)

* bpo-46968: "faulthandler": On Linux 5.14 and newer, dynamically
  determine size of signal handler stack size CPython allocates using
  "getauxval(AT_MINSIGSTKSZ)". This changes allows for Python
  extension's request to Linux kernel to use AMX_TILE instruction set
  on Sapphire Rapids Xeon processor to succeed, unblocking use of the
  ISA in frameworks.

* bpo-46955: Expose "asyncio.base_events.Server" as "asyncio.Server".
  Patch by Stefan Zabka.

* bpo-23325: The "signal" module no longer assumes that "SIG_IGN" and
  "SIG_DFL" are small int singletons.

* bpo-46932: Update bundled libexpat to 2.4.7

* bpo-25707: Fixed a file leak in "xml.etree.ElementTree.iterparse()"
  when the iterator is not exhausted. Patch by Jacob Walls.

* bpo-44886: Inherit asyncio proactor datagram transport from
  "asyncio.DatagramTransport".

* bpo-46827: Support UDP sockets in  "asyncio.loop.sock_connect()" for
  selector-based event loops.  Patch by Thomas Grainger.

* bpo-46811: Make test suite support Expat >=2.4.5

* bpo-46252: Raise "TypeError" if "ssl.SSLSocket" is passed to
  transport-based APIs.

* bpo-46784: Fix libexpat symbols collisions with user dynamically
  loaded or statically linked libexpat in embedded Python.

* bpo-39327: "shutil.rmtree()" can now work with VirtualBox shared
  folders when running from the guest operating-system.

* bpo-46756: Fix a bug in
  "urllib.request.HTTPPasswordMgr.find_user_password()" and
  "urllib.request.HTTPPasswordMgrWithPriorAuth.is_authenticated()"
  which allowed to bypass authorization. For example, access to URI
  "example.org/foobar" was allowed if the user was authorized for URI
  "example.org/foo".

* bpo-46643: In "typing.get_type_hints()", support evaluating
  stringified "ParamSpecArgs" and "ParamSpecKwargs" annotations. Patch
  by Gregory Beauregard.

* bpo-45863: When the "tarfile" module creates a pax format archive,
  it will put an integer representation of timestamps in the ustar
  header (if possible) for the benefit of older unarchivers, in
  addition to the existing full-precision timestamps in the pax
  extended header.

* bpo-46676: Make "typing.ParamSpec" args and kwargs equal to
  themselves. Patch by Gregory Beauregard.

* bpo-46672: Fix "NameError" in "asyncio.gather()" when initial type
  check fails.

* bpo-46655: In "typing.get_type_hints()", support evaluating bare
  stringified "TypeAlias" annotations. Patch by Gregory Beauregard.

* bpo-45948: Fixed a discrepancy in the C implementation of the
  "xml.etree.ElementTree" module. Now, instantiating an
  "xml.etree.ElementTree.XMLParser" with a "target=None" keyword
  provides a default "xml.etree.ElementTree.TreeBuilder" target as the
  Python implementation does.

* bpo-46521: Fix a bug in the "codeop" module that was incorrectly
  identifying invalid code involving string quotes as valid code.

* bpo-46581: Brings "ParamSpec" propagation for "GenericAlias" in line
  with "Concatenate" (and others).

* bpo-46591: Make the IDLE doc URL on the About IDLE dialog clickable.

* bpo-46400: expat: Update libexpat from 2.4.1 to 2.4.4

* bpo-46487: Add the "get_write_buffer_limits" method to
  "asyncio.transports.WriteTransport" and to the SSL transport.

* bpo-45173: Note the configparser deprecations will be removed in
  Python 3.12.

* bpo-46539: In "typing.get_type_hints()", support evaluating
  stringified "ClassVar" and "Final" annotations inside "Annotated".
  Patch by Gregory Beauregard.

* bpo-46491: Allow "typing.Annotated" to wrap "typing.Final" and
  "typing.ClassVar". Patch by Gregory Beauregard.

* bpo-46436: Fix command-line option "-d"/"--directory" in module
  "http.server" which is ignored when combined with command-line
  option "--cgi". Patch by Géry Ogam.

* bpo-41403: Make "mock.patch()" raise a "TypeError" with a relevant
  error message on invalid arg. Previously it allowed a cryptic
  "AttributeError" to escape.

* bpo-46474: In "importlib.metadata.EntryPoint.pattern", avoid
  potential REDoS by limiting ambiguity in consecutive whitespace.

* bpo-46469: "asyncio" generic classes now return "types.GenericAlias"
  in "__class_getitem__" instead of the same class.

* bpo-46434: "pdb" now gracefully handles "help" when "__doc__" is
  missing, for example when run with pregenerated optimized ".pyc"
  files.

* bpo-46333: The "__eq__()" and "__hash__()" methods of
  "typing.ForwardRef" now honor the "module" parameter of
  "typing.ForwardRef". Forward references from different modules are
  now differentiated.

* bpo-46246: Add missing "__slots__" to
  "importlib.metadata.DeprecatedList". Patch by Arie Bovenberg.

* bpo-46266: Improve day constants in "calendar".

  Now all constants ("MONDAY" ... "SUNDAY") are documented, tested,
  and added to "__all__".

* bpo-46232: The "ssl" module now handles certificates with bit
  strings in DN correctly.

* bpo-43118: Fix a bug in "inspect.signature()" that was causing it to
  fail on some subclasses of classes with a "__text_signature__"
  referencing module globals. Patch by Weipeng Hong.

* bpo-26552: Fixed case where failing "asyncio.ensure_future()" did
  not close the coroutine. Patch by Kumar Aditya.

* bpo-21987: Fix an issue with "tarfile.TarFile.getmember()" getting a
  directory name with a trailing slash.

* bpo-20392: Fix inconsistency with uppercase file extensions in
  "MimeTypes.guess_type()". Patch by Kumar Aditya.

* bpo-46080: Fix exception in argparse help text generation if a
  "argparse.BooleanOptionalAction" argument's default is
  "argparse.SUPPRESS" and it has "help" specified.  Patch by Felix
  Fontein.

* bpo-44439: Fix ".write()" method of a member file in "ZipFile", when
  the input data is an object that supports the buffer protocol, the
  file length may be wrong.

* bpo-45703: When a namespace package is imported before another
  module from the same namespace is created/installed in a different
  "sys.path" location while the program is running, calling the
  "importlib.invalidate_caches()" function will now also guarantee the
  new module is noticed.

* bpo-24959: Fix bug where "unittest" sometimes drops frames from
  tracebacks of exceptions raised in tests.

* bpo-44791: Fix substitution of "ParamSpec" in "Concatenate" with
  different parameter expressions. Substitution with a list of types
  returns now a tuple of types. Substitution with "Concatenate"
  returns now a "Concatenate" with concatenated lists of arguments.

* bpo-14156: argparse.FileType now supports an argument of '-' in
  binary mode, returning the .buffer attribute of sys.stdin/sys.stdout
  as appropriate. Modes including 'x' and 'a' are treated equivalently
  to 'w' when argument is '-'. Patch contributed by Josh Rosenberg


Documentación
-------------

* bpo-46463: Fixes "escape4chm.py" script used when building the CHM
  documentation file


Pruebas
-------

* bpo-46913: Fix test_faulthandler.test_sigfpe() if Python is built
  with undefined behavior sanitizer (UBSAN): disable UBSAN on the
  faulthandler_sigfpe() function. Patch by Victor Stinner.

* bpo-46708: Prevent default asyncio event loop policy modification
  warning after "test_asyncio" execution.

* bpo-46678: The function "make_legacy_pyc" in
  "Lib/test/support/import_helper.py" no longer fails when
  "PYTHONPYCACHEPREFIX" is set to a directory on a different device
  from where tempfiles are stored.

* bpo-46616: Ensures "test_importlib.test_windows" cleans up registry
  keys after completion.

* bpo-44359: test_ftplib now silently ignores socket errors to prevent
  logging unhandled threading exceptions. Patch by Victor Stinner.

* bpo-46542: Fix a Python crash in test_lib2to3 when using Python
  built in debug mode: limit the recursion limit. Patch by Victor
  Stinner.

* bpo-46576: test_peg_generator now disables compiler optimization
  when testing compilation of its own C extensions to significantly
  speed up the testing on non-debug builds of CPython.

* bpo-46542: Fix "test_json" tests checking for "RecursionError":
  modify these tests to use "support.infinite_recursion()". Patch by
  Victor Stinner.

* bpo-13886: Skip test_builtin PTY tests on non-ASCII characters if
  the readline module is loaded. The readline module changes input()
  behavior, but test_builtin is not intented to test the readline
  module. Patch by Victor Stinner.


Construir
---------

* bpo-47032: Ensure Windows install builds fail correctly with a non-
  zero exit code when part of the build fails.

* bpo-47024: Update OpenSSL to 1.1.1n for macOS installers and all
  Windows builds.

* bpo-38472: Fix GCC detection in setup.py when cross-compiling. The C
  compiler is now run with LC_ALL=C. Previously, the detection failed
  with a German locale.

* bpo-46513: **configure** no longer uses "AC_C_CHAR_UNSIGNED" macro
  and "pyconfig.h" no longer defines reserved symbol
  "__CHAR_UNSIGNED__".

* bpo-45925: Update Windows installer to use SQLite 3.37.2.


Ventanas
--------

* bpo-44549: Update bzip2 to 1.0.8 in Windows builds to mitigate
  CVE-2016-3189 and CVE-2019-12900

* bpo-46948: Prevent CVE-2022-26488 by ensuring the Add to PATH option
  in the Windows installer uses the correct path when being repaired.

* bpo-46638: Ensures registry virtualization is consistently disabled.
  For 3.10 and earlier, it remains enabled (some registry writes are
  protected), while for 3.11 and later it is disabled (registry
  modifications affect all applications).


Mac OS
------

* bpo-45925: Update macOS installer to SQLite 3.37.2.


INACTIVO
--------

* bpo-46630: Make query dialogs on Windows start with a cursor in the
  entry box.

* bpo-45296: Clarify close, quit, and exit in IDLE.  In the File menu,
  'Close' and 'Exit' are now 'Close Window' (the current one) and
  'Exit' is now 'Exit IDLE' (by closing all windows).  In Shell,
  'quit()' and 'exit()' mean 'close Shell'. If there are no other
  windows, this also exits IDLE.

* bpo-45447: Apply IDLE syntax highlighting to "pyi" files. Patch by
  Alex Waygood and Terry Jan Reedy.


API C
-----

* bpo-46433: The internal function _PyType_GetModuleByDef now
  correctly handles inheritance patterns involving static types.

* bpo-14916: Fixed bug in the tokenizer that prevented
  "PyRun_InteractiveOne" from parsing from the provided FD.


Python 3.10.2 final
===================

*Release date: 2022-01-13*


Núcleo y elementos integrados
-----------------------------

* bpo-46347: Fix memory leak in PyEval_EvalCodeEx.

* bpo-46289: ASDL declaration of "FormattedValue" has changed to
  reflect "conversion" field is not optional.

* bpo-46237: Fix the line number of tokenizer errors inside f-strings.
  Patch by Pablo Galindo.

* bpo-46006: Fix a regression when a type method like "__init__()" is
  modified in a subinterpreter. Fix a regression in
  "_PyUnicode_EqualToASCIIId()" and type "update_slot()". Revert the
  change which made the Unicode dictionary of interned strings
  compatible with subinterpreters: the internal interned dictionary is
  shared again by all interpreters. Patch by Victor Stinner.

* bpo-46085: Fix iterator cache mechanism of "OrderedDict".

* bpo-46110: Add a maximum recursion check to the PEG parser to avoid
  stack overflow. Patch by Pablo Galindo

* bpo-46054: Fix parser error when parsing non-utf8 characters in
  source files. Patch by Pablo Galindo.

* bpo-46042: Improve the location of the caret in "SyntaxError"
  exceptions emitted by the symbol table. Patch by Pablo Galindo.

* bpo-46025: Fix a crash in the "atexit" module involving functions
  that unregister themselves before raising exceptions. Patch by Pablo
  Galindo.

* bpo-46009: Restore behavior from 3.9 and earlier when sending non-
  None to newly started generator. In 3.9 this did not affect the
  state of the generator. In 3.10.0 and 3.10.1 "gen_func().send(0)" is
  equivalent to "gen_func().throw(TypeError(...)" which exhausts the
  generator. In 3.10.2 onward, the behavior has been reverted to that
  of 3.9.

* bpo-46000: Improve compatibility of the "curses" module with NetBSD
  curses.

* bpo-46004: Fix the "SyntaxError" location for errors involving for
  loops with invalid targets. Patch by Pablo Galindo

* bpo-42918: Fix bug where the built-in "compile()" function did not
  always raise a "SyntaxError" when passed multiple statements in
  'single' mode. Patch by Weipeng Hong.


Biblioteca
----------

* bpo-40479: Fix "hashlib" *usedforsecurity* option to work correctly
  with OpenSSL 3.0.0 in FIPS mode.

* bpo-46070: Fix possible segfault when importing the "asyncio" module
  from different sub-interpreters in parallel. Patch by Erlend E.
  Aasland.

* bpo-46278: Reflect "context" argument in
  "AbstractEventLoop.call_*()" methods. Loop implementations already
  support it.

* bpo-46239: Improve error message when importing
  "asyncio.windows_events" on non-Windows.

* bpo-20369: "concurrent.futures.wait()" no longer blocks forever when
  given duplicate Futures. Patch by Kumar Aditya.

* bpo-46105: Honor spec when generating requirement specs with urls
  and extras (importlib_metadata 4.8.3).

* bpo-26952: "argparse" raises "ValueError" with clear message when
  trying to render usage for an empty mutually-exclusive group.
  Previously it raised a cryptic "IndexError".

* bpo-27718: Fix help for the "signal" module. Some functions (e.g.
  "signal()" and "getsignal()") were omitted.

* bpo-46032: The "registry()" method of "functools.singledispatch()"
  functions checks now the first argument or the first parameter
  annotation and raises a TypeError if it is not supported. Previously
  unsupported "types" were ignored (e.g. "typing.List[int]") or caused
  an error at calling time (e.g. "list[int]").

* bpo-46018: Ensure that "math.expm1()" does not raise on underflow.

* bpo-45755: "typing" generic aliases now reveal the class attributes
  of the original generic class when passed to "dir()". This was the
  behavior up to Python 3.6, but was changed in 3.7-3.9.

* bpo-13236: "unittest.TextTestResult" and "unittest.TextTestRunner"
  flush now the output stream more often.

* bpo-42378: Fixes the issue with log file being overwritten when
  "logging.FileHandler" is used in "atexit" with *filemode* set to
  "'w'". Note this will cause the message in *atexit* not being logged
  if the log stream is already closed due to shutdown of logging.


Documentación
-------------

* bpo-46120: State that "|" is preferred for readability over "Union"
  in the "typing" docs.

* bpo-46040: Fix removal Python version for "@asyncio.coroutine", the
  correct value is 3.11.

* bpo-19737: Update the documentation for the "globals()" function.

* bpo-45840: Improve cross-references in the documentation for the
  data model.


Pruebas
-------

* bpo-46205: Fix hang in runtest_mp due to race condition

* bpo-46263: Fix test_capi on FreeBSD 14-dev: instruct jemalloc to not
  fill freed memory with junk byte.

* bpo-46150: Now "fakename" in
  "test_pathlib.PosixPathTest.test_expanduser" is checked to be non-
  existent.

* bpo-46129: Rewrite "asyncio.locks" tests with
  "unittest.IsolatedAsyncioTestCase" usage.

* bpo-46114: Fix test case for OpenSSL 3.0.1 version. OpenSSL 3.0 uses
  "0xMNN00PP0L".


Construir
---------

* bpo-46263: "configure" no longer sets "MULTIARCH" on FreeBSD
  platforms.

* bpo-46106: Updated OpenSSL to 1.1.1m in Windows builds, macOS
  installer builds, and CI. Patch by Kumar Aditya.


Mac OS
------

* bpo-40477: The Python Launcher app for macOS now properly launches
  scripts and, if necessary, the Terminal app when running on recent
  macOS releases.


API C
-----

* bpo-46236: Fix a bug in "PyFunction_GetAnnotations()" that caused it
  to return a "tuple" instead of a "dict".


Python 3.10.1 final
===================

*Release date: 2021-12-06*


Núcleo y elementos integrados
-----------------------------

* bpo-42268: Fail the configure step if the selected compiler doesn't
  support memory sanitizer. Patch by Pablo Galindo

* bpo-45727: Refine the custom syntax error that suggests that a comma
  may be missing to trigger only when the expressions are detected
  between parentheses or brackets. Patch by Pablo Galindo

* bpo-45614: Fix "traceback" display for exceptions with invalid
  module name.

* bpo-45848: Allow the parser to obtain error lines directly from
  encoded files. Patch by Pablo Galindo

* bpo-45826: Fixed a crash when calling ".with_traceback(None)" on
  "NameError". This occurs internally in
  "unittest.TestCase.assertRaises()".

* bpo-45822: Fixed a bug in the parser that was causing it to not
  respect **PEP 263** coding cookies when no flags are provided. Patch
  by Pablo Galindo

* bpo-45820: Fix a segfault when the parser fails without reading any
  input. Patch by Pablo Galindo

* bpo-42540: Fix crash when "os.fork()" is called with an active non-
  default memory allocator.

* bpo-45738: Fix computation of error location for invalid
  continuation characters in the parser. Patch by Pablo Galindo.

* bpo-45773: Fix a compiler hang when attempting to optimize certain
  jump patterns.

* bpo-45716: Improve the "SyntaxError" message when using "True",
  "None" or "False" as keywords in a function call. Patch by Pablo
  Galindo.

* bpo-45688: "sys.stdlib_module_names" now contains the macOS-specific
  module "_scproxy".

* bpo-30570: Fixed a crash in "issubclass()" from infinite recursion
  when searching pathological "__bases__" tuples.

* bpo-45521: Fix a bug in the obmalloc radix tree code.  On 64-bit
  machines, the bug causes the tree to hold 46-bits of virtual
  addresses, rather than the intended 48-bits.

* bpo-45494: Fix parser crash when reporting errors involving invalid
  continuation characters. Patch by Pablo Galindo.

* bpo-45408: Fix a crash in the parser when reporting tokenizer errors
  that occur at the same time unclosed parentheses are detected. Patch
  by Pablo Galindo.

* bpo-45385: Fix reference leak from descr_check. Patch by Dong-hee
  Na.

* bpo-45167: Fix deepcopying of "types.GenericAlias" objects.

* bpo-44219: Release the GIL while performing "isatty" system calls on
  arbitrary file descriptors. In particular, this affects
  "os.isatty()", "os.device_encoding()" and "io.TextIOWrapper". By
  extension, "io.open()" in text mode is also affected. This change
  solves a deadlock in "os.isatty()". Patch by Vincent Michel in
  bpo-44219.

* bpo-44959: Added fallback to extension modules with '.sl' suffix on
  HP-UX

* bpo-44050: Extensions that indicate they use global state (by
  setting "m_size" to -1) can again be used in multiple interpreters.
  This reverts to behavior of Python 3.8.

* bpo-45121: Fix issue where "Protocol.__init__" raises
  "RecursionError" when it's called directly or via "super()". Patch
  provided by Yurii Karabas.

* bpo-45083: When the interpreter renders an exception, its name now
  has a complete qualname. Previously only the class name was
  concatenated to the module name, which sometimes resulted in an
  incorrect full name being displayed.

  (This issue impacted only the C code exception rendering, the
  "traceback" module was using qualname already).

* bpo-45056: Compiler now removes trailing unused constants from
  co_consts.


Biblioteca
----------

* bpo-27946: Fix possible crash when getting an attribute of
  class:"xml.etree.ElementTree.Element" simultaneously with replacing
  the "attrib" dict.

* bpo-37658: Fix issue when on certain conditions "asyncio.wait_for()"
  may allow a coroutine to complete successfully, but fail to return
  the result, potentially causing memory leaks or other issues.

* bpo-44649: Handle dataclass(slots=True) with a field that has
  default a default value, but for which init=False.

* bpo-45803: Added missing kw_only parameter to
  dataclasses.make_dataclass().

* bpo-45831: "faulthandler" can now write ASCII-only strings (like
  filenames and function names) with a single write() syscall when
  dumping a traceback. It reduces the risk of getting an unreadable
  dump when two threads or two processes dump a traceback to the same
  file (like stderr) at the same time. Patch by Victor Stinner.

* bpo-41735: Fix thread lock in "zlib.Decompress.flush()" method
  before "PyObject_GetBuffer".

* bpo-45235: Reverted an argparse bugfix that caused regression in the
  handling of default arguments for subparsers.  This prevented leaf
  level arguments from taking precedence over root level arguments.

* bpo-45765: In importlib.metadata, fix distribution discovery for an
  empty path.

* bpo-45757: Fix bug where "dis" produced an incorrect oparg when
  "EXTENDED_ARG" is followed by an opcode that does not use its
  argument.

* bpo-45644: In-place JSON file formatting using "python3 -m json.tool
  infile infile" now works correctly, previously it left the file
  empty. Patch by Chris Wesseling.

* bpo-45679: Fix caching of multi-value "typing.Literal".
  "Literal[True, 2]" is no longer equal to "Literal[1, 2]".

* bpo-45664: Fix "types.resolve_bases()" and "types.new_class()" for
  "types.GenericAlias" instance as a base.

* bpo-45663: Fix "dataclasses.is_dataclass()" for dataclasses which
  are subclasses of "types.GenericAlias".

* bpo-45662: Fix the repr of "dataclasses.InitVar" with a type alias
  to the built-in class, e.g. "InitVar[list[int]]".

* bpo-45438: Fix typing.Signature string representation for generic
  builtin types.

* bpo-45574: Fix warning about "print_escape" being unused.

* bpo-45581: "sqlite3.connect()" now correctly raises "MemoryError" if
  the underlying SQLite API signals memory error. Patch by Erlend E.
  Aasland.

* bpo-45557: pprint.pprint() now handles underscore_numbers correctly.
  Previously it was always setting it to False.

* bpo-45515: Add references to "zoneinfo" in the "datetime"
  documentation, mostly replacing outdated references to
  "dateutil.tz". Change by Paul Ganssle.

* bpo-45475: Reverted optimization of iterating "gzip.GzipFile",
  "bz2.BZ2File", and "lzma.LZMAFile" (see bpo-43787) because it caused
  regression when user iterate them without having reference of them.
  Patch by Inada Naoki.

* bpo-45428: Fix a regression in py_compile when reading filenames
  from standard input.

* bpo-45467: Fix incremental decoder and stream reader in the "raw-
  unicode-escape" codec. Previously they failed if the escape sequence
  was split.

* bpo-45461: Fix incremental decoder and stream reader in the
  "unicode-escape" codec. Previously they failed if the escape
  sequence was split.

* bpo-45239: Fixed "email.utils.parsedate_tz()" crashing with
  "UnboundLocalError" on certain invalid input instead of returning
  "None". Patch by Ben Hoyt.

* bpo-45249: Fix the behaviour of "traceback.print_exc()" when
  displaying the caret when the "end_offset" in the exception is set
  to 0. Patch by Pablo Galindo

* bpo-45416: Fix use of "asyncio.Condition" with explicit
  "asyncio.Lock" objects, which was a regression due to removal of
  explicit loop arguments. Patch by Joongi Kim.

* bpo-45419: Correct interfaces on DegenerateFiles.Path.

* bpo-44904: Fix bug in the "doctest" module that caused it to fail if
  a docstring included an example with a "classmethod" "property".
  Patch by Alex Waygood.

* bpo-45406: Make "inspect.getmodule()" catch "FileNotFoundError"
  raised by :'func:"inspect.getabsfile", and return "None" to indicate
  that the module could not be determined.

* bpo-45262: Prevent use-after-free in asyncio. Make sure the cached
  running loop holder gets cleared on dealloc to prevent use-after-
  free in get_running_loop

* bpo-45386: Make "xmlrpc.client" more robust to C runtimes where the
  underlying C "strftime" function results in a "ValueError" when
  testing for year formatting options.

* bpo-45371: Fix clang rpath issue in "distutils". The UnixCCompiler
  now uses correct clang option to add a runtime library directory
  (rpath) to a shared library.

* bpo-20028: Improve error message of "csv.Dialect" when initializing.
  Patch by Vajrasky Kok and Dong-hee Na.

* bpo-45343: Update bundled pip to 21.2.4 and setuptools to 58.1.0

* bpo-45329: Fix freed memory access in "pyexpat.xmlparser" when
  building it with an installed expat library <= 2.2.0.

* bpo-41710: On Unix, if the "sem_clockwait()" function is available
  in the C library (glibc 2.30 and newer), the
  "threading.Lock.acquire()" method now uses the monotonic clock
  ("time.CLOCK_MONOTONIC") for the timeout, rather than using the
  system clock ("time.CLOCK_REALTIME"), to not be affected by system
  clock changes. Patch by Victor Stinner.

* bpo-45328: Fixed "http.client.HTTPConnection" to work properly in
  OSs that don't support the "TCP_NODELAY" socket option.

* bpo-1596321: Fix the "threading._shutdown()" function when the
  "threading" module was imported first from a thread different than
  the main thread: no longer log an error at Python exit.

* bpo-45274: Fix a race condition in the "Thread.join()" method of the
  "threading" module. If the function is interrupted by a signal and
  the signal handler raises an exception, make sure that the thread
  remains in a consistent state to prevent a deadlock. Patch by Victor
  Stinner.

* bpo-45238: Fix "unittest.IsolatedAsyncioTestCase.debug()": it runs
  now asynchronous methods and callbacks.

* bpo-36674: "unittest.TestCase.debug()" raises now a
  "unittest.SkipTest" if the class or the test method are decorated
  with the skipping decorator.

* bpo-45235: Fix an issue where argparse would not preserve values in
  a provided namespace when using a subparser with defaults.

* bpo-45183: Have zipimport.zipimporter.find_spec() not raise an
  exception when the underlying zip file has been deleted and the
  internal cache has been reset via invalidate_cache().

* bpo-45234: Fixed a regression in "copyfile()", "copy()", "copy2()"
  raising "FileNotFoundError" when source is a directory, which should
  raise "IsADirectoryError"

* bpo-45228: Fix stack buffer overflow in parsing J1939 network
  address.

* bpo-45192: Fix the "tempfile._infer_return_type" function so that
  the "dir" argument of the "tempfile" functions accepts an object
  implementing the "os.PathLike" protocol.

  Patch by Kyungmin Lee.

* bpo-42135: Fix typo: "importlib.find_loader" is really slated for
  removal in Python 3.12 not 3.10, like the others in PR 25169.

  Patch by Hugo van Kemenade.

* bpo-45160: When tracing a tkinter variable used by a ttk OptionMenu,
  callbacks are no longer made twice.

* bpo-35474: Calling "mimetypes.guess_all_extensions()" with
  "strict=False" no longer affects the result of the following call
  with "strict=True". Also, mutating the returned list no longer
  affects the global state.

* bpo-45166: "typing.get_type_hints()" now works with "Final" wrapped
  in "ForwardRef".

* bpo-20499: Improve the speed and accuracy of statistics.pvariance().

* bpo-24444: Fixed an error raised in "argparse" help display when
  help for an option is set to 1+ blank spaces or when *choices* arg
  is an empty container.

* bpo-45021: Fix a potential deadlock at shutdown of forked children
  when using "concurrent.futures" module

* bpo-39039: tarfile.open raises "ReadError" when a zlib error occurs
  during file extraction.

* bpo-44594: Fix an edge case of "ExitStack" and "AsyncExitStack"
  exception chaining.  They will now match "with" block behavior when
  "__context__" is explicitly set to "None" when the exception is in
  flight.

* bpo-44295: Ensure deprecation warning from
  "assertDictContainsSubset()" points at calling code - by Anthony
  Sottile.

* bpo-43498: Avoid a possible *"RuntimeError: dictionary changed size
  during iteration"* when adjusting the process count of
  "ProcessPoolExecutor".


Documentación
-------------

* bpo-45640: Properly marked-up grammar tokens in the documentation
  are now clickable and take you to the definition of a given piece of
  grammar. Patch by Arthur Milchior.

* bpo-45788: Link doc for sys.prefix to sysconfig doc on installation
  paths.

* bpo-45772: "socket.socket" documentation is corrected to a class
  from a function.

* bpo-45392: Update the docstring of the "type" built-in to remove a
  redundant line and to mention keyword arguments for the constructor.

* bpo-45726: Improve documentation for "functools.singledispatch()"
  and "functools.singledispatchmethod".

* bpo-45680: Amend the docs on "GenericAlias" objects to clarify that
  non-container classes can also implement "__class_getitem__". Patch
  contributed by Alex Waygood.

* bpo-45655: Add a new "relevant PEPs" section to the top of the
  documentation for the "typing" module. Patch by Alex Waygood.

* bpo-45604: Add "level" argument to "multiprocessing.log_to_stderr"
  function docs.

* bpo-45250: Update the documentation to note that CPython does not
  consistently require iterators to define "__iter__".

* bpo-45464: Mention in the documentation of Built-in Exceptions that
  inheriting from multiple exception types in a single subclass is not
  recommended due to possible memory layout incompatibility.

* bpo-45449: Add note about **PEP 585** in "collections.abc".

* bpo-45516: Add protocol description to the
  "importlib.abc.Traversable" documentation.

* bpo-20692: Add Programming FAQ entry explaining that int literal
  attribute access requires either a space after or parentheses around
  the literal.

* bpo-45216: Remove extra documentation listing methods in "difflib".
  It was rendering twice in pydoc and was outdated in some places.

* bpo-45024: "collections.abc" documentation has been expanded to
  explicitly cover how instance and subclass checks work, with
  additional doctest examples and an exhaustive list of ABCs which
  test membership purely by presence of the right *special method*s.
  Patch by Raymond Hettinger.

* bpo-25381: In the extending chapter of the extending doc, update a
  paragraph about the global variables containing exception
  information.

* bpo-43905: Expanded "astuple()" and "asdict()" docs, warning about
  deepcopy being applied and providing a workaround.


Pruebas
-------

* bpo-19460: Add new Test for
  "email.mime.nonmultipart.MIMENonMultipart".

* bpo-45835: Fix race condition in test_queue tests with multiple
  "feeder" threads.

* bpo-45678: Add tests for scenarios in which
  "functools.singledispatchmethod" is stacked on top of a method that
  has already been wrapped by two other decorators. Patch by Alex
  Waygood.

* bpo-45578: Add tests for "dis.distb()"

* bpo-45678: Add tests to ensure that "functools.singledispatchmethod"
  correctly wraps the attributes of the target function.

* bpo-45577: Add subtests for all "pickle" protocols in
  "test_zoneinfo".

* bpo-45566: Fix "test_frozen_pickle" in "test_dataclasses" to check
  all "pickle" versions.

* bpo-43592: "test.libregrtest" now raises the soft resource limit for
  the maximum number of file descriptors when the default is too low
  for our test suite as was often the case on macOS.

* bpo-39679: Add more test cases for "@functools.singledispatchmethod"
  when combined with "@classmethod" or "@staticmethod".

* bpo-45400: Fix
  test_name_error_suggestions_do_not_trigger_for_too_many_locals() of
  test_exceptions if a directory name contains "a1" (like
  "Python-3.11.0a1"): use a stricter regular expression. Patch by
  Victor Stinner.

* bpo-40173: Fix "test.support.import_helper.import_fresh_module()".

* bpo-45280: Add a test case for empty "typing.NamedTuple".

* bpo-45269: Cover case when invalid "markers" type is supplied to
  "c_make_encoder".

* bpo-45128: Fix "test_multiprocessing_fork" failure due to
  "test_logging" and "sys.modules" manipulation.

* bpo-45209: Fix "UserWarning: resource_tracker" warning in "_test_mu
  ltiprocessing._TestSharedMemory.test_shared_memory_cleaned_after_pr
  ocess_termination"

* bpo-45195: Fix test_readline.test_nonascii(): sometimes, the newline
  character is not written at the end, so don't expect it in the
  output. Patch by Victor Stinner.

* bpo-45156: Fixes infinite loop on "unittest.mock.seal()" of mocks
  created by "create_autospec()".

* bpo-45125: Improves pickling tests and docs of "SharedMemory" and
  "SharableList" objects.

* bpo-44860: Update "test_sysconfig.test_user_similar()" for the
  posix_user scheme: "platlib" doesn't use "sys.platlibdir". Patch by
  Victor Stinner.

* bpo-25130: Add calls of "gc.collect()" in tests to support PyPy.


Construir
---------

* bpo-44035: CI now verifies that autoconf files have been regenerated
  with a current and unpatched autoconf package.

* bpo-33393: Update "config.guess" to 2021-06-03 and "config.sub" to
  2021-08-14. "Makefile" now has an "update-config" target to make
  updating more convenient.

* bpo-45866: "make regen-all" now produces the same output when run
  from a directory other than the source tree: when building Python
  out of the source tree. pegen now strips directory of the "generated
  by pygen from <FILENAME>" header Patch by Victor Stinner.

* bpo-41498: Python now compiles on platforms without "sigset_t".
  Several functions in "signal" are not available when "sigset_t" is
  missing.

  Based on patch by Roman Yurchak for pyodide.

* bpo-45881: "setup.py" now uses "CC" from environment first to
  discover multiarch and cross compile paths.

* bpo-43158: "setup.py" now uses values from configure script to build
  the "_uuid" extension module. Configure now detects util-linux's
  "libuuid", too.

* bpo-45571: "Modules/Setup" now use "PY_CFLAGS_NODIST" instead of
  "PY_CFLAGS" to compile shared modules.

* bpo-45561: Run smelly.py tool from $(srcdir).

* bpo-45532: Update "sys.version" to use "main" as fallback
  information. Patch by Jeong YunWon.

* bpo-45536: The "configure" script now checks whether OpenSSL headers
  and libraries provide required APIs. Most common APIs are verified.
  The check detects outdated or missing OpenSSL. Failures do not stop
  configure.

* bpo-45221: Fixed regression in handling of "LDFLAGS" and "CPPFLAGS"
  options where "argparse.parse_known_args()" could interpret an
  option as one of the built-in command line argument, for example
  "-h" for help.

* bpo-45405: Prevent "internal configure error" when running
  "configure" with recent versions of non-Apple clang.  Patch by David
  Bohman.

* bpo-45220: Avoid building with the Windows 11 SDK previews
  automatically. This may be overridden by setting the
  "DefaultWindowsSDKVersion" environment variable before building.

* bpo-45067: The ncurses function extended_color_content was
  introduced in 2017

  (https://invisible-island.net/ncurses/NEWS.html#index-t20170401).
  The

  ncurses-devel package in CentOS 7 had a older version ncurses
  resulted in compilation error.  For compiling ncurses with extended
  color support, we verify the version of the ncurses library >=
  20170401.


Ventanas
--------

* bpo-45901: When installed through the Microsoft Store and set as the
  default app for "*.py" files, command line arguments will now be
  passed to Python when invoking a script without explicitly launching
  Python (that is, "script.py args" rather than "python script.py
  args").

* bpo-45616: Fix Python Launcher's ability to distinguish between
  versions 3.1 and 3.10 when either one is explicitly requested.
  Previously, 3.1 would be used if 3.10 was requested but not
  installed, and 3.10 would be used if 3.1 was requested but 3.10 was
  installed.

* bpo-45732: Updates bundled Tcl/Tk to 8.6.12.

* bpo-45720: Internal reference to "shlwapi.dll" was dropped to help
  improve startup time. This DLL will no longer be loaded at the start
  of every Python process.

* bpo-43652: Update Tcl/Tk to 8.6.11, actually this time. The previous
  update incorrectly included 8.6.10.

* bpo-45337: venv now warns when the created environment may need to
  be accessed at a different path, due to redirections, links or
  junctions. It also now correctly installs or upgrades components
  when the alternate path is required.


Mac OS
------

* bpo-45732: Update python.org macOS installer to use Tcl/Tk 8.6.12.

* bpo-44828: Avoid tkinter file dialog failure on macOS 12 Monterey
  when using the Tk 8.6.11 provided by python.org macOS installers.
  Patch by Marc Culler of the Tk project.

* bpo-34602: When building CPython on macOS with "./configure --with-
  undefined-behavior-sanitizer --with-pydebug", the stack size is now
  quadrupled to allow for the entire test suite to pass.


INACTIVO
--------

* bpo-45495: Add context keywords 'case' and 'match' to completions
  list.

* bpo-45296: On Windows, change exit/quit message to suggest Ctrl-D,
  which works, instead of <Ctrl-Z Return>, which does not work in
  IDLE.

* bpo-45193: Make completion boxes appear on Ubuntu again.


Herramientas / Demos
--------------------

* bpo-44786: Fix a warning in regular expression in the c-analyzer
  script.


API C
-----

* bpo-39026: Fix Python.h to build C extensions with Xcode: remove a
  relative include from "Include/cpython/pystate.h".

* bpo-45307: Restore the private C API function
  "_PyImport_FindExtensionObject()". It will be removed in Python
  3.11.

* bpo-44687: "BufferedReader.peek()" no longer raises "ValueError"
  when the entire file has already been buffered.

* bpo-44751: Remove "crypt.h" include from the public "Python.h"
  header.


Python 3.10.0 final
===================

*Release date: 2021-10-04*


Núcleo y elementos integrados
-----------------------------

* bpo-45121: Fix issue where "Protocol.__init__" raises
  "RecursionError" when it's called directly or via "super()". Patch
  provided by Yurii Karabas.


Biblioteca
----------

* bpo-45234: Fixed a regression in "copyfile()", "copy()", "copy2()"
  raising "FileNotFoundError" when source is a directory, which should
  raise "IsADirectoryError"


Documentación
-------------

* bpo-45216: Remove extra documentation listing methods in "difflib".
  It was rendering twice in pydoc and was outdated in some places.

* bpo-45024: "collections.abc" documentation has been expanded to
  explicitly cover how instance and subclass checks work, with
  additional doctest examples and an exhaustive list of ABCs which
  test membership purely by presence of the right *special method*s.
  Patch by Raymond Hettinger.


Pruebas
-------

* bpo-45128: Fix "test_multiprocessing_fork" failure due to
  "test_logging" and "sys.modules" manipulation.

* bpo-44860: Update "test_sysconfig.test_user_similar()" for the
  posix_user scheme: "platlib" doesn't use "sys.platlibdir". Patch by
  Victor Stinner.


Construir
---------

* bpo-45067: The ncurses function extended_color_content was
  introduced in 2017

  (https://invisible-island.net/ncurses/NEWS.html#index-t20170401).
  The

  ncurses-devel package in CentOS 7 had a older version ncurses
  resulted in compilation error.  For compiling ncurses with extended
  color support, we verify the version of the ncurses library >=
  20170401.


INACTIVO
--------

* bpo-45193: Make completion boxes appear on Ubuntu again.


API C
-----

* bpo-45307: Restore the private C API function
  "_PyImport_FindExtensionObject()". It will be removed in Python
  3.11.


Python 3.10.0 release candidate 2
=================================

*Release date: 2021-09-07*


Seguridad
---------

* bpo-42278: Replaced usage of "tempfile.mktemp()" with
  "TemporaryDirectory" to avoid a potential race condition.

* bpo-44394: Update the vendored copy of libexpat to 2.4.1 (from
  2.2.8) to get the fix for the CVE-2013-0340 "Billion Laughs"
  vulnerability. This copy is most used on Windows and macOS.

* bpo-43124: Made the internal "putcmd" function in "smtplib" sanitize
  input for presence of "\r" and "\n" characters to avoid (unlikely)
  command injection.


Núcleo y elementos integrados
-----------------------------

* bpo-45123: Fix PyAiter_Check to only check for the __anext__
  presence (not for __aiter__). Rename PyAiter_Check to PyAIter_Check,
  PyObject_GetAiter -> PyObject_GetAIter.

* bpo-45018: Fixed pickling of range iterators that iterated for over
  2**32 times.

* bpo-45000: A "SyntaxError" is now raised when trying to delete
  "__debug__". Patch by Dong-hee Na.

* bpo-44963: Implement "send()" and "throw()" methods for
  "anext_awaitable" objects. Patch by Pablo Galindo.

* bpo-44962: Fix a race in WeakKeyDictionary, WeakValueDictionary and
  WeakSet when two threads attempt to commit the last pending removal.
  This fixes asyncio.create_task and fixes a data loss in asyncio.run
  where shutdown_asyncgens is not run

* bpo-44954: Fixed a corner case bug where the result of
  "float.fromhex('0x.8p-1074')" was rounded the wrong way.

* bpo-44947: Refine the syntax error for trailing commas in import
  statements. Patch by Pablo Galindo.

* bpo-44698: Restore behaviour of complex exponentiation with integer-
  valued exponent of type "float" or "complex".

* bpo-44885: Correct the ast locations of f-strings with format specs
  and repeated expressions. Patch by Pablo Galindo

* bpo-44872: Use new trashcan macros (Py_TRASHCAN_BEGIN/END) in
  frameobject.c instead of the old ones (Py_TRASHCAN_SAFE_BEGIN/END).

* bpo-33930: Fix segmentation fault with deep recursion when cleaning
  method objects. Patch by Augusto Goulart and Pablo Galindo.

* bpo-25782: Fix bug where "PyErr_SetObject" hangs when the current
  exception has a cycle in its context chain.

* bpo-44856: Fix reference leaks in the error paths of
  "update_bases()" and "__build_class__". Patch by Pablo Galindo.

* bpo-44838: Fixed a bug that was causing the parser to raise an
  incorrect custom "SyntaxError" for invalid 'if' expressions. Patch
  by Pablo Galindo.

* bpo-44584: The threading debug ("PYTHONTHREADDEBUG" environment
  variable) is deprecated in Python 3.10 and will be removed in Python
  3.12. This feature requires a debug build of Python. Patch by Victor
  Stinner.

* bpo-39091: Fix crash when using passing a non-exception to a
  generator's "throw()" method. Patch by Noah Oxer


Biblioteca
----------

* bpo-45081: Fix issue when dataclasses that inherit from
  "typing.Protocol" subclasses have wrong "__init__". Patch provided
  by Yurii Karabas.

* bpo-41620: "run()" now always return a "TestResult" instance.
  Previously it returned "None" if the test class or method was
  decorated with a skipping decorator.

* bpo-43913: Fix bugs in cleaning up classes and modules in
  "unittest":

  * Functions registered with "addModuleCleanup()" were not called
    unless the user defines "tearDownModule()" in their test module.

  * Functions registered with "addClassCleanup()" were not called if
    "tearDownClass" is set to "None".

  * Buffering in "TestResult" did not work with functions registered
    with "addClassCleanup()" and "addModuleCleanup()".

  * Errors in functions registered with "addClassCleanup()" and
    "addModuleCleanup()" were not handled correctly in buffered and
    debug modes.

  * Errors in "setUpModule()" and functions registered with
    "addModuleCleanup()" were reported in wrong order.

  * And several lesser bugs.

* bpo-45030: Fix integer overflow in pickling and copying the range
  iterator.

* bpo-45001: Made email date parsing more robust against malformed
  input, namely a whitespace-only "Date:" header. Patch by Wouter
  Bolsterlee.

* bpo-44449: Fix a crash in the signal handler of the "faulthandler"
  module: no longer modify the reference count of frame objects. Patch
  by Victor Stinner.

* bpo-44955: Method "stopTestRun()" is now always called in pair with
  method "startTestRun()" for "TestResult" objects implicitly created
  in "run()". Previously it was not called for test methods and
  classes decorated with a skipping decorator.

* bpo-44935: "subprocess" on Solaris now also uses "os.posix_spawn()"
  for better performance.

* bpo-44911: "IsolatedAsyncioTestCase" will no longer throw an
  exception while cancelling leaked tasks. Patch by Bar Harel.

* bpo-44524: Make exception message more useful when subclass from
  typing special form alias. Patch provided by Yurii Karabas.

* bpo-38956: "argparse.BooleanOptionalAction"'s default value is no
  longer printed twice when used with
  "argparse.ArgumentDefaultsHelpFormatter".

* bpo-44860: Fix the "posix_user" scheme in "sysconfig" to not depend
  on "sys.platlibdir".

* bpo-44581: Upgrade bundled pip to 21.2.3 and setuptools to 57.4.0

* bpo-44849: Fix the "os.set_inheritable()" function on FreeBSD 14 for
  file descriptor opened with the "O_PATH" flag: ignore the "EBADF"
  error on "ioctl()", fallback on the "fcntl()" implementation. Patch
  by Victor Stinner.

* bpo-44605: The @functools.total_ordering() decorator now works with
  metaclasses.

* bpo-44524: Fixed an issue wherein the "__name__" and "__qualname__"
  attributes of subscribed specialforms could be "None".

* bpo-44822: "sqlite3" user-defined functions and aggregators
  returning "strings" with embedded NUL characters are no longer
  truncated. Patch by Erlend E. Aasland.

* bpo-44801: Ensure that the "ParamSpec" variable in Callable can only
  be substituted with a parameters expression (a list of types, an
  ellipsis, ParamSpec or Concatenate).

* bpo-27334: The "sqlite3" context manager now performs a rollback
  (thus releasing the database lock) if commit failed.  Patch by Luca
  Citi and Erlend E. Aasland.

* bpo-41402: Fix "email.message.EmailMessage.set_content()" when
  called with binary data and "7bit" content transfer encoding.

* bpo-32695: The *compresslevel* and *preset* keyword arguments of
  "tarfile.open()" are now both documented and tested.

* bpo-34990: Fixed a Y2k38 bug in the compileall module where it would
  fail to compile files with a modification time after the year 2038.

* bpo-38840: Fix "test___all__" on platforms lacking a shared memory
  implementation.

* bpo-26228: pty.spawn no longer hangs on FreeBSD, macOS, and Solaris.

* bpo-33349: lib2to3 now recognizes async generators everywhere.


Documentación
-------------

* bpo-44957: Promote PEP 604 union syntax by using it where possible.
  Also, mention "X | Y" more prominently in section about "Union" and
  mention "X | None" at all in section about "Optional".

* bpo-44903: Removed the othergui.rst file, any references to it, and
  the list of GUI frameworks in the FAQ. In their place I've added
  links to the Python Wiki "page on GUI frameworks".

* bpo-33479: Tkinter documentation has been greatly expanded with new
  "Architecture" and "Threading model" sections.

* bpo-36700: "base64" RFC references were updated to point to **RFC
  4648**; a section was added to point users to the new "security
  considerations" section of the RFC.

* bpo-44756: Reverted automated virtual environment creation on "make
  html" when building documentation. It turned out to be disruptive
  for downstream distributors.

* bpo-42958: Updated the docstring and docs of "filecmp.cmp()" to be
  more accurate and less confusing especially in respect to *shallow*
  arg.

* bpo-43066: Added a warning to "zipfile" docs: filename arg with a
  leading slash may cause archive to be un-openable on Windows
  systems.

* bpo-39452: Rewrote "Doc/library/__main__.rst". Broadened scope of
  the document to explicitly discuss and differentiate between
  "__main__.py" in packages versus the "__name__ == '__main__'"
  expression (and the idioms that surround it).

* bpo-27752: Documentation of csv.Dialect is more descriptive.

* bpo-41576: document BaseException in favor of bare except

* bpo-39498: Add a "Security Considerations" index which links to
  standard library modules that have explicitly documented security
  considerations.

* bpo-33479: Remove the unqualified claim that tkinter is threadsafe.
  It has not been true for several years and likely never was. An
  explanation of what is true may be added later, after more
  discussion, and possibly after patching _tkinter.c,


Pruebas
-------

* bpo-45052: "WithProcessesTestSharedMemory.test_shared_memory_basics"
  test was ignored, because "self.assertEqual(sms.size, sms2.size)"
  line was failing. It is now removed and test is unskipped.

  The main motivation for this line to be removed from the test is
  that the "size" of "SharedMemory" is not ever guaranteed to be the
  same. It is decided by the platform.

* bpo-45042: Fixes that test classes decorated with
  "@hashlib_helper.requires_hashdigest" were skipped all the time.

* bpo-45011: Made tests relying on the "_asyncio" C extension module
  optional to allow running on alternative Python implementations.
  Patch by Serhiy Storchaka.

* bpo-44949: Fix auto history tests of test_readline: sometimes, the
  newline character is not written at the end, so don't expect it in
  the output.

* bpo-44891: Tests were added to clarify "id()" is preserved when "obj
  * 1" is used on "str" and "bytes" objects. Patch by Nikita Sobolev.

* bpo-44852: Add ability to wholesale silence DeprecationWarnings
  while running the regression test suite.

* bpo-40928: Notify users running test_decimal regression tests on
  macOS of potential harmless "malloc can't allocate region" messages
  spewed by test_decimal.


Ventanas
--------

* bpo-45007: Update to OpenSSL 1.1.1l in Windows build


Mac OS
------

* bpo-45007: Update macOS installer builds to use OpenSSL 1.1.1l.

* bpo-44689: "ctypes.util.find_library()" now works correctly on macOS
  11 Big Sur even if Python is built on an older version of macOS.
  Previously, when built on older macOS systems, "find_library" was
  not able to find  macOS system libraries when running on Big Sur due
  to changes in  how system libraries are stored.


Python 3.10.0 release candidate 1
=================================

*Release date: 2021-08-02*


Seguridad
---------

* bpo-44600: Fix incorrect line numbers while tracing some failed
  patterns in match statements. Patch by Charles Burkland.


Núcleo y elementos integrados
-----------------------------

* bpo-44792: Improve syntax errors for if expressions. Patch by Miguel
  Brito

* bpo-34013: Generalize the invalid legacy statement custom error
  message (like the one generated when "print" is called without
  parentheses) to include more generic expressions. Patch by Pablo
  Galindo

* bpo-44732: Rename "types.Union" to "types.UnionType".

* bpo-44698: Fix undefined behaviour in complex object exponentiation.

* bpo-44653: Support "typing" types in parameter substitution in the
  union type.

* bpo-44676: Add ability to serialise "types.Union" objects. Patch
  provided by Yurii Karabas.

* bpo-44633: Parameter substitution of the union type with wrong types
  now raises "TypeError" instead of returning "NotImplemented".

* bpo-44662: Add "__module__" to "types.Union". This also fixes
  "types.Union" issues with "typing.Annotated". Patch provided by
  Yurii Karabas.

* bpo-44655: Include the name of the type in unset __slots__ attribute
  errors. Patch by Pablo Galindo

* bpo-44655: Don't include a missing attribute with the same name as
  the failing one when offering suggestions for missing attributes.
  Patch by Pablo Galindo

* bpo-44646: Fix the hash of the union type: it no longer depends on
  the order of arguments.

* bpo-44636: Collapse union of equal types. E.g. the result of "int |
  int" is now "int". Fix comparison of the union type with non-
  hashable objects. E.g. "int | str == {}" no longer raises a
  TypeError.

* bpo-44635: Convert "None" to "type(None)" in the union type
  constructor.

* bpo-44589: Mapping patterns in "match" statements with two or more
  equal literal keys will now raise a "SyntaxError" at compile-time.

* bpo-44606: Fix "__instancecheck__" and "__subclasscheck__" for the
  union type.

* bpo-42073: The "@classmethod" decorator can now wrap other
  classmethod-like descriptors.

* bpo-44490: "typing" now searches for type parameters in
  "types.Union" objects. "get_type_hints" will also properly resolve
  annotations with nested "types.Union" objects. Patch provided by
  Yurii Karabas.

* bpo-44490: Add "__parameters__" attribute and "__getitem__" operator
  to "types.Union". Patch provided by Yurii Karabas.

* bpo-44472: Fix ltrace functionality when exceptions are raised.
  Patch by Pablo Galindo


Biblioteca
----------

* bpo-44806: Non-protocol subclasses of "typing.Protocol" ignore now
  the "__init__" method inherited from protocol base classes.

* bpo-44793: Fix checking the number of arguments when subscribe a
  generic type with "ParamSpec" parameter.

* bpo-44784: In importlib.metadata tests, override warnings behavior
  under expected DeprecationWarnings (importlib_metadata 4.6.3).

* bpo-44667: The "tokenize.tokenize()" doesn't incorrectly generate a
  "NEWLINE" token if the source doesn't end with a new line character
  but the last line is a comment, as the function is already
  generating a "NL" token. Patch by Pablo Galindo

* bpo-44752: "rcompleter" does not call "getattr()" on "property"
  objects to avoid the side-effect of  evaluating the corresponding
  method.

* bpo-44720: "weakref.proxy" objects referencing non-iterators now
  raise "TypeError" rather than dereferencing the null "tp_iternext"
  slot and crashing.

* bpo-44704: The implementation of "collections.abc.Set._hash()" now
  matches that of "frozenset.__hash__()".

* bpo-44666: Fixed issue in "compileall.compile_file()" when
  "sys.stdout" is redirected. Patch by Stefan Hölzl.

* bpo-42854: Fixed a bug in the "_ssl" module that was throwing
  "OverflowError" when using "_ssl._SSLSocket.write()" and
  "_ssl._SSLSocket.read()" for a big value of the "len" parameter.
  Patch by Pablo Galindo

* bpo-44353: Refactor "typing.NewType" from function into callable
  class. Patch provided by Yurii Karabas.

* bpo-44524: Add missing "__name__" and "__qualname__" attributes to
  "typing" module classes. Patch provided by Yurii Karabas.

* bpo-40897: Give priority to using the current class constructor in
  "inspect.signature()". Patch by Weipeng Hong.

* bpo-44648: Fixed wrong error being thrown by "inspect.getsource()"
  when examining a class in the interactive session. Instead of
  "TypeError", it should be "OSError" with appropriate error message.

* bpo-44608: Fix memory leak in "_tkinter._flatten()" if it is called
  with a sequence or set, but not list or tuple.

* bpo-44559: [Enum] module reverted to 3.9; 3.10 changes pushed until
  3.11

* bpo-41928: Update "shutil.copyfile()" to raise "FileNotFoundError"
  instead of confusing "IsADirectoryError" when a path ending with a
  "os.path.sep" does not exist; "shutil.copy()" and "shutil.copy2()"
  are also affected.

* bpo-44566: handle StopIteration subclass raised from
  @contextlib.contextmanager generator

* bpo-41249: Fixes "TypedDict" to work with "typing.get_type_hints()"
  and postponed evaluation of annotations across modules.

* bpo-44461: Fix bug with "pdb"'s handling of import error due to a
  package which does not have a "__main__" module

* bpo-43625: Fix a bug in the detection of CSV file headers by
  "csv.Sniffer.has_header()" and improve documentation of same.

* bpo-42892: Fixed an exception thrown while parsing a malformed
  multipart email by "email.message.EmailMessage".

* bpo-27827: "pathlib.PureWindowsPath.is_reserved()" now identifies a
  greater range of reserved filenames, including those with trailing
  spaces or colons.

* bpo-38741: "configparser": using ']' inside a section header will no
  longer cut the section name short at the ']'

* bpo-27513: "email.utils.getaddresses()" now accepts
  "email.header.Header" objects along with string values. Patch by
  Zackery Spytz.

* bpo-29298: Fix "TypeError" when required subparsers without "dest"
  do not receive arguments. Patch by Anthony Sottile.


Documentación
-------------

* bpo-44740: Replaced occurences of uppercase "Web" and "Internet"
  with lowercase versions per the 2016 revised Associated Press Style
  Book.

* bpo-44693: Update the definition of __future__ in the glossary by
  replacing the confusing word "pseudo-module" with a more accurate
  description.

* bpo-35183: Add typical examples to os.path.splitext docs

* bpo-30511: Clarify that "shutil.make_archive()" is not thread-safe
  due to reliance on changing the current working directory.

* bpo-44561: Update of three expired hyperlinks in
  Doc/distributing/index.rst: "Project structure", "Building and
  packaging the project", and "Uploading the project to the Python
  Packaging Index".

* bpo-44613: importlib.metadata is no longer provisional.

* bpo-44544: List all kwargs for "textwrap.wrap()", "textwrap.fill()",
  and "textwrap.shorten()". Now, there are nav links to attributes of
  "TextWrap", which makes navigation much easier while minimizing
  duplication in the documentation.

* bpo-44453: Fix documentation for the return type of
  "sysconfig.get_path()".


Pruebas
-------

* bpo-44734: Fixed floating point precision issue in turtle tests.

* bpo-44708: Regression tests, when run with -w, are now re-running
  only the affected test methods instead of re-running the entire test
  file.

* bpo-44647: Added a permanent Unicode-valued environment variable to
  regression tests to ensure they handle this use case in the future.
  If your test environment breaks because of that, report a bug to us,
  and temporarily set PYTHONREGRTEST_UNICODE_GUARD=0 in your test
  environment.

* bpo-44515: Adjust recently added contextlib tests to avoid assuming
  the use of a refcounted GC


Ventanas
--------

* bpo-44572: Avoid consuming standard input in the "platform" module

* bpo-40263: This is a follow-on bug from
  https://bugs.python.org/issue26903. Once that is applied we run into
  an off-by-one assertion problem. The assert was not correct.


Mac OS
------

* bpo-41972: The framework build's user header path in sysconfig is
  changed to add a 'pythonX.Y' component to match distutils's
  behavior.

* bpo-34932: Add socket.TCP_KEEPALIVE support for macOS. Patch by
  Shane Harvey.


Herramientas / Demos
--------------------

* bpo-44756: In the Makefile for documentation ("Doc/Makefile"), the
  "build" rule is dependent on the "venv" rule. Therefore, "html",
  "latex", and other build-dependent rules are also now dependent on
  "venv". The "venv" rule only performs an action if "$(VENVDIR)" does
  not exist. "Doc/README.rst" was updated; most users now only need to
  type "make html".


API C
-----

* bpo-41103: Reverts removal of the old buffer protocol because they
  are part of stable ABI.

* bpo-42747: The "Py_TPFLAGS_HAVE_VERSION_TAG" type flag now does
  nothing. The "Py_TPFLAGS_HAVE_AM_SEND" flag (which was added in
  3.10) is removed. Both were unnecessary because it is not possible
  to have type objects with the relevant fields missing.


Python 3.10.0 beta 4
====================

*Release date: 2021-07-10*


Seguridad
---------

* bpo-41180: Add auditing events to the "marshal" module, and stop
  raising "code.__init__" events for every unmarshalled code object.
  Directly instantiated code objects will continue to raise an event,
  and audit event handlers should inspect or collect the raw marshal
  data. This reduces a significant performance overhead when loading
  from ".pyc" files.


Núcleo y elementos integrados
-----------------------------

* bpo-44562: Remove uses of "PyObject_GC_Del()" in error path when
  initializing "types.GenericAlias".

* bpo-41486: Fix a memory consumption and copying performance
  regression in earlier 3.10 beta releases if someone used an output
  buffer larger than 4GiB with zlib.decompress on input data that
  expands that large.

* bpo-44553: Implement GC methods for "types.Union" to break reference
  cycles and prevent memory leaks.

* bpo-44523: Remove the pass-through for "hash()" of "weakref.proxy"
  objects to prevent unintended consequences when the original
  referred object dies while the proxy is part of a hashable object.
  Patch by Pablo Galindo.

* bpo-44483: Fix a crash in "types.Union" objects when creating a
  union of an object with bad "__module__" field.

* bpo-44297: Make sure that the line number is set when entering a
  comprehension scope. Ensures that backtraces inclusing generator
  expressions show the correct line number.

* bpo-44456: Improve the syntax error when mixing positional and
  keyword patterns. Patch by Pablo Galindo.

* bpo-44368: Improve syntax errors for invalid "as" targets. Patch by
  Pablo Galindo

* bpo-44317: Improve tokenizer error with improved locations. Patch by
  Pablo Galindo.

* bpo-43667: Improve Unicode support in non-UTF locales on Oracle
  Solaris. This issue does not affect other Solaris systems.


Biblioteca
----------

* bpo-44558: Make the implementation consistency of "indexOf()"
  between C and Python versions. Patch by Dong-hee Na.

* bpo-34798: Break up paragraph about "pprint.PrettyPrinter"
  construction parameters to make it easier to read.

* bpo-44516: Update vendored pip to 21.1.3

* bpo-44468: "typing.get_type_hints()" now finds annotations in
  classes and base classes with unexpected "__module__". Previously,
  it skipped those MRO elements.

* bpo-43977: Set the proper "Py_TPFLAGS_MAPPING" and
  "Py_TPFLAGS_SEQUENCE" flags for subclasses created before a parent
  has been registered as a "collections.abc.Mapping" or
  "collections.abc.Sequence".

* bpo-44482: Fix very unlikely resource leak in "glob" in alternate
  Python implementations.

* bpo-44466: The "faulthandler" module now detects if a fatal error
  occurs during a garbage collector collection. Patch by Victor
  Stinner.

* bpo-44404: "tkinter"'s "after()" method now supports callables
  without the "__name__" attribute.

* bpo-44458: "BUFFER_BLOCK_SIZE" is now declared static, to avoid
  linking collisions when bz2, lmza or zlib are statically linked.

* bpo-44464: Remove exception for flake8 in deprecated
  importlib.metadata interfaces. Sync with importlib_metadata 4.6.

* bpo-44446: Take into account that "lineno" might be "None" in
  "traceback.FrameSummary".

* bpo-44439: Fix in "bz2.BZ2File.write()" / "lzma.LZMAFile.write()"
  methods, when the input data is an object that supports the buffer
  protocol, the file length may be wrong.

* bpo-44434: _thread.start_new_thread() no longer calls
  PyThread_exit_thread() explicitly at the thread exit, the call was
  redundant. On Linux with the glibc, pthread_exit() aborts the whole
  process if dlopen() fails to open libgcc_s.so file (ex: EMFILE
  error). Patch by Victor Stinner.

* bpo-44395: Fix "as_string()" to pass unixfrom properly. Patch by
  Dong-hee Na.

* bpo-34266: Handle exceptions from parsing the arg of "pdb"'s
  run/restart command.

* bpo-44077: It's now possible to receive the type of service (ToS),
  a.k.a. differentiated services (DS), a.k.a. differenciated services
  code point (DSCP) and excplicit congestion notification (ECN) IP
  header fields with "socket.IP_RECVTOS".

* bpo-43024: Improve the help signature of
  "traceback.print_exception()", "traceback.format_exception()" and
  "traceback.format_exception_only()".

* bpo-30256: Pass multiprocessing BaseProxy argument "manager_owned"
  through AutoProxy.


Documentación
-------------

* bpo-44558: Match the docstring and python implementation of
  "countOf()" to the behavior of its c implementation.

* bpo-38062: Clarify that atexit uses equality comparisons internally.

* bpo-40620: Convert examples in tutorial controlflow.rst section 4.3
  to be interpreter-demo style.

* bpo-13814: In the Design FAQ, answer "Why don't generators support
  the with statement?"

* bpo-41621: Document that "collections.defaultdict" parameter
  "default_factory" defaults to None and is positional-only.


Pruebas
-------

* bpo-44287: Fix asyncio test_popen() of test_windows_utils by using a
  longer timeout. Use military grade battle-tested
  "test.support.SHORT_TIMEOUT" timeout rather than a hardcoded timeout
  of 10 seconds: it's 30 seconds by default, but it is made longer on
  slow buildbots. Patch by Victor Stinner.

* bpo-44451: Reset "DeprecationWarning" filters in "test.test_importl
  ib.test_metadata_api.APITests.test_entry_points_by_index" to avoid
  "StopIteration" error if "DeprecationWarnings" are ignored.

* bpo-30256: Add test for nested queues when using "multiprocessing"
  shared objects "AutoProxy[Queue]" inside "ListProxy" and "DictProxy"


Construir
---------

* bpo-44535: Enable building using a Visual Studio 2022 install on
  Windows.

* bpo-43298: Improved error message when building without a Windows
  SDK installed.


Ventanas
--------

* bpo-44582: Accelerate speed of "mimetypes" initialization using a
  native implementation of the registry scan.

* bpo-41299: Fix 16ms jitter when using timeouts in "threading", such
  as with "threading.Lock.acquire()" or "threading.Condition.wait()".


API C
-----

* bpo-44441: "Py_RunMain()" now resets "PyImport_Inittab" to its
  initial value at exit. It must be possible to call
  "PyImport_AppendInittab()" or "PyImport_ExtendInittab()" at each
  Python initialization. Patch by Victor Stinner.

* bpo-40939: Removed documentation for the removed "PyParser_*" C API.


Python 3.10.0 beta 3
====================

*Release date: 2021-06-17*


Núcleo y elementos integrados
-----------------------------

* bpo-44409: Fix error location information for tokenizer errors
  raised on initialization of the tokenizer. Patch by Pablo Galindo.

* bpo-44396: Fix a possible crash in the tokenizer when raising syntax
  errors for unclosed strings. Patch by Pablo Galindo.

* bpo-44349: Fix an edge case when displaying text from files with
  encoding in syntax errors. Patch by Pablo Galindo.

* bpo-44335: Fix a regression when identifying incorrect characters in
  syntax errors. Patch by Pablo Galindo

* bpo-44304: Fix a crash in the "sqlite3" module that happened when
  the garbage collector clears "sqlite.Statement" objects. Patch by
  Pablo Galindo

* bpo-44305: Improve error message for "try" blocks without "except"
  or "finally" blocks. Patch by Pablo Galindo.

* bpo-43833: Emit a deprecation warning if the numeric literal is
  immediately followed by one of keywords: and, else, for, if, in, is,
  or. Raise a syntax error with more informative message if it is
  immediately followed by other keyword or identifier.

* bpo-11105: When compiling "ast.AST" objects with recursive
  references through "compile()", the interpreter doesn't crash
  anymore instead it raises a "RecursionError".


Biblioteca
----------

* bpo-42972: The _thread.RLock type now fully implement the GC
  protocol: add a traverse function and the "Py_TPFLAGS_HAVE_GC" flag.
  Patch by Victor Stinner.

* bpo-44422: The "threading.enumerate()" function now uses a reentrant
  lock to prevent a hang on reentrant call. Patch by Victor Stinner.

* bpo-44389: Fix deprecation of "ssl.OP_NO_TLSv1_3"

* bpo-44362: Improve "ssl" module's deprecation messages, error
  reporting, and documentation for deprecations.

* bpo-44342: [Enum] Change pickling from by-value to by-name.

* bpo-44356: [Enum] Allow multiple data-type mixins if they are all
  the same.

* bpo-44351: Restore back "parse_makefile()" in "distutils.sysconfig"
  because it behaves differently than the similar implementation in
  "sysconfig".

* bpo-44242: Remove missing flag check from Enum creation and move
  into a "verify" decorator.

* bpo-44246: In "importlib.metadata", restore compatibility in the
  result from "Distribution.entry_points" ("EntryPoints") to honor
  expectations in older implementations and issuing deprecation
  warnings for these cases: A. "EntryPoints" objects are once again
  mutable, allowing   for "sort()" and other list-based mutation
  operations.   Avoid deprecation warnings by casting to a   mutable
  sequence (e.g. "list(dist.entry_points).sort()"). B. "EntryPoints"
  results once again allow   for access by index. To avoid deprecation
  warnings,   cast the result to a Sequence first   (e.g.
  "tuple(dist.entry_points)[0]").

* bpo-44246: In importlib.metadata.entry_points, de-duplication of
  distributions no longer requires loading the full metadata for
  PathDistribution objects, improving entry point loading performance
  by ~10x.

* bpo-43853: Improved string handling for "sqlite3" user-defined
  functions and aggregates:

  * It is now possible to pass strings with embedded null characters
    to UDFs

  * Conversion failures now correctly raise "MemoryError"

  Patch by Erlend E. Aasland.

* bpo-43318: Fix a bug where "pdb" does not always echo cleared
  breakpoints.

* bpo-37022: "pdb" now displays exceptions from "repr()" with its "p"
  and "pp" commands.


Documentación
-------------

* bpo-44392: Added a new section in the C API documentation for types
  used in type hinting.  Documented "Py_GenericAlias" and
  "Py_GenericAliasType".

* bpo-38291: Mark "typing.io" and "typing.re" as deprecated since
  Python 3.8 in the documentation. They were never properly supported
  by type checkers.

* bpo-44322: Document that SyntaxError args have a details tuple and
  that details are adjusted for errors in f-string field replacement
  expressions.


Pruebas
-------

* bpo-44363: Account for address sanitizer in test_capi. test_capi now
  passes when run GCC address sanitizer.

* bpo-43921: Fix test_ssl.test_wrong_cert_tls13(): use
  "suppress_ragged_eofs=False", since "read()" can raise
  "ssl.SSLEOFError" on Windows. Patch by Victor Stinner.

* bpo-43921: Fix test_pha_required_nocert() of test_ssl: catch two
  more EOF cases (when the "recv()" method returns an empty string).
  Patch by Victor Stinner.


Construir
---------

* bpo-44381: The Windows build now accepts "EnableControlFlowGuard"
  set to "guard" to enable CFG.


INACTIVO
--------

* bpo-40128: Mostly fix completions on macOS when not using tcl/tk
  8.6.11 (as with 3.9). The added update_idletask call should be
  harmless and possibly helpful otherwise.

* bpo-33962: Move the indent space setting from the Font tab to the
  new Windows tab. Patch by Mark Roseman and Terry Jan Reedy.

* bpo-40468: Split the settings dialog General tab into Windows and
  Shell/ED tabs. Move help sources, which extend the Help menu, to the
  Extensions tab. Make space for new options and shorten the dialog.
  The latter makes the dialog better fit small screens.


API C
-----

* bpo-43795: The list in Contenido de la API limitada now shows the
  public name "PyFrameObject" rather than "_frame". The non-existing
  entry "_node" no longer appears in the list.

* bpo-44378: "Py_IS_TYPE()" no longer uses "Py_TYPE()" to avoid a
  compiler warning: no longer cast "const PyObject*" to "PyObject*".
  Patch by Victor Stinner.


Python 3.10.0 beta 2
====================

*Release date: 2021-05-31*


Seguridad
---------

* bpo-44022: mod:"http.client" now avoids infinitely reading potential
  HTTP headers after a "100 Continue" status response from the server.


Núcleo y elementos integrados
-----------------------------

* bpo-43667: Improve Unicode support in non-UTF locales on Oracle
  Solaris. This issue does not affect other Solaris systems.

* bpo-44232: Fix a regression in "type()" when a metaclass raises an
  exception. The C function "type_new()" must properly report the
  exception when a metaclass constructor raises an exception and the
  winner class is not the metaclass. Patch by Victor Stinner.

* bpo-44201: Avoid side effects of checking for specialized syntax
  errors in the REPL that was causing it to ask for extra tokens after
  a syntax error had been detected. Patch by Pablo Galindo

* bpo-44184: Fix a crash at Python exit when a deallocator function
  removes the last strong reference to a heap type. Patch by Victor
  Stinner.

* bpo-44180: The parser doesn't report generic syntax errors that
  happen in a position further away that the one it reached in the
  first pass. Patch by Pablo Galindo

* bpo-44168: Fix error message in the parser involving keyword
  arguments with invalid expressions. Patch by Pablo Galindo

* bpo-44143: Fixed a crash in the parser that manifest when raising
  tokenizer errors when an existing exception was present. Patch by
  Pablo Galindo.

* bpo-44114: Fix incorrect dictkeys_reversed and dictitems_reversed
  function signatures in C code, which broke webassembly builds.

* bpo-43149: Corrent the syntax error message regarding multiple
  exception types to not refer to "exception groups". Patch by Pablo
  Galindo

* bpo-44056: Syntax errors when default "except" is not the last
  "except"  are reported with the correct location. Patch by Mark
  Shannon.

* bpo-43822: The parser will prioritize tokenizer errors over custom
  syntax errors when raising exceptions. Patch by Pablo Galindo.

* bpo-28146: Fix a confusing error message in "str.format()".


Biblioteca
----------

* bpo-44254: On Mac, give turtledemo button text a color that works on
  both light or dark background.  Programmers cannot control the
  latter.

* bpo-38693: Prefer f-strings to ".format" in importlib.resources.

* bpo-33693: Importlib.metadata now prefers f-strings to .format.

* bpo-44241: Incorporate minor tweaks from importlib_metadata 4.1:
  SimplePath protocol, support for Metadata 2.2.

* bpo-44210: Make importlib.metadata._meta.PackageMetadata public.

* bpo-43643: Declare readers.MultiplexedPath.name as a property per
  the spec.

* bpo-33433: For IPv4 mapped IPv6 addresses (**RFC 4291** Section
  2.5.5.2), the "ipaddress.IPv6Address.is_private" check is deferred
  to the mapped IPv4 address. This solves a bug where public mapped
  IPv4 addresses were considered private by the IPv6 check.

* bpo-44145: "hmac" computations were not releasing the GIL while
  calling the OpenSSL "HMAC_Update" C API (a new feature in 3.9).
  This unintentionally prevented parallel computation as other
  "hashlib" algorithms support.

* bpo-37788: Fix a reference leak when a Thread object is never
  joined.

* bpo-38908: Subclasses of "typing.Protocol" which only have data
  variables declared will now raise a "TypeError" when checked with
  "isinstance" unless they are decorated with "runtime_checkable()".
  Previously, these checks passed silently. Patch provided by Yurii
  Karabas.

* bpo-44098: "typing.ParamSpec" will no longer be found in the
  "__parameters__" of most "typing" generics except in valid use
  locations specified by **PEP 612**. This prevents incorrect usage
  like "typing.List[P][int]". This change means incorrect usage which
  may have passed silently in 3.10 beta 1 and earlier will now error.

* bpo-44089: Allow subclassing "csv.Error" in 3.10 (it was allowed in
  3.9 and earlier but was disallowed in early versions of 3.10).

* bpo-44059: Register the SerenityOS Browser in the "webbrowser"
  module.

* bpo-36515: The "hashlib" module no longer does unaligned memory
  accesses when compiled for ARM platforms.

* bpo-44018: random.seed() no longer mutates bytearray inputs.

* bpo-38352: Add "IO", "BinaryIO", "TextIO", "Match", and "Pattern" to
  "typing.__all__". Patch by Jelle Zijlstra.

* bpo-43972: When "http.server.SimpleHTTPRequestHandler" sends a "301
  (Moved Permanently)" for a directory path not ending with "/", add a
  "Content-Length: 0" header. This improves the behavior for certain
  clients.

* bpo-28528: Fix a bug in "pdb" where "checkline()" raises
  "AttributeError" if it is called after "reset()".

* bpo-43650: Fix "MemoryError" in "shutil.unpack_archive()" which
  fails inside "shutil._unpack_zipfile()" on large files. Patch by
  Igor Bolshakov.

* bpo-41730: "DeprecationWarning" is now raised when importing
  "tkinter.tix", which has been deprecated in documentation since
  Python 3.6.


Documentación
-------------

* bpo-42392: Document the deprecation and removal of the "loop"
  parameter for many functions and classes in "asyncio".

* bpo-44195: Corrected references to "TraversableResources" in docs.
  There is no "TraversableReader".

* bpo-41963: Document that "ConfigParser" strips off comments when
  reading configuration files.

* bpo-44072: Correct where in the numeric ABC hierarchy "**" support
  is added, i.e., in numbers.Complex, not numbers.Integral.

* bpo-43558: Add the remark to "dataclasses" documentation that the
  "__init__()" of any base class has to be called in
  "__post_init__()", along with a code example.

* bpo-44025: Clarify when '_' in match statements is a keyword, and
  when not.


Pruebas
-------

* bpo-31904: Ignore error string case in test_py_compile
  "test_file_not_exists()".

* bpo-42083: Add test to check that "PyStructSequence_NewType" accepts
  a "PyStructSequence_Desc" with "doc" field set to "NULL".

* bpo-35753: Fix crash in doctest when doctest parses modules that
  include unwrappable functions by skipping those functions.


Construir
---------

* bpo-41282: Fix broken "make install" that caused standard library
  extension modules to be unnecessarily and incorrectly rebuilt during
  the install phase of cpython.


Ventanas
--------

* bpo-42686: Build "sqlite3" with math functions enabled. Patch by
  Erlend E. Aasland.


Mac OS
------

* bpo-43109: Allow --with-lto configure option to work with Apple-
  supplied Xcode or Command Line Tools.


INACTIVO
--------

* bpo-41611: Avoid uncaught exceptions in
  "AutoCompleteWindow.winconfig_event()".

* bpo-41611: Fix IDLE sometimes freezing upon tab-completion on macOS.

* bpo-44010: Highlight the new match statement's soft keywords:
  "match", "case", and "_". However, this highlighting is not perfect
  and will be incorrect in some rare cases, including some "_"-s in
  "case" patterns.

* bpo-44026: Include interpreter's typo fix suggestions in message
  line for NameErrors and AttributeErrors.  Patch by E. Paine.


Herramientas / Demos
--------------------

* bpo-44074: Make patchcheck automatically detect the correct base
  branch name (previously it was hardcoded to 'master')


API C
-----

* bpo-43795: The undocumented function "Py_FrozenMain()" is removed
  from the Limited API.

* bpo-43795: "PyCodec_Unregister()" is now properly exported as a
  function in the Windows Stable ABI DLL.


Python 3.10.0 beta 1
====================

*Release date: 2021-05-03*


Seguridad
---------

* bpo-43434: Creating "sqlite3.Connection" objects now also produces
  "sqlite3.connect" and "sqlite3.connect/handle" auditing events.
  Previously these events were only produced by "sqlite3.connect()"
  calls. Patch by Erlend E. Aasland.

* bpo-43998: The "ssl" module sets more secure cipher suites defaults.
  Ciphers without forward secrecy and with SHA-1 MAC are disabled by
  default. Security level 2 prohibits weak RSA, DH, and ECC keys with
  less than 112 bits of security. "SSLContext" defaults to minimum
  protocol version TLS 1.2. Settings are based on Hynek Schlawack's
  research.

* bpo-43882: The presence of newline or tab characters in parts of a
  URL could allow some forms of attacks.

  Following the controlling specification for URLs defined by WHATWG
  "urllib.parse()" now removes ASCII newlines and tabs from URLs,
  preventing such attacks.

* bpo-43472: Ensures interpreter-level audit hooks receive the
  "cpython.PyInterpreterState_New" event when called through the
  "_xxsubinterpreters" module.

* bpo-43362: Fix invalid free in _sha3 module. The issue was
  introduced in 3.10.0a1. Python 3.9 and earlier are not affected.

* bpo-43762: Add audit events for "sqlite3.connect/handle()",
  "sqlite3.Connection.enable_load_extension()", and
  "sqlite3.Connection.load_extension()". Patch by Erlend E. Aasland.

* bpo-43756: Add new audit event "glob.glob/2" to incorporate the new
  *root_dir* and *dir_fd* arguments added to "glob.glob()" and
  "glob.iglob()".

* bpo-36384: "ipaddress" module no longer accepts any leading zeros in
  IPv4 address strings. Leading zeros are ambiguous and interpreted as
  octal notation by some libraries. For example the legacy function
  "socket.inet_aton()" treats leading zeros as octal notatation. glibc
  implementation of modern "inet_pton()" does not accept any leading
  zeros. For a while the "ipaddress" module used to accept ambiguous
  leading zeros.

* bpo-43075: Fix Regular Expression Denial of Service (ReDoS)
  vulnerability in "urllib.request.AbstractBasicAuthHandler".  The
  ReDoS-vulnerable regex has quadratic worst-case complexity and it
  allows cause a denial of service when identifying crafted invalid
  RFCs. This ReDoS issue is on the client side and needs remote
  attackers to control the HTTP server.

* bpo-42800: Audit hooks are now fired for frame.f_code,
  traceback.tb_frame, and generator code/frame attribute access.

* bpo-37363: Add audit events to the "http.client" module.


Núcleo y elementos integrados
-----------------------------

* bpo-43977: Prevent classes being both a sequence and a mapping when
  pattern matching.

* bpo-43977: Use "tp_flags" on the class object to determine if the
  subject is a sequence or mapping when pattern matching. Avoids the
  need to import "collections.abc" when pattern matching.

* bpo-43892: Restore proper validation of complex literal value
  patterns when parsing "match" blocks.

* bpo-43933: Set frame.f_lineno to the line number of the 'with'
  kweyword when executing the call to "__exit__".

* bpo-43933: If the current position in a frame has no line number
  then set the f_lineno attribute to None, instead of -1, to conform
  to PEP 626. This should not normally be possible, but might occur in
  some unusual circumstances.

* bpo-43963: Importing the "_signal" module in a subinterpreter has no
  longer side effects.

* bpo-42739: The internal representation of line number tables is
  changed to not use sentinels, and an explicit length parameter is
  added to the out of process API function
  "PyLineTable_InitAddressRange". This makes the handling of line
  number tables more robust in some circumstances.

* bpo-43908: Make "re" types immutable. Patch by Erlend E. Aasland.

* bpo-43908: Make the "array.array" type immutable. Patch by Erlend E.
  Aasland.

* bpo-43901: Change class and module objects to lazy-create empty
  annotations dicts on demand.  The annotations dicts are stored in
  the object's __dict__ for backwards compatibility.

* bpo-43892: Match patterns now use new dedicated AST nodes
  ("MatchValue", "MatchSingleton", "MatchSequence", "MatchStar",
  "MatchMapping", "MatchClass") rather than reusing expression AST
  nodes. "MatchAs" and "MatchOr" are now defined as pattern nodes
  rather than as expression nodes. Patch by Nick Coghlan.

* bpo-42725: Usage of "await"/"yield"/"yield from" and named
  expressions within an annotation is now forbidden when PEP 563 is
  activated.

* bpo-43754: When performing structural pattern matching (**PEP
  634**), captured names are now left unbound until the *entire*
  pattern has matched successfully.

* bpo-42737: Annotations for complex targets (everything beside simple
  names) no longer cause any runtime effects with "from __future__
  import annotations".

* bpo-43914: "SyntaxError" exceptions raised by the interpreter will
  highlight the full error range of the expression that consistutes
  the syntax error itself, instead of just where the problem is
  detected. Patch by Pablo Galindo.

* bpo-38605: Revert making "from __future__ import annotations" the
  default. This follows the Steering Council decision to postpone PEP
  563 changes to at least Python 3.11. See the original email for more
  information regarding the decision:
  https://mail.python.org/archives/list/python-
  dev@python.org/thread/CLVXXPQ2T2LQ5MP2Y53VVQFCXYWQJHKZ/. Patch by
  Pablo Galindo.

* bpo-43475: Hashes of NaN values now depend on object identity.
  Formerly, they always hashed to 0 even though NaN values are not
  equal to one another.  Having the same hash for unequal values
  caused pile-ups in hash tables.

* bpo-43859: Improve the error message for "IndentationError"
  exceptions. Patch by Pablo Galindo

* bpo-41323: Constant tuple folding in bytecode optimizer now reuses
  tuple in constant table.

* bpo-43846: Data stack usage is much reduced for large literal and
  call expressions.

* bpo-38530: When printing "NameError" raised by the interpreter,
  "PyErr_Display()" will offer suggestions of similar variable names
  in the function that the exception was raised from. Patch by Pablo
  Galindo

* bpo-43823: Improve syntax errors for invalid dictionary literals.
  Patch by Pablo Galindo.

* bpo-43822: Improve syntax errors in the parser for missing commas
  between expressions. Patch by Pablo Galindo.

* bpo-43798: "ast.alias" nodes now include source location metadata
  attributes e.g. lineno, col_offset.

* bpo-43797: Improve "SyntaxError" error messages for invalid
  comparisons. Patch by Pablo Galindo.

* bpo-43760: Move the flag for checking whether tracing is enabled to
  the C stack, from the heap. Should speed up dispatch in the
  interpreter.

* bpo-43682: Static methods ("@staticmethod") and class methods
  ("@classmethod") now inherit the method attributes ("__module__",
  "__name__", "__qualname__", "__doc__", "__annotations__") and have a
  new "__wrapped__" attribute. Patch by Victor Stinner.

* bpo-43751: Fixed a bug where "anext(ait, default)" would erroneously
  return None.

* bpo-42128: "__match_args__" is no longer allowed to be a list.

* bpo-43683: Add GEN_START opcode. Marks start of generator, including
  async, or coroutine and handles sending values to a newly created
  generator or coroutine.

* bpo-43105: Importlib now resolves relative paths when creating
  module spec objects from file locations.

* bpo-43682: Static methods ("@staticmethod") are now callable as
  regular functions. Patch by Victor Stinner.

* bpo-42609: Prevented crashes in the AST validator and optimizer when
  compiling some absurdly long expressions like ""+0"*1000000".
  "RecursionError" is now raised instead.

* bpo-38530: When printing "AttributeError", "PyErr_Display()" will
  offer suggestions of similar attribute names in the object that the
  exception was raised from. Patch by Pablo Galindo


Biblioteca
----------

* bpo-44015: In @dataclass(), raise a TypeError if KW_ONLY is
  specified more than once.

* bpo-25478: Added a *total()* method to collections.Counter() to
  compute the sum of the counts.

* bpo-43733: Change "netrc.netrc" to use UTF-8 encoding before using
  locale encoding.

* bpo-43979: Removed an unnecessary list comprehension before looping
  from "urllib.parse.parse_qsl()".  Patch by Christoph Zwerschke and
  Dong-hee Na.

* bpo-43993: Update bundled pip to 21.1.1.

* bpo-43957: [Enum] Deprecate "TypeError" when non-member is used in a
  containment check; In 3.12 "True" or "False" will be returned
  instead, and containment will return "True" if the value is either a
  member of that enum or one of its members' value.

* bpo-42904: For backwards compatibility with previous minor versions
  of Python, if "typing.get_type_hints()" receives no namespace
  dictionary arguments, "typing.get_type_hints()" will search through
  the global then local namespaces during evaluation of stringized
  type annotations (string forward references) inside a class.

* bpo-43945: [Enum] Deprecate non-standard mixin format() behavior: in
  3.12 the enum member, not the member's value, will be used for
  format() calls.

* bpo-41139: Deprecate undocumented "cgi.log()" API.

* bpo-43937: Fixed the "turtle" module working with non-default root
  window.

* bpo-43930: Update bundled pip to 21.1 and setuptools to 56.0.0

* bpo-43907: Fix a bug in the pure-Python pickle implementation when
  using protocol 5, where bytearray instances that occur several time
  in the pickled object graph would incorrectly unpickle into repeated
  copies of the bytearray object.

* bpo-43926: In "importlib.metadata", provide a uniform interface to
  "Description", allow for any field to be encoded with multiline
  values, remove continuation lines from multiline values, and add a
  ".json" property for easy access to the PEP 566 JSON-compatible
  form. Sync with "importlib_metadata 4.0".

* bpo-43920: OpenSSL 3.0.0: "load_verify_locations()" now returns a
  consistent error message when cadata contains no valid certificate.

* bpo-43607: "urllib" can now convert Windows paths with "\\?\"
  prefixes into URL paths.

* bpo-43817: Add "inspect.get_annotations()", which safely computes
  the annotations defined on an object.  It works around the quirks of
  accessing the annotations from various types of objects, and makes
  very few assumptions about the object passed in.
  "inspect.get_annotations()" can also correctly un-stringize
  stringized annotations.

  "inspect.signature()", "inspect.from_callable()", and
  "inspect.from_function()" now call "inspect.get_annotations()" to
  retrieve annotations.  This means "inspect.signature()" and
  "inspect.from_callable()" can now un-stringize stringized
  annotations, too.

* bpo-43284: platform.win32_ver derives the windows version from
  sys.getwindowsversion().platform_version which in turn derives the
  version from kernel32.dll (which can be of a different version than
  Windows itself). Therefore change the platform.win32_ver to
  determine the version using the platform module's _syscmd_ver
  private function to return an accurate version.

* bpo-42854: The "ssl" module now uses "SSL_read_ex" and
  "SSL_write_ex" internally. The functions support reading and writing
  of data larger than 2 GB. Writing zero-length data no longer fails
  with a protocol violation error.

* bpo-42333: Port "_ssl" extension module to multiphase
  initialization.

* bpo-43880: "ssl" now raises DeprecationWarning for OP_NO_SSL/TLS*
  options, old TLS versions, old protocols, and other features that
  have been deprecated since Python 3.6, 3.7, or OpenSSL 1.1.0.

* bpo-41559: **PEP 612** is now implemented purely in Python; builtin
  "types.GenericAlias" objects no longer include "typing.ParamSpec" in
  "__parameters__" (with the exception of "collections.abc.Callable"'s
  "GenericAlias"). This means previously invalid uses of "ParamSpec"
  (such as "list[P]") which worked in earlier versions of Python 3.10
  alpha, will now raise "TypeError" during substitution.

* bpo-43867: The "multiprocessing" "Server" class now explicitly
  catches "SystemExit" and closes the client connection in this case.
  It happens when the "Server.serve_client()" method reaches the end
  of file (EOF).

* bpo-40443: Remove unused imports: pyclbr no longer uses copy, and
  typing no longer uses ast. Patch by Victor Stinner.

* bpo-43820: Remove an unneeded copy of the namespace passed to
  dataclasses.make_dataclass().

* bpo-43787: Add "__iter__()" method to "bz2.BZ2File",
  "gzip.GzipFile", and "lzma.LZMAFile". It makes iterating them about
  2x faster. Patch by Inada Naoki.

* bpo-43680: Deprecate io.OpenWrapper and _pyio.OpenWrapper: use
  io.open and _pyio.open instead. Until Python 3.9, _pyio.open was not
  a static method and builtins.open was set to OpenWrapper to not
  become a bound method when set to a class variable. _io.open is a
  built-in function whereas _pyio.open is a Python function. In Python
  3.10, _pyio.open() is now a static method, and builtins.open() is
  now io.open().

* bpo-43680: The Python "_pyio.open()" function becomes a static
  method to behave as "io.open()" built-in function: don't become a
  bound method when stored as a class variable. It becomes possible
  since static methods are now callable in Python 3.10. Moreover,
  "_pyio.OpenWrapper()" becomes a simple alias to "_pyio.open()".
  Patch by Victor Stinner.

* bpo-41515: Fix "KeyError" raised in "typing.get_type_hints()" due to
  synthetic modules that don't appear in "sys.modules".

* bpo-43776: When "subprocess.Popen" args are provided as a string or
  as "pathlib.Path", the Popen instance repr now shows the right
  thing.

* bpo-42248: [Enum] ensure exceptions raised in "_missing__" are
  released

* bpo-43744: fix issue with enum member name matching the start of a
  private variable name

* bpo-43772: Fixed the return value of "TypeVar.__ror__". Patch by
  Jelle Zijlstra.

* bpo-43764: Add match_args parameter to @dataclass decorator to allow
  suppression of __match_args__ generation.

* bpo-43799: OpenSSL 3.0.0: define "OPENSSL_API_COMPAT" 1.1.1 to
  suppress deprecation warnings. Python requires OpenSSL 1.1.1 APIs.

* bpo-43478: Mocks can no longer be used as the specs for other Mocks.
  As a result, an already-mocked object cannot have an attribute
  mocked using "autospec=True" or be the subject of a
  "create_autospec(...)" call. This can uncover bugs in tests since
  these Mock-derived Mocks will always pass certain tests (e.g.
  "isinstance()") and builtin assert functions (e.g.
  assert_called_once_with) will unconditionally pass.

* bpo-43794: Add "ssl.OP_IGNORE_UNEXPECTED_EOF" constants (OpenSSL
  3.0.0)

* bpo-43785: Improve "bz2.BZ2File" performance by removing the RLock
  from BZ2File. This makes BZ2File thread unsafe in the face of
  multiple simultaneous readers or writers, just like its equivalent
  classes in "gzip" and "lzma" have always been.  Patch by Inada
  Naoki.

* bpo-43789: OpenSSL 3.0.0: Don't call the password callback function
  a second time when first call has signaled an error condition.

* bpo-43788: The header files for "ssl" error codes are now OpenSSL
  version-specific. Exceptions will now show correct reason and
  library codes. The "make_ssl_data.py" script has been rewritten to
  use OpenSSL's text file with error codes.

* bpo-43766: Implement **PEP 647** in the "typing" module by adding
  "TypeGuard".

* bpo-25264: "os.path.realpath()" now accepts a *strict* keyword-only
  argument. When set to "True", "OSError" is raised if a path doesn't
  exist or a symlink loop is encountered.

* bpo-43780: In "importlib.metadata", incorporate changes from
  importlib_metadata 3.10: Add mtime-based caching during distribution
  discovery. Flagged use of dict result from "entry_points()" as
  deprecated.

* The "P.args" and "P.kwargs" attributes of "typing.ParamSpec" are now
  instances of the new classes "typing.ParamSpecArgs" and
  "typing.ParamSpecKwargs", which enables a more useful "repr()".
  Patch by Jelle Zijlstra.

* bpo-43731: Add an "encoding" parameter "logging.fileConfig()".

* bpo-43712: Add "encoding" and "errors" parameters to
  "fileinput.input()" and "fileinput.FileInput".

* bpo-38659: A "simple_enum" decorator is added to the "enum" module
  to convert a normal class into an Enum. "test_simple_enum" added to
  test simple enums against a corresponding normal Enum.  Standard
  library modules updated to use "simple_enum".

* bpo-43764: Fix an issue where "__match_args__" generation could fail
  for some "dataclasses".

* bpo-43752: Fix "sqlite3" regression for zero-sized blobs with
  converters, where "b""" was returned instead of "None". The
  regression was introduced by PR 24723. Patch by Erlend E. Aasland.

* bpo-43655: "tkinter" dialog windows are now recognized as dialogs by
  window managers on macOS and X Window.

* bpo-43723: The following "threading" methods are now deprecated and
  should be replaced:

  * "currentThread" => "threading.current_thread()"

  * "activeCount" => "threading.active_count()"

  * "Condition.notifyAll" => "threading.Condition.notify_all()"

  * "Event.isSet" => "threading.Event.is_set()"

  * "Thread.setName" => "threading.Thread.name"

  * "thread.getName" => "threading.Thread.name"

  * "Thread.isDaemon" => "threading.Thread.daemon"

  * "Thread.setDaemon" => "threading.Thread.daemon"

  Patch by Jelle Zijlstra.

* bpo-2135: Deprecate find_module() and find_loader() implementations
  in importlib and zipimport.

* bpo-43534: "turtle.textinput()" and "turtle.numinput()" create now a
  transient window working on behalf of the canvas window.

* bpo-43532: Add the ability to specify keyword-only fields to
  dataclasses. These fields will become keyword-only arguments to the
  generated __init__.

* bpo-43522: Fix problem with "hostname_checks_common_name". OpenSSL
  does not copy hostflags from *struct SSL_CTX* to *struct SSL*.

* bpo-8978: Improve error message for "tarfile.open()" when "lzma" /
  "bz2" are unavailable.  Patch by Anthony Sottile.

* bpo-42967: Allow "bytes" "separator" argument in
  "urllib.parse.parse_qs" and "urllib.parse.parse_qsl" when parsing
  "str" query strings. Previously, this raised a "TypeError".

* bpo-43296: Improve "sqlite3" error handling: "sqlite3_value_blob()"
  errors that set "SQLITE_NOMEM" now raise "MemoryError". Patch by
  Erlend E. Aasland.

* bpo-43312: New functions "sysconfig.get_preferred_scheme()" and
  "sysconfig.get_default_scheme()" are added to query a platform for
  its preferred "user", "home", and "prefix" (default) scheme names.

* bpo-43265: Improve "sqlite3.Connection.backup()" error handling. The
  error message for non-existent target database names is now "unknown
  database <database name>" instead of "SQL logic error". Patch by
  Erlend E. Aasland.

* bpo-41282: Install schemes in "distutils.command.install" are now
  loaded from "sysconfig".

* bpo-41282: "distutils.sysconfig" has been merged to "sysconfig".

* bpo-43176: Fixed processing of a dataclass that inherits from a
  frozen dataclass with no fields.  It is now correctly detected as an
  error.

* bpo-43080: "pprint" now has support for "dataclasses.dataclass".
  Patch by Lewis Gaul.

* bpo-39950: Add "pathlib.Path.hardlink_to()" method that supersedes
  "link_to()". The new method has the same argument order as
  "symlink_to()".

* bpo-42904: "typing.get_type_hints()" now checks the local namespace
  of a class when evaluating **PEP 563** annotations inside said
  class.

* bpo-42269: Add "slots" parameter to "dataclasses.dataclass"
  decorator to automatically generate "__slots__" for class. Patch
  provided by Yurii Karabas.

* bpo-39529: Deprecated use of "asyncio.get_event_loop()" without
  running event loop. Emit deprecation warning for "asyncio" functions
  which implicitly create a "Future" or "Task" objects if there is no
  running event loop and no explicit *loop* argument is passed:
  "ensure_future()", "wrap_future()", "gather()", "shield()",
  "as_completed()" and constructors of "Future", "Task",
  "StreamReader", "StreamReaderProtocol".

* bpo-18369: Certificate and PrivateKey classes were added to the ssl
  module. Certificates and keys can now be loaded from memory buffer,
  too.

* bpo-41486: Use a new output buffer management code for "bz2" /
  "lzma" / "zlib" modules, and add ".readall()" function to
  "_compression.DecompressReader" class. These bring some performance
  improvements. Patch by Ma Lin.

* bpo-31870: The "ssl.get_server_certificate()" function now has a
  *timeout* parameter.

* bpo-41735: Fix thread locks in zlib module may go wrong in rare
  case. Patch by Ma Lin.

* bpo-36470: Fix dataclasses with "InitVar"s and "replace()". Patch by
  Claudiu Popa.

* bpo-40849: Expose X509_V_FLAG_PARTIAL_CHAIN ssl flag

* bpo-35114: "ssl.RAND_status()" now returns a boolean value (as
  documented) instead of "1" or "0".

* bpo-39906: "pathlib.Path.stat()" and "chmod()" now accept a
  *follow_symlinks* keyword-only argument for consistency with
  corresponding functions in the "os" module.

* bpo-39899: "os.path.expanduser()" now refuses to guess Windows home
  directories if the basename of current user's home directory does
  not match their username.

  "pathlib.Path.expanduser()" and "home()" now consistently raise
  "RuntimeError" exception when a home directory cannot be resolved.
  Previously a "KeyError" exception could be raised on Windows when
  the ""USERNAME""  environment variable was unset.

* bpo-36076: Added SNI support to "ssl.get_server_certificate()".

* bpo-38490: Covariance, Pearson's correlation, and simple linear
  regression functionality was added to statistics module. Patch by
  Tymoteusz Wołodźko.

* bpo-33731: Provide a locale.localize() function, which converts a
  normalized number string into a locale format.

* bpo-32745: Fix a regression in the handling of ctypes'
  "ctypes.c_wchar_p" type: embedded null characters would cause a
  "ValueError" to be raised. Patch by Zackery Spytz.


Documentación
-------------

* bpo-43987: Add "Annotations Best Practices" document as a new HOWTO.

* bpo-43977: Document the new "Py_TPFLAGS_MAPPING" and
  "Py_TPFLAGS_SEQUENCE" type flags.

* bpo-43959: The documentation on the PyContextVar C-API was
  clarified.

* bpo-43938: Update dataclasses documentation to express that
  FrozenInstanceError is derived from AttributeError.

* bpo-43778: Fix the Sphinx glossary_search extension: create the
  _static/ sub-directory if it doesn't exist.

* bpo-43755: Update documentation to reflect that unparenthesized
  lambda expressions can no longer be the expression part in an "if"
  clause in comprehensions and generator expressions since Python 3.9.

* bpo-43739: Fixing the example code in Doc/extending/extending.rst to
  declare and initialize the pmodule variable to be of the right type.


Pruebas
-------

* bpo-43961: Fix test_logging.test_namer_rotator_inheritance() on
  Windows: use "os.replace()" rather than "os.rename()". Patch by
  Victor Stinner.

* bpo-43842: Fix a race condition in the SMTP test of test_logging.
  Don't close a file descriptor (socket) from a different thread while
  asyncore.loop() is polling the file descriptor. Patch by Victor
  Stinner.

* bpo-43843: "test.libregrtest" now marks a test as ENV_CHANGED
  (altered the execution environment) if a thread raises an exception
  but does not catch it. It sets a hook on "threading.excepthook()".
  Use "--fail-env-changed" option to mark the test as failed. Patch by
  Victor Stinner.

* bpo-43811: Tests multiple OpenSSL versions on GitHub Actions. Use
  ccache to speed up testing.

* bpo-43791: OpenSSL 3.0.0: Disable testing of legacy protocols TLS
  1.0 and 1.1. Tests are failing with TLSV1_ALERT_INTERNAL_ERROR.


Construir
---------

* bpo-43567: Improved generated code refresh
  (AST/tokens/opcodes/keywords) on Windows.

* bpo-43669: Implement **PEP 644**. Python now requires OpenSSL 1.1.1
  or newer.


Ventanas
--------

* bpo-35306: Adds additional arguments to "os.startfile()" function.

* bpo-43538: Avoid raising errors from "pathlib.Path.exists()" when
  passed an invalid filename.

* bpo-38822: Fixed "os.stat()" failing on inaccessible directories
  with a trailing slash, rather than falling back to the parent
  directory's metadata. This implicitly affected "os.path.exists()"
  and "os.path.isdir()".

* bpo-26227: Fixed decoding of host names in "socket.gethostbyaddr()"
  and "socket.gethostbyname_ex()".

* bpo-40432: Updated pegen regeneration script on Windows to find and
  use Python 3.8 or higher.  Prior to this, pegen regeneration already
  required 3.8 or higher, but the script may have used lower versions
  of Python.

* bpo-43745: Actually updates Windows release to OpenSSL 1.1.1k.
  Earlier releases were mislabelled and actually included 1.1.1i
  again.

* bpo-43652: Update Tcl and Tk to 8.6.11 in Windows installer.

* bpo-43492: Upgrade Windows installer to use SQLite 3.35.5.

* bpo-30555: Fix "WindowsConsoleIO" errors in the presence of fd
  redirection. Patch by Segev Finer.


Mac OS
------

* bpo-42119: Fix check for macOS SDK paths when building Python.
  Narrow search to match contents of SDKs, namely only files in
  "/System/Library", "/System/IOSSupport", and "/usr" other than
  "/usr/local". Previously, anything under "/System" was assumed to be
  in an SDK which causes problems with the new file system layout in
  10.15+ where user file systems may appear to be mounted under
  "/System".  Paths in "/Library" were also incorrectly treated as SDK
  locations.

* bpo-43568: Drop support for MACOSX_DEPLOYMENT_TARGET < 10.3

* bpo-44009: Provide "python3.x-intel64" executable to allow reliably
  forcing macOS universal2 framework builds to run under Rosetta 2
  Intel-64 emulation on Apple Silicon Macs.  This can be useful for
  testing or when universal2 wheels are not yet available.

* bpo-43851: Build SQLite with "SQLITE_OMIT_AUTOINIT" on macOS. Patch
  by Erlend E. Aasland.

* bpo-43492: Update macOS installer to use SQLite 3.35.4.

* bpo-42235: "Mac/BuildScript/build-installer.py" will now use "--
  enable-optimizations" and "--with-lto" when building on macOS 10.15
  or later.


INACTIVO
--------

* bpo-37903: Add mouse actions to the shell sidebar.  Left click and
  optional drag selects one or more lines, as with the editor line
  number sidebar.  Right click after selecting raises a context menu
  with 'copy with prompts'.  This zips together prompts from the
  sidebar with lines from the selected text.

* bpo-43981: Fix reference leak in test_sidebar and test_squeezer.
  Patches by Terry Jan Reedy and Pablo Galindo

* bpo-37892: Indent IDLE Shell input with spaces instead of tabs

* bpo-43655: IDLE dialog windows are now recognized as dialogs by
  window managers on macOS and X Window.

* bpo-37903: IDLE's shell now shows prompts in a separate side-bar.


API C
-----

* bpo-43916: Add a new "Py_TPFLAGS_DISALLOW_INSTANTIATION" type flag
  to disallow creating type instances. Patch by Victor Stinner.

* bpo-43774: Remove the now unused "PYMALLOC_DEBUG" macro. Debug hooks
  on memory allocators are now installed by default if Python is built
  in debug mode (if "Py_DEBUG" macro is defined). Moreover, they can
  now be used on Python build in release mode (ex: using
  "PYTHONMALLOC=debug" environment variable).

* bpo-43962: _PyInterpreterState_IDIncref() now calls
  _PyInterpreterState_IDInitref() and always increments id_refcount.
  Previously, calling _xxsubinterpreters.get_current() could create an
  id_refcount inconsistency when a _xxsubinterpreters.InterpreterID
  object was deallocated. Patch by Victor Stinner.

* bpo-28254: Add new C-API functions to control the state of the
  garbage collector: "PyGC_Enable()", "PyGC_Disable()",
  "PyGC_IsEnabled()", corresponding to the functions in the "gc"
  module.

* bpo-43908: Introduce "Py_TPFLAGS_IMMUTABLETYPE" flag for immutable
  type objects, and modify "PyType_Ready()" to set it for static
  types. Patch by Erlend E. Aasland.

* bpo-43795: "PyMem_Calloc()" is now available in the limited C API
  ("Py_LIMITED_API").

* bpo-43868: "PyOS_ReadlineFunctionPointer()" is no longer exported by
  limited C API headers and by "python3.dll" on Windows. Like any
  function that takes "FILE*", it is not part of the stable ABI.

* bpo-43795: Stable ABI and limited API definitions are generated from
  a central manifest (**PEP 652**).

* bpo-43753: Add the "Py_Is(x, y)" function to test if the *x* object
  is the *y* object, the same as "x is y" in Python. Add also the
  "Py_IsNone()", "Py_IsTrue()", "Py_IsFalse()" functions to test if an
  object is, respectively, the "None" singleton, the "True" singleton
  or the "False" singleton. Patch by Victor Stinner.


Python 3.10.0 alpha 7
=====================

*Release date: 2021-04-05*


Seguridad
---------

* bpo-42988: CVE-2021-3426: Remove the "getfile" feature of the
  "pydoc" module which could be abused to read arbitrary files on the
  disk (directory traversal vulnerability). Moreover, even source code
  of Python modules can contain sensitive data like passwords.
  Vulnerability reported by David Schwörer.

* bpo-43285: "ftplib" no longer trusts the IP address value returned
  from the server in response to the PASV command by default.  This
  prevents a malicious FTP server from using the response to probe
  IPv4 address and port combinations on the client network.

  Code that requires the former vulnerable behavior may set a
  "trust_server_pasv_ipv4_address" attribute on their "ftplib.FTP"
  instances to "True" to re-enable it.

* bpo-43439: Add audit hooks for "gc.get_objects()",
  "gc.get_referrers()" and "gc.get_referents()". Patch by Pablo
  Galindo.


Núcleo y elementos integrados
-----------------------------

* bpo-27129: Update CPython bytecode magic number.

* bpo-43672: Raise ImportWarning when calling find_loader().

* bpo-43660: Fix crash that happens when replacing "sys.stderr" with a
  callable that can remove the object while an exception is being
  printed. Patch by Pablo Galindo.

* bpo-27129: The bytecode interpreter uses instruction, rather byte,
  offsets internally. This reduces the number of EXTENDED_ARG
  instructions needed and streamlines instruction dispatch a bit.

* bpo-40645: Fix reference leak in the "_hashopenssl" extension. Patch
  by Pablo Galindo.

* bpo-42134: Calls to find_module() by the import system now raise
  ImportWarning.

* bpo-41064: Improve the syntax error for invalid usage of double
  starred elements ('**') in f-strings. Patch by Pablo Galindo.

* bpo-43575: Speed up calls to "map()" by using the **PEP 590**
  "vectorcall" calling convention. Patch by Dong-hee Na.

* bpo-42137: The import system now prefers using "__spec__" for
  "ModuleType.__repr__" over "module_repr()".

* bpo-43452: Added micro-optimizations to "_PyType_Lookup()" to
  improve cache lookup performance in the common case of cache hits.

* bpo-43555: Report the column offset for "SyntaxError" for invalid
  line continuation characters. Patch by Pablo Galindo.

* bpo-43517: Fix misdetection of circular imports when using "from
  pkg.mod import attr", which caused false positives in non-trivial
  multi-threaded code.

* bpo-43497: Emit SyntaxWarnings for assertions with tuple constants,
  this is a regression introduced in python3.7

* bpo-39316: Tracing now has correct line numbers for attribute
  accesses when the the attribute is on a different line from the
  object. Improves debugging and profiling for multi-line method
  chains.

* bpo-35883: Python no longer fails at startup with a fatal error if a
  command line argument contains an invalid Unicode character. The
  "Py_DecodeLocale()" function now escapes byte sequences which would
  be decoded as Unicode characters outside the [U+0000; U+10ffff]
  range.

* bpo-43410: Fix a bug that was causing the parser to crash when
  emitting syntax errors when reading input from stdin. Patch by Pablo
  Galindo

* bpo-43406: Fix a possible race condition where "PyErr_CheckSignals"
  tries to execute a non-Python signal handler.

* bpo-42128: Add "__match_args__" to "structsequence" based classes.
  Patch by Pablo Galindo.

* bpo-43390: CPython now sets the "SA_ONSTACK" flag in "PyOS_setsig"
  for the VM's default signal handlers.  This is friendlier to other
  in-process code that an extension module or embedding use could pull
  in (such as Golang's cgo) where tiny thread stacks are the norm and
  "sigaltstack()" has been used to provide for signal handlers.  This
  is a no-op change for the vast majority of processes that don't use
  sigaltstack.

* bpo-43287: Speed up calls to "filter()" by using the **PEP 590**
  "vectorcall" calling convention. Patch by Dong-hee Na.

* bpo-37448: Add a radix tree based memory map to track in-use
  obmalloc arenas. Use to replace the old implementation of
  address_in_range(). The radix tree approach makes it easy to
  increase pool sizes beyond the OS page size. Boosting the pool and
  arena size allows obmalloc to handle a significantly higher
  percentage of requests from its ultra-fast paths.

  It also has the advantage of eliminating the memory unsanitary
  behavior of the previous address_in_range(). The old
  address_in_range() was marked with the annotations
  _Py_NO_SANITIZE_ADDRESS, _Py_NO_SANITIZE_THREAD, and
  _Py_NO_SANITIZE_MEMORY. Those annotations are no longer needed.

  To disable the radix tree map, set a preprocessor flag as follows:
  "-DWITH_PYMALLOC_RADIX_TREE=0".

  Co-authored-by: Tim Peters <tim.peters@gmail.com>

* bpo-29988: Only handle asynchronous exceptions and requests to drop
  the GIL when returning from a call or on the back edges of loops.
  Makes sure that "__exit__()" is always called in with statements,
  even for interrupts.


Biblioteca
----------

* bpo-43720: Document various stdlib deprecations in imp, pkgutil, and
  importlib.util for removal in Python 3.12.

* bpo-43433: "xmlrpc.client.ServerProxy" no longer ignores query and
  fragment in the URL of the server.

* bpo-31956: The "index()" method of "array.array" now has optional
  *start* and *stop* parameters.

* bpo-40066: Enum: adjust "repr()" to show only enum and member name
  (not value, nor angle brackets) and "str()" to show only member
  name.  Update and improve documentation to match.

* bpo-42136: Deprecate all module_repr() methods found in importlib as
  their use is being phased out by Python 3.12.

* bpo-35930: Raising an exception raised in a "future" instance will
  create reference cycles.

* bpo-41369: Finish updating the vendored libmpdec to version 2.5.1.
  Patch by Stefan Krah.

* bpo-43422: Revert the _decimal C API which was added in bpo-41324.

* bpo-43577: Fix deadlock when using "ssl.SSLContext" debug callback
  with "ssl.SSLContext.sni_callback()".

* bpo-43571: It's now possible to create MPTCP sockets with
  IPPROTO_MPTCP

* bpo-43542: "image/heic" and "image/heif" were added to "mimetypes".

* bpo-40645: The "hmac" module now uses OpenSSL's HMAC implementation
  when digestmod argument is a hash name or builtin hash function.

* bpo-43510: Implement **PEP 597**: Add "EncodingWarning" warning, "-X
  warn_default_encoding" option, "PYTHONWARNDEFAULTENCODING"
  environment variable and "encoding="locale"" argument value.

* bpo-43521: "ast.unparse" can now render NaNs and empty sets.

* bpo-42914: "pprint.pprint()" gains a new boolean
  "underscore_numbers" optional argument to emit integers with
  thousands separated by an underscore character for improved
  readability (for example "1_000_000" instead of "1000000").

* bpo-41361: "rotate()" calls are now slightly faster due to faster
  argument parsing.

* bpo-43423: "subprocess.communicate()" no longer raises an IndexError
  when there is an empty stdout or stderr IO buffer during a timeout
  on Windows.

* bpo-27820: Fixed long-standing bug of smtplib.SMTP where doing AUTH
  LOGIN with initial_response_ok=False will fail.

  The cause is that SMTP.auth_login _always_ returns a password if
  provided with a challenge string, thus non-compliant with the
  standard for AUTH LOGIN.

  Also fixes bug with the test for smtpd.

* bpo-43445: Add frozen modules to "sys.stdlib_module_names". For
  example, add ""_frozen_importlib"" and
  ""_frozen_importlib_external"" names.

* bpo-43245: Add keyword arguments support to "ChainMap.new_child()".

* bpo-29982: Add optional parameter *ignore_cleanup_errors* to
  "tempfile.TemporaryDirectory()" and allow multiple "cleanup()"
  attempts. Contributed by C.A.M. Gerlach.

* bpo-43428: Include changes from importlib_metadata 3.7:

  Performance enhancements to distribution discovery.

  "entry_points" only returns unique distributions.

  Introduces new "EntryPoints" object for containing a set of entry
  points with convenience methods for selecting entry points by group
  or name. "entry_points" now returns this object if selection
  parameters are supplied but continues to return a dict object for
  compatibility. Users are encouraged to rely on the selection
  interface. The dict object result is likely to be deprecated in the
  future.

  Added packages_distributions function to return a mapping of
  packages to the distributions that provide them.

* bpo-43332: Improves the networking efficiency of "http.client" when
  using a proxy via "set_tunnel()".  Fewer small send calls are made
  during connection setup.

* bpo-43420: Improve performance of "fractions.Fraction" arithmetics
  for large components.  Contributed by Sergey B. Kirpichev.

* bpo-43356: Allow passing a signal number to
  "_thread.interrupt_main()".

* bpo-43399: Fix "ElementTree.extend" not working on iterators when
  using the Python implementation

* bpo-43369: Improve "sqlite3" error handling: If
  "sqlite3_column_text()" and "sqlite3_column_blob()" set
  "SQLITE_NOMEM", "MemoryError" is now raised. Patch by Erlend E.
  Aasland.

* bpo-43368: Fix a regression introduced in PR 24562, where an empty
  bytestring was fetched as "None" instead of "b''" in "sqlite3".
  Patch by Mariusz Felisiak.

* bpo-41282: Fixed stacklevel of "DeprecationWarning" emitted from
  "import distutils".

* bpo-42129: "importlib.resources" now honors namespace packages,
  merging resources from each location in the namespace as introduced
  in "importlib_resources" 3.2 and including incidental changes
  through 5.0.3.

* bpo-43295: "datetime.datetime.strptime()" now raises "ValueError"
  instead of "IndexError" when matching "'z'" with the "%z" format
  specifier.

* bpo-43125: Return empty string if base64mime.body_encode receive
  empty bytes

* bpo-43084: "curses.window.enclose()" returns now "True" or "False"
  (as was documented) instead of "1" or "0".

* bpo-42994: Add MIME types for opus, AAC, 3gpp and 3gpp2

* bpo-14678: Add an invalidate_caches() method to the
  zipimport.zipimporter class to support
  importlib.invalidate_caches(). Patch by Desmond Cheong.

* bpo-42782: Fail fast in "shutil.move()" to avoid creating
  destination directories on failure.

* bpo-40066: Enum's "repr()" and "str()" have changed: "repr()" is now
  *EnumClass.MemberName* and "str()" is *MemberName*.  Additionally,
  stdlib Enum's whose contents are available as module attributes,
  such as "RegexFlag.IGNORECASE", have their "repr()" as
  *module.name*, e.g. "re.IGNORECASE".

* bpo-26053: Fixed bug where the "pdb" interactive run command echoed
  the args from the shell command line, even if those have been
  overridden at the pdb prompt.

* bpo-24160: Fixed bug where breakpoints did not persist across
  multiple debugger sessions in "pdb"'s interactive mode.

* bpo-40701: When the "tempfile.tempdir" global variable is set to a
  value of type bytes, it is now handled consistently.  Previously
  exceptions could be raised from some tempfile APIs when the
  directory did not already exist in this situation.  Also ensures
  that the "tempfile.gettempdir()" and "tempfile.gettempdirb()"
  functions *always* return "str" and "bytes" respectively.

* bpo-39342: Expose "X509_V_FLAG_ALLOW_PROXY_CERTS" as
  "VERIFY_ALLOW_PROXY_CERTS" to allow proxy certificate validation as
  explained in https://www.openssl.org/docs/man1.1.1/man7/proxy-
  certificates.html.

* bpo-31861: Add builtins.aiter and builtins.anext. Patch by Joshua
  Bronson (@jab), Daniel Pope (@lordmauve), and Justin Wang
  (@justin39).


Documentación
-------------

* bpo-43199: Answer "Why is there no goto?" in the Design and History
  FAQ.

* bpo-43407: Clarified that a result from "time.monotonic()",
  "time.perf_counter()", "time.process_time()", or
  "time.thread_time()" can be compared with the result from any
  following call to the same function - not just the next immediate
  call.

* bpo-43354: Fix type documentation for "Fault.faultCode"; the type
  has to be "int" instead of "str".

* bpo-41933: Clarified wording of s * n in the Common Sequence
  Operations


Pruebas
-------

* bpo-37945: Fix test_getsetlocale_issue1813() of test_locale: skip
  the test if "setlocale()" fails. Patch by Victor Stinner.

* bpo-41561: Add workaround for Ubuntu's custom OpenSSL security level
  policy.


Construir
---------

* bpo-43179: Introduce and correctly use ALIGNOF_X in place of
  SIZEOF_X for alignment-related code in optimized string routines.
  Patch by Jessica Clarke.

* bpo-43631: Update macOS, Windows, and CI to OpenSSL 1.1.1k.

* bpo-43617: Improve configure.ac: Check for presence of autoconf-
  archive package and remove our copies of M4 macros.

* bpo-43466: The "configure" script now supports "--with-openssl-
  rpath" option.

* bpo-43372: Use "_freeze_importlib" to generate code for the
  "__hello__" module. This approach ensures the code matches the
  interpreter version.  Previously, PYTHON_FOR_REGEN was used to
  generate the code, which might be wrong.  The marshal format for
  code objects has changed with bpo-42246, commit 877df851. Update the
  code and the expected code sizes in ctypes test_frozentable.


Ventanas
--------

* bpo-43440: Build "sqlite3" with the "R*Tree" module enabled. Patch
  by Erlend E. Aasland.


INACTIVO
--------

* bpo-42225: Document that IDLE can fail on Unix either from
  misconfigured IP masquerade rules or failure displaying complex
  colored (non-ascii) characters.


API C
-----

* bpo-43688: The limited C API is now supported if Python is built in
  debug mode (if the "Py_DEBUG" macro is defined). In the limited C
  API, the "Py_INCREF()" and "Py_DECREF()" functions are now
  implemented as opaque function calls, rather than accessing directly
  the "PyObject.ob_refcnt" member, if Python is built in debug mode
  and the "Py_LIMITED_API" macro targets Python 3.10 or newer. It
  became possible to support the limited C API in debug mode because
  the "PyObject" structure is the same in release and debug mode since
  Python 3.8 (see bpo-36465).

  The limited C API is still not supported in the "--with-trace-refs"
  special build ("Py_TRACE_REFS" macro).

  Patch by Victor Stinner.

* bpo-43244: Remove the "pyarena.h" header file with functions:

  * "PyArena_New()"

  * "PyArena_Free()"

  * "PyArena_Malloc()"

  * "PyArena_AddPyObject()"

  These functions were undocumented, excluded from the limited C API,
  and were only used internally by the compiler. Patch by Victor
  Stinner.

* bpo-43244: Remove the compiler and parser functions using "struct
  _mod" type, because the public AST C API was removed:

  * "PyAST_Compile()"

  * "PyAST_CompileEx()"

  * "PyAST_CompileObject()"

  * "PyFuture_FromAST()"

  * "PyFuture_FromASTObject()"

  * "PyParser_ASTFromFile()"

  * "PyParser_ASTFromFileObject()"

  * "PyParser_ASTFromFilename()"

  * "PyParser_ASTFromString()"

  * "PyParser_ASTFromStringObject()"

  These functions were undocumented and excluded from the limited C
  API. Patch by Victor Stinner.

* bpo-43244: Remove "ast.h", "asdl.h", and "Python-ast.h" header
  files. These functions were undocumented and excluded from the
  limited C API. Most names defined by these header files were not
  prefixed by "Py" and so could create names conflicts. For example,
  "Python-ast.h" defined a "Yield" macro which was conflict with the
  "Yield" name used by the Windows "<winbase.h>" header. Use the
  Python "ast" module instead. Patch by Victor Stinner.

* bpo-43541: Fix a "PyEval_EvalCodeEx()" regression: fix reference
  counting on builtins. Patch by Victor Stinner.

* bpo-43244: Remove the "symtable.h" header file and the undocumented
  functions:

  * "PyST_GetScope()"

  * "PySymtable_Build()"

  * "PySymtable_BuildObject()"

  * "PySymtable_Free()"

  * "Py_SymtableString()"

  * "Py_SymtableStringObject()"

  The "Py_SymtableString()" function was part the stable ABI by
  mistake but it could not be used, because the "symtable.h" header
  file was excluded from the limited C API.

  The Python "symtable" module remains available and is unchanged.

  Patch by Victor Stinner.

* bpo-43244: Remove the "PyAST_Validate()" function. It is no longer
  possible to build a AST object ("mod_ty" type) with the public C
  API. The function was already excluded from the limited C API (**PEP
  384**). Patch by Victor Stinner.


Python 3.10.0 alpha 6
=====================

*Release date: 2021-03-01*


Seguridad
---------

* bpo-42967: Fix web cache poisoning vulnerability by defaulting the
  query args separator to "&", and allowing the user to choose a
  custom separator.


Núcleo y elementos integrados
-----------------------------

* bpo-43321: Fix "SystemError" raised when "PyArg_Parse*()" is used
  with "#" but without "PY_SSIZE_T_CLEAN" defined.

* bpo-36346: "PyArg_Parse*()" functions now emits "DeprecationWarning"
  when "u" or "Z" format is used. See **PEP 623** for detail.

* bpo-43277: Add a new "PySet_CheckExact()" function to the C-API to
  check if an object is an instance of "set" but not an instance of a
  subtype. Patch by Pablo Galindo.

* bpo-42990: The "types.FunctionType" constructor now inherits the
  current builtins if the *globals* dictionary has no ""__builtins__""
  key, rather than using "{"None": None}" as builtins: same behavior
  as "eval()" and "exec()" functions. Defining a function with "def
  function(...): ..." in Python is not affected, globals cannot be
  overridden with this syntax: it also inherits the current builtins.
  Patch by Victor Stinner.

* bpo-42990: Functions have a new "__builtins__" attribute which is
  used to look for builtin symbols when a function is executed,
  instead of looking into "__globals__['__builtins__']". Patch by Mark
  Shannon and Victor Stinner.

* bpo-43149: Improve the error message in the parser for exception
  groups without parentheses. Patch by Pablo Galindo.

* bpo-43121: Fixed an incorrect "SyntaxError" message for missing
  comma in literals. Patch by Pablo Galindo.

* bpo-42819: "readline": Explicitly disable bracketed paste in the
  interactive interpreter, even if it's set in the inputrc, is enabled
  by default (eg GNU Readline 8.1), or a user calls
  "readline.read_init_file()". The Python REPL has not implemented
  bracketed paste support. Also, bracketed mode writes the
  ""\x1b[?2004h"" escape sequence into stdout which causes test
  failures in applications that don't support it. It can still be
  explicitly enabled by calling "readline.parse_and_bind("set enable-
  bracketed-paste on")". Patch by Dustin Rodrigues.

* bpo-42808: Simple calls to "type(object)" are now faster due to the
  "vectorcall" calling convention. Patch by Dennis Sweeney.

* bpo-42217: Make the compiler merges same co_code and co_linetable
  objects in a module like already did for co_consts.

* bpo-41972: Substring search functions such as "str1 in str2" and
  "str2.find(str1)" now sometimes use the "Two-Way" string comparison
  algorithm to avoid quadratic behavior on long strings.

* bpo-42128: Implement **PEP 634** (structural pattern matching).
  Patch by Brandt Bucher.

* bpo-40692: In the "concurrent.futures.ProcessPoolExecutor", validate
  that "multiprocess.synchronize()" is available on a given platform
  and rely on that check in the "concurrent.futures" test suite so we
  can run tests that are unrelated to "ProcessPoolExecutor" on those
  platforms.

* bpo-38302: If "object.__ipow__()" returns "NotImplemented", the
  operator will correctly fall back to "object.__pow__()" and
  "object.__rpow__()" as expected.


Biblioteca
----------

* bpo-43316: The "python -m gzip" command line application now
  properly fails when detecting an unsupported extension. It exits
  with a non-zero exit code and prints an error message to stderr.

* bpo-43317: Set the chunk size for the "gzip" module main function to
  io.DEFAULT_BUFFER_SIZE. This is slightly faster than the 1024 bytes
  constant that was used previously.

* bpo-43146: Handle None in single-arg versions of "print_exception()"
  and "format_exception()".

* bpo-43260: Fix TextIOWrapper can not flush internal buffer forever
  after very large text is written.

* bpo-43258: Prevent needless allocation of "sqlite3" aggregate
  function context when no rows match an aggregate query. Patch by
  Erlend E. Aasland.

* bpo-43251: Improve "sqlite3" error handling: "sqlite3_column_name()"
  failures now result in "MemoryError". Patch by Erlend E. Aasland.

* bpo-40956: Fix segfault in "sqlite3.Connection.backup()" if no
  argument was provided. The regression was introduced by PR 23838.
  Patch by Erlend E. Aasland.

* bpo-43172: The readline module now passes its tests when built
  directly against libedit. Existing irreconcilable API differences
  remain in "readline.get_begidx()" and "readline.get_endidx()"
  behavior based on libreadline vs libedit use.

* bpo-43163: Fix a bug in "codeop" that was causing it to not ask for
  more input when multi-line snippets have unclosed parentheses. Patch
  by Pablo Galindo

* bpo-43162: deprecate unsupported ability to access enum members as
  attributes of other enum members

* bpo-43146: Fix recent regression in None argument handling in
  "traceback" module functions.

* bpo-43102: The namedtuple __new__ method had its __builtins__ set to
  None instead of an actual dictionary.  This created problems for
  introspection tools.

* bpo-43106: Added "O_EVTONLY", "O_FSYNC", "O_SYMLINK" and
  "O_NOFOLLOW_ANY" for macOS. Patch by Dong-hee Na.

* bpo-42960: Adds "resource.RLIMIT_KQUEUES" constant from FreeBSD to
  the "resource" module.

* bpo-42151: Make the pure Python implementation of
  "xml.etree.ElementTree" behave the same as the C implementation
  ("_elementree") regarding default attribute values (by not setting
  "specified_attributes=1").

* bpo-29753: In ctypes, now packed bitfields are calculated properly
  and the first item of packed bitfields is now shrank correctly.


Documentación
-------------

* bpo-27646: Clarify that 'yield from <expr>' works with any iterable,
  not just iterators.

* bpo-36346: Update some deprecated unicode APIs which are documented
  as "will be removed in 4.0" to "3.12". See **PEP 623** for detail.


Pruebas
-------

* bpo-43288: Fix test_importlib to correctly skip Unicode file tests
  if the filesystem does not support them.


Construir
---------

* bpo-43174: Windows build now uses "/utf-8" compiler option.

* bpo-43103: Add a new configure "--without-static-libpython" option
  to not build the "libpythonMAJOR.MINOR.a" static library and not
  install the "python.o" object file.

* bpo-13501: The configure script can now use *libedit* instead of
  *readline* with the command line option "--with-readline=editline".

* bpo-42603: Make configure script use pkg-config to detect the
  location of Tcl/Tk headers and libraries, used to build tkinter.

  On macOS, a Tcl/Tk configuration provided by pkg-config will be
  preferred over Tcl/Tk frameworks installed in
  "/{System/,}Library/Frameworks". If both exist and the latter is
  preferred, the appropriate "--with-tcltk-*" configuration options
  need to be explicitly set.

* bpo-39448: Add the "regen-frozen" makefile target that regenerates
  the code for the frozen "__hello__" module.


Ventanas
--------

* bpo-43155: "PyCMethod_New()" is now present in "python3.lib".


Mac OS
------

* bpo-41837: Update macOS installer build to use OpenSSL 1.1.1j.


INACTIVO
--------

* bpo-43283: Document why printing to IDLE's Shell is often slower
  than printing to a system terminal and that it can be made faster by
  pre-formatting a single string before printing.


API C
-----

* bpo-43278: Always put compiler and system information on the first
  line of the REPL welcome message.

* bpo-43270: Remove the private "_PyErr_OCCURRED()" macro: use the
  public "PyErr_Occurred()" function instead.

* bpo-35134: Move odictobject.h, parser_interface.h,
  picklebufobject.h, pydebug.h, and pyfpe.h into the cpython/
  directory. They must not be included directly, as they are already
  included by Python.h: Include Files.

* bpo-35134: Move pyarena.h, pyctype.h, and pytime.h into the cpython/
  directory. They must not be included directly, as they are already
  included by Python.h: Include Files.

* bpo-40170: "PyExceptionClass_Name()" is now always declared as a
  function, in order to hide implementation details. The macro
  accessed "PyTypeObject.tp_name" directly.  Patch by Erlend E.
  Aasland.

* bpo-43239: The "PyCFunction_New()" function is now exported in the
  ABI when compiled with "-fvisibility=hidden".

* bpo-40170: "PyIter_Check()" is now always declared as a function, in
  order to hide implementation details. The macro accessed
  "PyTypeObject.tp_iternext" directly. Patch by Erlend E. Aasland.

* bpo-40170: Convert "PyDescr_IsData()" macro to a function to hide
  implementation details: The macro accessed
  "PyTypeObject.tp_descr_set" directly. Patch by Erlend E. Aasland.

* bpo-43181: Convert "PyObject_TypeCheck()" macro to a static inline
  function. Patch by Erlend E. Aasland.


Python 3.10.0 alpha 5
=====================

*Release date: 2021-02-02*


Seguridad
---------

* bpo-42938: Avoid static buffers when computing the repr of
  "ctypes.c_double" and "ctypes.c_longdouble" values.


Núcleo y elementos integrados
-----------------------------

* bpo-42990: Refactor the "PyEval_" family of functions.

  * An new function "_PyEval_Vector" is added to simplify calls to
    Python from C.

  * "_PyEval_EvalCodeWithName" is removed

  * "PyEval_EvalCodeEx" is retained as part of the API, but is not
    used internally

* bpo-38631: Replace "Py_FatalError()" calls in the compiler with
  regular "SystemError" exceptions. Patch by Victor Stinner.

* bpo-42997: Improve error message for missing ":" before blocks.
  Patch by Pablo Galindo.

* bpo-43017: Improve error message in the parser when using un-
  parenthesised tuples in comprehensions. Patch by Pablo Galindo.

* bpo-42986: Fix parser crash when reporting syntax errors in f-string
  with newlines. Patch by Pablo Galindo.

* bpo-40176: Syntax errors for unterminated string literals now point
  to the start of the string instead of reporting EOF/EOL.

* bpo-42927: The inline cache for "LOAD_ATTR" now also optimizes
  access to attributes defined by "__slots__". This makes reading such
  attribute up to 30% faster.

* bpo-42864: Improve error messages in the parser when parentheses are
  not closed. Patch by Pablo Galindo.

* bpo-42924: Fix "bytearray" repetition incorrectly copying data from
  the start of the buffer, even if the data is offset within the
  buffer (e.g. after reassigning a slice at the start of the
  "bytearray" to a shorter byte string).

* bpo-42882: Fix the "_PyUnicode_FromId()" function
  (_Py_IDENTIFIER(var) API) when "Py_Initialize()" / "Py_Finalize()"
  is called multiple times: preserve
  "_PyRuntime.unicode_ids.next_index" value.

* bpo-42827: Fix a crash when working out the error line of a
  "SyntaxError" in some multi-line expressions.

* bpo-42823: frame.f_lineno is correct even if frame.f_trace is set to
  True

* bpo-37324: Remove deprecated aliases to Colecciones Clases Base
  Abstractas from the "collections" module.

* bpo-41994: Fixed possible leak in "import" when "sys.modules" is not
  a "dict".

* bpo-27772: In string formatting, preceding the *width* field by
  "'0'" no longer affects the default alignment for strings.


Biblioteca
----------

* bpo-43108: Fixed a reference leak in the "curses" module. Patch by
  Pablo Galindo

* bpo-43077: Update the bundled pip to 21.0.1 and setuptools to
  52.0.0.

* bpo-41282: Deprecate "distutils" in documentation and add warning on
  import.

* bpo-43014: Improve performance of "tokenize" by 20-30%.  Patch by
  Anthony Sottile.

* bpo-42323: Fix "math.nextafter()" for NaN on AIX.

* bpo-42955: Add "sys.stdlib_module_names", containing the list of the
  standard library module names. Patch by Victor Stinner.

* bpo-42944: Fix "random.Random.sample" when "counts" argument is not
  "None".

* bpo-42934: Use "TracebackException"'s new "compact" param in
  "TestResult" to reduce time and memory consumed by traceback
  formatting.

* bpo-42931: Add "randbytes()" to "random.__all__".

* bpo-38250: [Enum] Flags consisting of a single bit are now
  considered canonical, and will be the only flags returned from
  listing and iterating over a Flag class or a Flag member.  Multi-bit
  flags are considered aliases; they will be returned from lookups and
  operations that result in their value. Iteration for both Flag and
  Flag members is in definition order.

* bpo-42877: Added the "compact" parameter to the constructor of
  "traceback.TracebackException" to reduce time and memory for use
  cases that only need to call "TracebackException.format()" and
  "TracebackException.format_exception_only()".

* bpo-42923: The "Py_FatalError()" function and the "faulthandler"
  module now dump the list of extension modules on a fatal error.

* bpo-42848: Removed recursion from "TracebackException" to allow it
  to handle long exception chains.

* bpo-42901: [Enum] move member creation from "EnumMeta.__new__" to
  "_proto_member.__set_name__", allowing members to be created and
  visible in "__init_subclass__".

* bpo-42780: Fix os.set_inheritable() for O_PATH file descriptors on
  Linux.

* bpo-42866: Fix a reference leak in the "getcodec()" function of CJK
  codecs. Patch by Victor Stinner.

* bpo-42846: Convert the 6 CJK codec extension modules (_codecs_cn,
  _codecs_hk, _codecs_iso2022, _codecs_jp, _codecs_kr and _codecs_tw)
  to the multiphase initialization API (**PEP 489**). Patch by Victor
  Stinner.

* bpo-42851: remove __init_subclass__ support for Enum members

* bpo-42834: Make internal caches of the "_json" module compatible
  with subinterpreters.

* bpo-41748: Fix HTMLParser parsing rules for element attributes
  containing commas with spaces. Patch by Karl Dubost.

* bpo-40810: Require SQLite 3.7.15 or newer. Patch by Erlend E.
  Aasland.

* bpo-1635741: Convert the _multibytecodec extension module (CJK
  codecs) to multi-phase initialization (**PEP 489**).  Patch by
  Erlend E. Aasland.

* bpo-42802: The distutils "bdist_wininst" command deprecated in
  Python 3.8 has been removed. The distutils "bdist_wheel" command is
  now recommended to distribute binary packages on Windows.

* bpo-24464: The undocumented built-in function
  "sqlite3.enable_shared_cache" is now deprecated, scheduled for
  removal in Python 3.12.  Its use is strongly discouraged by the
  SQLite3 documentation.  Patch by Erlend E. Aasland.

* bpo-42384: Make pdb populate sys.path[0] exactly the same as regular
  python execution.

* bpo-42383: Fix pdb: previously pdb would fail to restart the
  debugging target if it was specified using a relative path and the
  current directory changed.

* bpo-42005: Fix CLI of "cProfile" and "profile" to catch
  "BrokenPipeError".

* bpo-41604: Don't decrement the reference count of the previous
  user_ptr when set_panel_userptr fails.

* bpo-41149: Allow executing callables that have a boolean value of
  "False" when passed to "Threading.thread" as the target. Patch
  contributed by Barney Stratford.

* bpo-38307: Add an 'end_lineno' attribute to the Class and Function
  objects that appear in the tree returned by pyclbr functions.  This
  and the existing 'lineno' attribute define the extent of class and
  def statements. Patch by Aviral Srivastava.

* bpo-39273: The "BUTTON5_*" constants are now exposed in the "curses"
  module if available.

* bpo-33289: Correct call to "tkinter.colorchooser" to return RGB
  triplet of ints instead of floats.  Patch by Cheryl Sabella.


Documentación
-------------

* bpo-40304: Fix doc for type(name, bases, dict).  Patch by Boris
  Verkhovskiy and Éric Araujo.

* bpo-42811: Updated importlib.utils.resolve_name() doc to use
  __spec__.parent instead of __package__. (Thanks Yair Frid.)


Pruebas
-------

* bpo-40823: Use "unittest.TestLoader().loadTestsFromTestCase()"
  instead of "unittest.makeSuite()" in "sqlite3" tests. Patch by
  Erlend E. Aasland.

* bpo-40810: In "sqlite3", fix "CheckTraceCallbackContent" for SQLite
  pre 3.7.15.


Construir
---------

* bpo-43031: Pass "--timeout=$(TESTTIMEOUT)" option to the default
  profile task "./python -m test --pgo" command.

* bpo-36143: "make regen-all" now also runs "regen-keyword". Patch by
  Victor Stinner.

* bpo-42874: Removed the grep -q and -E flags in the tzpath validation
  section of the configure script to better accommodate users of some
  platforms (specifically Solaris 10).

* bpo-31904: Add library search path by wr-cc in
  add_cross_compiling_paths() for VxWorks.

* bpo-42856: Add "--with-wheel-pkg-dir=PATH" option to the
  "./configure" script. If specified, the "ensurepip" module looks for
  "setuptools" and "pip" wheel packages in this directory: if both are
  present, these wheel packages are used instead of ensurepip bundled
  wheel packages.

  Some Linux distribution packaging policies recommend against
  bundling dependencies. For example, Fedora installs wheel packages
  in the "/usr/share/python-wheels/" directory and don't install the
  "ensurepip._bundled" package.


Ventanas
--------

* bpo-41837: Updated Windows installer to include OpenSSL 1.1.1i

* bpo-42584: Upgrade Windows installer to use SQLite 3.34.0.


Mac OS
------

* bpo-42504: Ensure that the value of
  sysconfig.get_config_var('MACOSX_DEPLOYMENT_TARGET') is always a
  string, even in when the value is parsable as an integer.


INACTIVO
--------

* bpo-43008: Make IDLE invoke "sys.excepthook()" in normal, 2-process
  mode. Patch by Ken Hilton.

* bpo-33065: Fix problem debugging user classes with __repr__ method.

* bpo-23544: Disable Debug=>Stack Viewer when user code is running or
  Debugger is active, to prevent hang or crash.  Patch by Zackery
  Spytz.

* bpo-32631: Finish zzdummy example extension module: make menu
  entries work; add docstrings and tests with 100% coverage.


API C
-----

* bpo-42979: When Python is built in debug mode (with C assertions),
  calling a type slot like "sq_length" ("__len__()" in Python) now
  fails with a fatal error if the slot succeeded with an exception
  set, or failed with no exception set. The error message contains the
  slot, the type name, and the current exception (if an exception is
  set). Patch by Victor Stinner.

* bpo-43030: Fixed a compiler warning in "Py_UNICODE_ISSPACE()" on
  platforms with signed "wchar_t".


Python 3.10.0 alpha 4
=====================

*Release date: 2021-01-04*


Núcleo y elementos integrados
-----------------------------

* bpo-42814: Fix undefined behavior in "Objects/genericaliasobject.c".

* bpo-42806: Fix the column offsets for f-strings "ast" nodes
  surrounded by parentheses and for nodes that spawn multiple lines.
  Patch by Pablo Galindo.

* bpo-40631: Fix regression where a single parenthesized starred
  expression was a valid assignment target.

* bpo-27794: Improve the error message for failed writes/deletes to
  property objects. When possible, the attribute name is now shown.
  Patch provided by Yurii Karabas.

* bpo-42745: Make the type attribute lookup cache per-interpreter.
  Patch by Victor Stinner.

* bpo-42246: Jumps to jumps are not eliminated when it would break PEP
  626.

* bpo-42246: Make sure that the "f_lasti" and "f_lineno" attributes of
  a frame are set correctly when an exception is raised or re-raised.
  Required for PEP 626.

* bpo-32381: The coding cookie (ex: "# coding: latin1") is now ignored
  in the command passed to the "-c" command line option. Patch by
  Victor Stinner.

* bpo-30858: Improve error location in expressions that contain
  assignments. Patch by Pablo Galindo and Lysandros Nikolaou.

* bpo-42615: Remove jump commands made redundant by the deletion of
  unreachable bytecode blocks

* bpo-42639: Make the "atexit" module state per-interpreter. It is now
  safe have more than one "atexit" module instance. Patch by Dong-hee
  Na and Victor Stinner.

* bpo-32381: Fix encoding name when running a ".pyc" file on Windows:
  "PyRun_SimpleFileExFlags()" now uses the correct encoding to decode
  the filename.

* bpo-42195: The "__args__" of the parameterized generics for
  "typing.Callable" and "collections.abc.Callable" are now consistent.
  The "__args__" for "collections.abc.Callable" are now flattened
  while "typing.Callable"'s have not changed.  To allow this change,
  "types.GenericAlias" can now be subclassed and
  "collections.abc.Callable"'s "__class_getitem__" will now return a
  subclass of "types.GenericAlias".  Tests for typing were also
  updated to not subclass things like "Callable[..., T]" as that is
  not a valid base class.  Finally, both "Callable"s no longer
  validate their "argtypes", in "Callable[[argtypes], resulttype]" to
  prepare for **PEP 612**.  Patch by Ken Jin.

* bpo-40137: Convert functools module to use
  "PyType_FromModuleAndSpec()".

* bpo-40077: Convert "array" to use heap types, and establish module
  state for these.

* bpo-42008: Fix _random.Random() seeding.

* bpo-1635741: Port the "pyexpat" extension module to multi-phase
  initialization (**PEP 489**).

* bpo-40521: Make the Unicode dictionary of interned strings
  compatible with subinterpreters. Patch by Victor Stinner.

* bpo-39465: Make "_PyUnicode_FromId()" function compatible with
  subinterpreters. Each interpreter now has an array of identifier
  objects (interned strings decoded from UTF-8). Patch by Victor
  Stinner.


Biblioteca
----------

* bpo-42257: Handle empty string in variable executable in
  platform.libc_ver()

* bpo-42772: randrange() now raises a TypeError when step is specified
  without a stop argument.  Formerly, it silently ignored the step
  argument.

* bpo-42759: Fixed equality comparison of "tkinter.Variable" and
  "tkinter.font.Font". Objects which belong to different Tcl
  interpreters are now always different, even if they have the same
  name.

* bpo-42756: Configure LMTP Unix-domain socket to use socket global
  default timeout when a timeout is not explicitly provided.

* bpo-23328: Allow / character in username, password fields on _PROXY
  envars.

* bpo-42740: "typing.get_args()" and "typing.get_origin()" now support
  **PEP 604** union types and **PEP 612** additions to "Callable".

* bpo-42655: "subprocess" *extra_groups* is now correctly passed into
  setgroups() system call.

* bpo-42727: "EnumMeta.__prepare__" now accepts "**kwds" to properly
  support "__init_subclass__"

* bpo-38308: Add optional *weights* to *statistics.harmonic_mean()*.

* bpo-42721: When simple query dialogs ("tkinter.simpledialog"),
  message boxes ("tkinter.messagebox") or color choose dialog
  ("tkinter.colorchooser") are created without arguments *master* and
  *parent*, and the default root window is not yet created, and
  "NoDefaultRoot()" was not called, a new temporal hidden root window
  will be created automatically. It will not be set as the default
  root window and will be destroyed right after closing the dialog
  window. It will help to use these simple dialog windows in programs
  which do not need other GUI.

* bpo-25246: Optimized "collections.deque.remove()".

* bpo-35728: Added a root parameter to "tkinter.font.nametofont()".

* bpo-15303: "tkinter" supports now widgets with boolean value False.

* bpo-42681: Fixed range checks for color and pair numbers in
  "curses".

* bpo-42685: Improved placing of simple query windows in Tkinter (such
  as "tkinter.simpledialog.askinteger()"). They are now centered at
  the center of the parent window if it is specified and shown,
  otherwise at the center of the screen.

* bpo-9694: Argparse help no longer uses the confusing phrase,
  "optional arguments". It uses "options" instead.

* bpo-1635741: Port the "_thread" extension module to the multiphase
  initialization API (**PEP 489**) and convert its static types to
  heap types.

* bpo-37961: Fix crash in "tracemalloc.Traceback.__repr__()"
  (regressed in Python 3.9).

* bpo-42630: "tkinter" functions and constructors which need a default
  root window raise now "RuntimeError" with descriptive message
  instead of obscure "AttributeError" or "NameError" if it is not
  created yet or cannot be created automatically.

* bpo-42639: "atexit._run_exitfuncs()" now logs callback exceptions
  using "sys.unraisablehook", rather than logging them directly into
  "sys.stderr" and raise the last exception.

* bpo-42644: "logging.disable" will now validate the types and value
  of its parameter. It also now accepts strings representing the
  levels (as does "loging.setLevel") instead of only the numerical
  values.

* bpo-42639: At Python exit, if a callback registered with
  "atexit.register()" fails, its exception is now logged. Previously,
  only some exceptions were logged, and the last exception was always
  silently ignored.

* bpo-36541: Fixed lib2to3.pgen2 to be able to parse PEP-570
  positional only argument syntax.

* bpo-42382: In "importlib.metadata": -  "EntryPoint" objects now
  expose a ".dist" object referencing the "Distribution" when
  constructed from a "Distribution". - Add support for package
  discovery under package normalization rules. - The object returned
  by "metadata()" now has a formally defined protocol called
  "PackageMetadata" with declared support for the ".get_all()" method.
  - Synced with importlib_metadata 3.3.

* bpo-41877: A check is added against misspellings of autospect,
  auto_spec and set_spec being passed as arguments to patch,
  patch.object and create_autospec.

* bpo-39717: [tarfile] update nested exception raising to use "from
  None" or "from e"

* bpo-41877: AttributeError for suspected misspellings of assertions
  on mocks are now pointing out that the cause are misspelled
  assertions and also what to do if the misspelling is actually an
  intended attribute name. The unittest.mock document is also updated
  to reflect the current set of recognised misspellings.

* bpo-41559: Implemented **PEP 612**: added "ParamSpec" and
  "Concatenate" to "typing".  Patch by Ken Jin.

* bpo-42385: StrEnum: fix _generate_next_value_ to return a str

* bpo-31904: Define THREAD_STACK_SIZE for VxWorks.

* bpo-34750: [Enum] "_EnumDict.update()" is now supported

* bpo-42517: Enum: private names do not become members / do not
  generate errors -- they remain normal attributes

* bpo-42678: "Enum": call "__init_subclass__" after members have been
  added

* bpo-28964: "ast.literal_eval()" adds line number information (if
  available) in error message for malformed nodes.

* bpo-42470: "random.sample()" no longer warns on a sequence which is
  also a set.

* bpo-31904: "posixpath.expanduser()" returns the input *path*
  unchanged if user home directory is None on VxWorks.

* bpo-42388: Fix subprocess.check_output(..., input=None) behavior
  when text=True to be consistent with that of the documentation and
  universal_newlines=True.

* bpo-34463: Fixed discrepancy between "traceback" and the interpreter
  in formatting of SyntaxError with lineno not set ("traceback" was
  changed to match interpreter).

* bpo-42393: Raise "OverflowError" instead of silent truncation in
  "socket.ntohs()" and "socket.htons()".  Silent truncation was
  deprecated in Python 3.7. Patch by Erlend E. Aasland

* bpo-42222: Harmonized "random.randrange()" argument handling to
  match "range()".

  * The integer test and conversion in "randrange()" now uses
    "operator.index()".

  * Non-integer arguments to "randrange()" are deprecated.

  * The "ValueError" is deprecated in favor of a "TypeError".

  * It now runs a little faster than before.

  (Contributed by Raymond Hettinger and Serhiy Storchaka.)

* bpo-42163: Restore compatibility for "uname_result" around deepcopy
  and _replace.

* bpo-42090: "zipfile.Path.joinpath" now accepts arbitrary arguments,
  same as "pathlib.Path.joinpath".

* bpo-1635741: Port the _csv module to the multi-phase initialization
  API (**PEP 489**).

* bpo-42059: "typing.TypedDict" types created using the alternative
  call-style syntax now correctly respect the "total" keyword argument
  when setting their "__required_keys__" and "__optional_keys__" class
  attributes.

* bpo-41960: Add "globalns" and "localns" parameters to the
  "inspect.signature()" and "inspect.Signature.from_callable()".

* bpo-41907: fix "format()" behavior for "IntFlag"

* bpo-41891: Ensure asyncio.wait_for waits for task completion

* bpo-24792: Fixed bug where "zipimporter" sometimes reports an
  incorrect cause of import errors.

* bpo-31904: Fix site and sysconfig modules for VxWorks RTOS which has
  no home directories.

* bpo-41462: Add "os.set_blocking()" support for VxWorks RTOS.

* bpo-40219: Lowered "tkinter.ttk.LabeledScale" dummy widget to
  prevent hiding part of the content label.

* bpo-37193: Fixed memory leak in "socketserver.ThreadingMixIn"
  introduced in Python 3.7.

* bpo-39068: Fix initialization race condition in "a85encode()" and
  "b85encode()" in "base64". Patch by Brandon Stansbury.


Documentación
-------------

* bpo-17140: Add documentation for the
  "multiprocessing.pool.ThreadPool" class.

* bpo-34398: Prominently feature listings from the glossary in
  documentation search results. Patch by Ammar Askar.


Pruebas
-------

* bpo-42794: Update test_nntplib to use official group name of
  news.aioe.org for testing. Patch by Dong-hee Na.

* bpo-31904: Skip some asyncio tests on VxWorks.

* bpo-42641: Enhance "test_select.test_select()": it now takes 500 ms
  rather than 10 seconds. Use Python rather than a shell to make the
  test more portable.

* bpo-31904: Skip some tests in _test_all_chown_common() on VxWorks.

* bpo-42199: Fix bytecode helper assertNotInBytecode.

* bpo-41443: Add more attribute checking in test_posix.py

* bpo-31904: Disable os.popen and impacted tests on VxWorks

* bpo-41439: Port test_ssl and test_uuid to VxWorks RTOS.


Construir
---------

* bpo-42692: Fix __builtin_available check on older compilers. Patch
  by Joshua Root.

* bpo-27640: Added "--disable-test-modules" option to the "configure"
  script: don't build nor install test modules. Patch by Xavier de
  Gaye, Thomas Petazzoni and Peixing Xin.

* bpo-42604: Now all platforms use a value for the "EXT_SUFFIX" build
  variable derived from SOABI (for instance in freeBSD, "EXT_SUFFIX"
  is now ".cpython-310d.so" instead of ".so"). Previously only Linux,
  Mac and VxWorks were using a value for "EXT_SUFFIX" that included
  "SOABI".

* bpo-42598: Fix implicit function declarations in configure which
  could have resulted in incorrect configuration checks.  Patch
  contributed by Joshua Root.

* bpo-31904: Enable libpython3.so for VxWorks.

* bpo-29076: Add fish shell support to macOS installer.


Mac OS
------

* bpo-42361: Update macOS installer build to use Tcl/Tk 8.6.11 (rc2,
  expected to be final release).

* bpo-41837: Update macOS installer build to use OpenSSL 1.1.1i.

* bpo-42584: Update macOS installer to use SQLite 3.34.0.


Herramientas / Demos
--------------------

* bpo-42726: Fixed Python 3 compatibility issue with gdb/libpython.py
  handling of attribute dictionaries.

* bpo-42613: Fix "freeze.py" tool to use the prope config and library
  directories. Patch by Victor Stinner.


API C
-----

* bpo-42591: Export the "Py_FrozenMain()" function: fix a Python 3.9.0
  regression. Python 3.9 uses "-fvisibility=hidden" and the function
  was not exported explicitly and so not exported.

* bpo-32381: Remove the private "_Py_fopen()" function which is no
  longer needed. Use "_Py_wfopen()" or "_Py_fopen_obj()" instead.
  Patch by Victor Stinner.

* bpo-1635741: Port "resource" extension module to module state

* bpo-42111: Update the "xxlimited" module to be a better example of
  how to use the limited C API.

* bpo-40052: Fix an alignment build warning/error in function
  "PyVectorcall_Function()". Patch by Andreas Schneider, Antoine
  Pitrou and Petr Viktorin.


Python 3.10.0 alpha 3
=====================

*Release date: 2020-12-07*


Seguridad
---------

* bpo-40791: Add "volatile" to the accumulator variable in
  "hmac.compare_digest", making constant-time-defeating optimizations
  less likely.


Núcleo y elementos integrados
-----------------------------

* bpo-42576: "types.GenericAlias" will now raise a "TypeError" when
  attempting to initialize with a keyword argument.  Previously, this
  would cause the interpreter to crash if the interpreter was compiled
  with debug symbols. This does not affect interpreters compiled for
  release.  Patch by Ken Jin.

* bpo-42536: Several built-in and standard library types now ensure
  that their internal result tuples are always tracked by the *garbage
  collector*:

  * "collections.OrderedDict.items()"

  * "dict.items()"

  * "enumerate()"

  * "functools.reduce()"

  * "itertools.combinations()"

  * "itertools.combinations_with_replacement()"

  * "itertools.permutations()"

  * "itertools.product()"

  * "itertools.zip_longest()"

  * "zip()"

  Previously, they could have become untracked by a prior garbage
  collection. Patch by Brandt Bucher.

* bpo-42500: Improve handling of exceptions near recursion limit.
  Converts a number of Fatal Errors in RecursionErrors.

* bpo-42246: PEP 626: After a return, the f_lineno attribute of a
  frame is always the last line executed.

* bpo-42435: Speed up comparison of bytes objects with non-bytes
  objects when option "-b" is specified. Speed up comparison of
  bytarray objects with non-buffer object.

* bpo-1635741: Port the "_warnings" extension module to the multi-
  phase initialization API (**PEP 489**). Patch by Victor Stinner.

* bpo-41686: On Windows, the "SIGINT" event, "_PyOS_SigintEvent()", is
  now created even if Python is configured to not install signal
  handlers (if "PyConfig.install_signal_handlers" equals to 0, or
  "Py_InitializeEx(0)").

* bpo-42381: Allow assignment expressions in set literals and set
  comprehensions as per PEP 572. Patch by Pablo Galindo.

* bpo-42202: Change function parameters annotations internal
  representation to tuple of strings. Patch provided by Yurii Karabas.

* bpo-42374: Fix a regression introduced by the new parser, where an
  unparenthesized walrus operator was not allowed within generator
  expressions.

* bpo-42316: Allow an unparenthesized walrus in subscript indexes.

* bpo-42349: Make sure that the compiler front-end produces a well-
  formed control flow graph. Be be more aggressive in the compiler
  back-end, as it is now safe to do so.

* bpo-42296: On Windows, fix a regression in signal handling which
  prevented to interrupt a program using CTRL+C. The signal handler
  can be run in a thread different than the Python thread, in which
  case the test deciding if the thread can handle signals is wrong.

* bpo-42332: "types.GenericAlias" objects can now be the targets of
  weakrefs.

* bpo-42282: Optimise constant subexpressions that appear as part of
  named expressions (previously the AST optimiser did not descend into
  named expressions). Patch by Nick Coghlan.

* bpo-42266: Fixed a bug with the LOAD_ATTR opcode cache that was not
  respecting monkey-patching a class-level attribute to make it a
  descriptor. Patch by Pablo Galindo.

* bpo-40077: Convert "queue" to use heap types.

* bpo-42246: Improved accuracy of line tracing events and f_lineno
  attribute of Frame objects. See PEP 626 for details.

* bpo-40077: Convert "mmap" to use heap types.

* bpo-42233: Allow "GenericAlias" objects to use union type
  expressions. This allows expressions like "list[int] | dict[float,
  str]" where previously a "TypeError" would have been thrown.  This
  also fixes union type expressions not de-duplicating "GenericAlias"
  objects. (Contributed by Ken Jin in bpo-42233.)

* bpo-26131: The import system triggers a "ImportWarning" when it
  falls back to using "load_module()".


Biblioteca
----------

* bpo-5054: CGIHTTPRequestHandler.run_cgi() HTTP_ACCEPT improperly
  parsed. Replace the special purpose getallmatchingheaders with
  generic get_all method and add relevant tests.

  Original Patch by Martin Panter. Modified by Senthil Kumaran.

* bpo-42562: Fix issue when dis failed to parse function that has no
  line numbers. Patch provided by Yurii Karabas.

* bpo-17735: "inspect.findsource()" now raises "OSError" instead of
  "IndexError" when "co_lineno" of a code object is greater than the
  file length. This can happen, for example, when a file is edited
  after it was imported.  PR by Irit Katriel.

* bpo-42116: Fix handling of trailing comments by
  "inspect.getsource()".

* bpo-42532: Remove unexpected call of "__bool__" when passing a
  "spec_arg" argument to a Mock.

* bpo-38200: Added itertools.pairwise()

* bpo-41818: Fix test_master_read() so that it succeeds on all
  platforms that either raise OSError or return b"" upon reading from
  master.

* bpo-42487: ChainMap.__iter__ no longer calls __getitem__ on
  underlying maps

* bpo-42482: "TracebackException" no longer holds a reference to the
  exception's traceback object. Consequently, instances of
  TracebackException for equivalent but non-equal exceptions now
  compare as equal.

* bpo-41818: Make test_openpty() avoid unexpected success due to
  number of rows and/or number of columns being == 0.

* bpo-42392: Remove loop parameter from "asyncio.subprocess" and
  "asyncio.tasks" functions. Patch provided by Yurii Karabas.

* bpo-42392: Remove loop parameter from "asyncio.open_connection" and
  "asyncio.start_server" functions. Patch provided by Yurii Karabas.

* bpo-28468: Add "platform.freedesktop_os_release()" function to parse
  freedesktop.org "os-release" files.

* bpo-42299: Removed the "formatter" module, which was deprecated in
  Python 3.4. It is somewhat obsolete, little used, and not tested. It
  was originally scheduled to be removed in Python 3.6, but such
  removals were delayed until after Python 2.7 EOL. Existing users
  should copy whatever classes they use into their code. Patch by
  Dong-hee Na and and Terry J. Reedy.

* bpo-26131: Deprecate zipimport.zipimporter.load_module() in favour
  of exec_module().

* bpo-41818: Updated tests for the pty library. test_basic() has been
  changed to test_openpty(); this additionally checks if slave termios
  and slave winsize are being set properly by pty.openpty(). In order
  to add support for FreeBSD, NetBSD, OpenBSD, and Darwin, this also
  adds test_master_read(), which demonstrates that pty.spawn() should
  not depend on an OSError to exit from its copy loop.

* bpo-42392: Remove loop parameter from "__init__" in all
  "asyncio.locks" and "asyncio.Queue" classes. Patch provided by Yurii
  Karabas.

* bpo-15450: Make "filecmp.dircmp" respect subclassing. Now the
  "filecmp.dircmp.subdirs" behaves as expected when subclassing
  dircmp.

* bpo-42413: The exception "socket.timeout" is now an alias of
  "TimeoutError".

* bpo-31904: Support signal module on VxWorks.

* bpo-42406: We fixed an issue in "pickle.whichmodule" in which
  importing "multiprocessing" could change the how pickle identifies
  which module an object belongs to, potentially breaking the
  unpickling of those objects.

* bpo-42403: Simplify the "importlib" external bootstrap code:
  "importlib._bootstrap_external" now uses regular imports to import
  builtin modules. When it is imported, the builtin "__import__()"
  function is already fully working and so can be used to import
  builtin modules like "sys". Patch by Victor Stinner.

* bpo-1635741: Convert _sre module types to heap types (PEP 384).
  Patch by Erlend E. Aasland.

* bpo-42375: subprocess module update for DragonFlyBSD support.

* bpo-41713: Port the "_signal" extension module to the multi-phase
  initialization API (**PEP 489**). Patch by Victor Stinner and
  Mohamed Koubaa.

* bpo-37205: "time.time()", "time.perf_counter()" and
  "time.monotonic()" functions can no longer fail with a Python fatal
  error, instead raise a regular Python exception on failure.

* bpo-42328: Fixed "tkinter.ttk.Style.map()". The function accepts now
  the representation of the default state as empty sequence (as
  returned by "Style.map()"). The structure of the result is now the
  same on all platform and does not depend on the value of
  "wantobjects".

* bpo-42345: Fix various issues with "typing.Literal" parameter
  handling (flatten, deduplicate, use type to cache key). Patch
  provided by Yurii Karabas.

* bpo-37205: "time.perf_counter()" on Windows and "time.monotonic()"
  on macOS are now system-wide. Previously, they used an offset
  computed at startup to reduce the precision loss caused by the float
  type. Use "time.perf_counter_ns()" and "time.monotonic_ns()" added
  in Python 3.7 to avoid this precision loss.

* bpo-42318: Fixed support of non-BMP characters in "tkinter" on
  macOS.

* bpo-42350: Fix the "threading.Thread" class at fork: do nothing if
  the thread is already stopped (ex: fork called at Python exit).
  Previously, an error was logged in the child process.

* bpo-42333: Port _ssl extension module to heap types.

* bpo-42014: The "onerror" callback from "shutil.rmtree" now receives
  correct function when "os.open" fails.

* bpo-42237: Fix "os.sendfile()" on illumos.

* bpo-42308: Add "threading.__excepthook__" to allow retrieving the
  original value of "threading.excepthook()" in case it is set to a
  broken or a different value. Patch by Mario Corchero.

* bpo-42131: Implement PEP 451/spec methods on zipimport.zipimporter:
  find_spec(), create_module(), and exec_module().

  This also allows for the documented deprecation of find_loader(),
  find_module(), and load_module().

* bpo-41877: Mock objects which are not unsafe will now raise an
  AttributeError if an attribute with the prefix asert, aseert, or
  assrt is accessed, in addition to this already happening for the
  prefixes assert or assret.

* bpo-42264: "sqlite3.OptimizedUnicode" has been undocumented and
  obsolete since Python 3.3, when it was made an alias to "str".  It
  is now deprecated, scheduled for removal in Python 3.12.

* bpo-42251: Added "threading.gettrace()" and "threading.getprofile()"
  to retrieve the functions set by "threading.settrace()" and
  "threading.setprofile()" respectively. Patch by Mario Corchero.

* bpo-42249: Fixed writing binary Plist files larger than 4 GiB.

* bpo-42236: On Unix, the "os.device_encoding()" function now returns
  "'UTF-8'" rather than the device encoding if the Python UTF-8 Mode
  is enabled.

* bpo-41754: webbrowser: Ignore *NotADirectoryError* when calling
  "xdg-settings".

* bpo-42183: Fix a stack overflow error for asyncio Task or Future
  repr().

  The overflow occurs under some circumstances when a Task or Future
  recursively returns itself.

* bpo-42140: Improve asyncio.wait function to create the futures set
  just one time.

* bpo-42133: Update various modules in the stdlib to fall back on
  "__spec__.loader" when "__loader__" isn't defined on a module.

* bpo-26131: The "load_module()" methods found in importlib now
  trigger a DeprecationWarning.

* bpo-39825: Windows: Change "sysconfig.get_config_var('EXT_SUFFIX')"
  to the expected full "platform_tag.extension" format. Previously it
  was hard-coded to ".pyd", now it is compatible with
  "distutils.sysconfig" and will result in something like
  ".cp38-win_amd64.pyd". This brings windows into conformance with the
  other platforms.

* bpo-26389: The "traceback.format_exception()",
  "traceback.format_exception_only()", and
  "traceback.print_exception()" functions can now take an exception
  object as a positional-only argument.

* bpo-41889: Enum: fix regression involving inheriting a multiply
  inherited enum

* bpo-41861: Convert "sqlite3" to use heap types (PEP 384). Patch by
  Erlend E. Aasland.

* bpo-40624: Added support for the XPath "!=" operator in xml.etree

* bpo-28850: Fix "pprint.PrettyPrinter.format()" overrides being
  ignored for contents of small containers. The "pprint._safe_repr()"
  function was removed.

* bpo-41625: Expose the "splice()" as "os.splice()" in the "os"
  module. Patch by Pablo Galindo

* bpo-34215: Clarify the error message for
  "asyncio.IncompleteReadError" when "expected" is "None".

* bpo-41543: Add async context manager support for
  contextlib.nullcontext.

* bpo-21041: "pathlib.PurePath.parents" now supports negative
  indexing. Patch contributed by Yaroslav Pankovych.

* bpo-41332: Added missing connect_accepted_socket() method to
  "asyncio.AbstractEventLoop".

* bpo-12800: Extracting a symlink from a tarball should succeed and
  overwrite the symlink if it already exists. The fix is to remove the
  existing file or symlink before extraction. Based on patch by Chris
  AtLee, Jeffrey Kintscher, and Senthil Kumaran.

* bpo-40968: "urllib.request" and "http.client" now send "http/1.1"
  ALPN extension during TLS handshake when no custom context is
  supplied.

* bpo-41001: Add func:"os.eventfd" to provide a low level interface
  for Linux's event notification file descriptor.

* bpo-40816: Add AsyncContextDecorator to contextlib to support async
  context manager as a decorator.

* bpo-40550: Fix time-of-check/time-of-action issue in
  subprocess.Popen.send_signal.

* bpo-39411: Add an "is_async" identifier to "pyclbr"'s "Function"
  objects. Patch by Batuhan Taskaya

* bpo-35498: Add slice support to "pathlib.PurePath.parents".


Documentación
-------------

* bpo-42238: Tentative to deprecate "make suspicious" by first
  removing it from the CI and documentation builds, but keeping it
  around for manual uses.

* bpo-42153: Fix the URL for the IMAP protocol documents.

* bpo-41028: Language and version switchers, previously maintained in
  every cpython branches, are now handled by docsbuild-script.


Pruebas
-------

* bpo-41473: Re-enable test_gdb on gdb 9.2 and newer:
  https://bugzilla.redhat.com/show_bug.cgi?id=1866884 bug is fixed in
  gdb 10.1.

* bpo-42553: Fix "test_asyncio.test_call_later()" race condition:
  don't measure asyncio performance in the "call_later()" unit test.
  The test failed randomly on the CI.

* bpo-31904: Fix test_netrc on VxWorks: create temporary directories
  using temp_cwd().

* bpo-31904: skip test_getaddrinfo_ipv6_scopeid_symbolic and
  test_getnameinfo_ipv6_scopeid_symbolic on VxWorks

* bpo-31904: skip test_test of test_mailcap on VxWorks

* bpo-31904: add shell requirement for test_pipes

* bpo-31904: skip some tests related to fifo on VxWorks

* bpo-31904: Fix test_doctest.py failures for VxWorks.

* bpo-40754: Include "_testinternalcapi" module in Windows installer
  for test suite

* bpo-41561: test_ssl: skip test_min_max_version_mismatch when TLS 1.0
  is not available

* bpo-31904: Fix os module failures for VxWorks RTOS.

* bpo-31904: Fix fifo test cases for VxWorks RTOS.


Construir
---------

* bpo-31904: remove libnet dependency from detect_socket() for VxWorks

* bpo-42398: Fix a race condition in "make regen-all" when make -jN
  option is used to run jobs in parallel. The clinic.py script now
  only use atomic write to write files. Moveover, generated files are
  now left unchanged if the content does not change, to not change the
  file modification time.

* bpo-41617: Fix building "pycore_bitutils.h" internal header on old
  clang version without "__builtin_bswap16()" (ex: Xcode 4.6.3 on Mac
  OS X 10.7). Patch by Joshua Root and Victor Stinner.

* bpo-38823: It is no longer possible to build the "_ctypes" extension
  module without "wchar_t" type: remove "CTYPES_UNICODE" macro.
  Anyway, the "wchar_t" type is required to build Python. Patch by
  Victor Stinner.

* bpo-42087: Support was removed for AIX 5.3 and below. See bpo-40680.

* bpo-40998: Addressed three compiler warnings found by undefined
  behavior sanitizer (ubsan).


Ventanas
--------

* bpo-42120: Remove macro definition of "copysign" (to "_copysign") in
  headers.

* bpo-38506: The Windows launcher now properly handles Python 3.10
  when listing installed Python versions.


Mac OS
------

* bpo-42504: Fix build on macOS Big Sur when
  MACOSX_DEPLOYMENT_TARGET=11

* bpo-41116: Ensure distutils.unixxcompiler.find_library_file can find
  system provided libraries on macOS 11.

* bpo-41100: Add support for macOS 11 and Apple Silicon systems.

  It is now possible to build "Universal 2" binaries using "--enable-
  universalsdk --with-universal-archs=universal2".

  Binaries build on later macOS versions can be deployed back to older
  versions (tested up to macOS 10.9), when using the correct
  deployment target. This is tested using Xcode 11 and later.

* bpo-42232: Added Darwin specific madvise options to mmap module.

* bpo-38443: The "--enable-universalsdk" and "--with-universal-archs"
  options for the configure script now check that the specified
  architectures can be used.


INACTIVO
--------

* bpo-42508: Keep IDLE running on macOS.  Remove obsolete workaround
  that prevented running files with shortcuts when using new
  universal2 installers built on macOS 11.

* bpo-42426: Fix reporting offset of the RE error in searchengine.

* bpo-42415: Get docstrings for IDLE calltips more often by using
  inspect.getdoc.


Herramientas / Demos
--------------------

* bpo-42212: The smelly.py script now also checks the Python dynamic
  library and extension modules, not only the Python static library.
  Make also the script more verbose: explain what it does.

* bpo-36310: Allow "Tools/i18n/pygettext.py" to detect calls to
  "gettext" in f-strings.


API C
-----

* bpo-42423: The "PyType_FromSpecWithBases()" and
  "PyType_FromModuleAndSpec()" functions now accept a single class as
  the *bases* argument.

* bpo-1635741: Port "select" extension module to multiphase
  initialization (**PEP 489**).

* bpo-1635741: Port _posixsubprocess extension module to multiphase
  initialization (**PEP 489**).

* bpo-1635741: Port _posixshmem extension module to multiphase
  initialization (**PEP 489**)

* bpo-1635741: Port _struct extension module to multiphase
  initialization (**PEP 489**)

* bpo-1635741: Port "spwd" extension module to multiphase
  initialization (**PEP 489**)

* bpo-1635741: Port "gc" extension module to multiphase initialization
  (**PEP 489**)

* bpo-1635741: Port _queue extension module to multiphase
  initialization (**PEP 489**)

* bpo-39573: Convert "Py_TYPE()" and "Py_SIZE()" back to macros to
  allow using them as an l-value. Many third party C extension modules
  rely on the ability of using Py_TYPE() and Py_SIZE() to set an
  object type and size: "Py_TYPE(obj) = type;" and "Py_SIZE(obj) =
  size;".

* bpo-1635741: Port "symtable" extension module to multiphase
  initialization (**PEP 489**)

* bpo-1635741: Port "grp" and "pwd" extension modules to multiphase
  initialization (**PEP 489**)

* bpo-1635741: Port _random extension module to multiphase
  initialization (**PEP 489**)

* bpo-1635741: Port _hashlib extension module to multiphase
  initialization (**PEP 489**)

* bpo-41713: Removed the undocumented "PyOS_InitInterrupts()"
  function. Initializing Python already implicitly installs signal
  handlers: see "PyConfig.install_signal_handlers". Patch by Victor
  Stinner.

* bpo-40170: The "Py_TRASHCAN_BEGIN" macro no longer accesses
  PyTypeObject attributes, but now can get the condition by calling
  the new private "_PyTrash_cond()" function which hides
  implementation details.

* bpo-42260: "Py_GetPath()", "Py_GetPrefix()", "Py_GetExecPrefix()",
  "Py_GetProgramFullPath()", "Py_GetPythonHome()" and
  "Py_GetProgramName()" functions now return "NULL" if called before
  "Py_Initialize()" (before Python is initialized). Use the new Python
  Initialization Configuration API to get the Python Path
  Configuration.. Patch by Victor Stinner.

* bpo-42260: The "PyConfig_Read()" function now only parses
  "PyConfig.argv" arguments once: "PyConfig.parse_argv" is set to "2"
  after arguments are parsed. Since Python arguments are strippped
  from "PyConfig.argv", parsing arguments twice would parse the
  application options as Python options.

* bpo-42262: Added "Py_NewRef()" and "Py_XNewRef()" functions to
  increment the reference count of an object and return the object.
  Patch by Victor Stinner.

* bpo-42260: When "Py_Initialize()" is called twice, the second call
  now updates more "sys" attributes for the configuration, rather than
  only "sys.argv". Patch by Victor Stinner.

* bpo-41832: The "PyType_FromModuleAndSpec()" function now accepts
  NULL "tp_doc" slot.

* bpo-1635741: Added "PyModule_AddObjectRef()" function: similar to
  "PyModule_AddObject()" but don't steal a reference to the value on
  success. Patch by Victor Stinner.

* bpo-42171: The "METH_FASTCALL" calling convention is added to the
  limited API. The functions  "PyModule_AddType()",
  "PyType_FromModuleAndSpec()", "PyType_GetModule()" and
  "PyType_GetModuleState()" are added to the limited API on Windows.

* bpo-42085: Add dedicated entry to PyAsyncMethods for sending values

* bpo-41073: "PyType_GetSlot()" can now accept static types.

* bpo-30459: "PyList_SET_ITEM()", "PyTuple_SET_ITEM()" and
  "PyCell_SET()" macros can no longer be used as l-value or r-value.
  For example, "x = PyList_SET_ITEM(a, b, c)" and "PyList_SET_ITEM(a,
  b, c) = x" now fail with a compiler error. It prevents bugs like "if
  (PyList_SET_ITEM (a, b, c) < 0) ..." test. Patch by Zackery Spytz
  and Victor Stinner.


Python 3.10.0 alpha 2
=====================

*Release date: 2020-11-03*


Seguridad
---------

* bpo-42103: Prevented potential DoS attack via CPU and RAM exhaustion
  when processing malformed Apple Property List files in binary
  format.

* bpo-42051: The "plistlib" module no longer accepts entity
  declarations in XML plist files to avoid XML vulnerabilities. This
  should not affect users as entity declarations are not used in
  regular plist files.


Núcleo y elementos integrados
-----------------------------

* bpo-42236: If the "nl_langinfo(CODESET)" function returns an empty
  string, Python now uses UTF-8 as the filesystem encoding. Patch by
  Victor Stinner.

* bpo-42218: Fixed a bug in the PEG parser that was causing crashes in
  debug mode. Now errors are checked in left-recursive rules to avoid
  cases where such errors do not get handled in time and appear as
  long-distance crashes in other places.

* bpo-42214: Fixed a possible crash in the PEG parser when checking
  for the '!=' token in the "barry_as_flufl" rule. Patch by Pablo
  Galindo.

* bpo-42206: Propagate and raise the errors caused by
  "PyAST_Validate()" in the parser.

* bpo-41796: The "ast" module internal state is now per interpreter.
  Patch by Victor Stinner.

* bpo-42143: Fix handling of errors during creation of
  "PyFunctionObject", which resulted in operations on uninitialized
  memory. Patch by Yonatan Goldschmidt.

* bpo-41659: Fix a bug in the parser, where a curly brace following a
  "primary" didn't fail immediately. This led to invalid expressions
  like "a {b}" to throw a "SyntaxError" with a wrong offset, or
  invalid expressions ending with a curly brace like "a {" to not fail
  immediately in the REPL.

* bpo-42150: Fix possible buffer overflow in the new parser when
  checking for continuation lines. Patch by Pablo Galindo.

* bpo-42123: Run the parser two times. On the first run, disable all
  the rules that only generate better error messages to gain
  performance. If there's a parse failure, run the parser a second
  time with those enabled.

* bpo-42093: The "LOAD_ATTR" instruction now uses new "per opcode
  cache" mechanism and it is about 36% faster now. Patch by Pablo
  Galindo and Yury Selivanov.

* bpo-42030: Support for the legacy AIX-specific shared library
  loading support has been removed. All versions of AIX since 4.3 have
  supported and defaulted to using the common Unix mechanism instead.

* bpo-41984: The garbage collector now tracks all user-defined
  classes. Patch by Brandt Bucher.

* bpo-41993: Fixed potential issues with removing not completely
  initialized module from "sys.modules" when import fails.

* bpo-41979: Star-unpacking is now allowed for with item's targets in
  the PEG parser.

* bpo-41974: Removed special methods "__int__", "__float__",
  "__floordiv__", "__mod__", "__divmod__", "__rfloordiv__", "__rmod__"
  and "__rdivmod__" of the "complex" class.  They always raised a
  "TypeError".

* bpo-41902: Micro optimization when compute "sq_item" and
  "mp_subscript" of "range". Patch by Dong-hee Na.

* bpo-41894: When loading a native module and a load failure occurs,
  prevent a possible UnicodeDecodeError when not running in a UTF-8
  locale by decoding the load error message using the current locale's
  encoding.

* bpo-41902: Micro optimization for range.index if step is 1. Patch by
  Dong-hee Na.

* bpo-41435: Add "sys._current_exceptions()" function to retrieve a
  dictionary mapping each thread's identifier to the topmost exception
  currently active in that thread at the time the function is called.

* bpo-38605: Enable "from __future__ import annotations" (**PEP 563**)
  by default. The values found in "__annotations__" dicts are now
  strings, e.g. "{"x": "int"}" instead of "{"x": int}".


Biblioteca
----------

* bpo-35455: On Solaris, "thread_time()" is now implemented with
  "gethrvtime()" because "clock_gettime(CLOCK_THREAD_CPUTIME_ID)" is
  not always available. Patch by Jakub Kulik.

* bpo-42233: The "repr()" of "typing" types containing Generic Alias
  Types previously did not show the parameterized types in the
  "GenericAlias".  They have now been changed to do so.

* bpo-29566: "binhex.binhex()" consistently writes macOS 9 line
  endings.

* bpo-26789: The "logging.FileHandler" class now keeps a reference to
  the builtin "open()" function to be able to open or reopen the file
  during Python finalization. Fix errors like: "NameError: name 'open'
  is not defined". Patch by Victor Stinner.

* bpo-42157: Removed the "unicodedata.ucnhash_CAPI" attribute which
  was an internal PyCapsule object. The related private
  "_PyUnicode_Name_CAPI" structure was moved to the internal C API.
  Patch by Victor Stinner.

* bpo-42157: Convert the "unicodedata" extension module to the
  multiphase initialization API (**PEP 489**) and convert the
  "unicodedata.UCD" static type to a heap type. Patch by Mohamed
  Koubaa and Victor Stinner.

* bpo-42146: Fix memory leak in "subprocess.Popen()" in case an uid
  (gid) specified in "user" ("group", "extra_groups") overflows
  "uid_t" ("gid_t").

* bpo-42103: "InvalidFileException" and "RecursionError" are now the
  only errors caused by loading malformed binary Plist file
  (previously ValueError and TypeError could be raised in some
  specific cases).

* bpo-41490: In "importlib.resources", ".path" method is more
  aggressive about releasing handles to zipfile objects early,
  enabling use-cases like certifi to leave the context open but delete
  the underlying zip file.

* bpo-41052: Pickling heap types implemented in C with protocols 0 and
  1 raises now an error instead of producing incorrect data.

* bpo-42089: In "importlib.metadata.PackageNotFoundError", make
  reference to the package metadata being missing to improve the user
  experience.

* bpo-41491: plistlib: fix parsing XML plists with hexadecimal integer
  values

* bpo-42065: Fix an incorrectly formatted error from
  "_codecs.charmap_decode()" when called with a mapped value outside
  the range of valid Unicode code points. PR by Max Bernstein.

* bpo-41966: Fix pickling pure Python "datetime.time" subclasses.
  Patch by Dean Inwood.

* bpo-19270: "sched.scheduler.cancel()" will now cancel the correct
  event, if two events with same priority are scheduled for the same
  time. Patch by Bar Harel.

* bpo-28660: "textwrap.wrap()" now attempts to break long words after
  hyphens when "break_long_words=True" and "break_on_hyphens=True".

* bpo-35823: Use "vfork()" instead of "fork()" for
  "subprocess.Popen()" on Linux to improve performance in cases where
  it is deemed safe.

* bpo-42043: Add support for "zipfile.Path" inheritance.
  "zipfile.Path.is_file()" now returns False for non-existent names.
  "zipfile.Path" objects now expose a ".filename" attribute and rely
  on that to resolve ".name" and ".parent" when the "Path" object is
  at the root of the zipfile.

* bpo-42021: Fix possible ref leaks in "sqlite3" module init.

* bpo-39101: Fixed tests using IsolatedAsyncioTestCase from hanging on
  BaseExceptions.

* bpo-41976: Fixed a bug that was causing "ctypes.util.find_library()"
  to return "None" when triying to locate a library in an environment
  when gcc>=9 is available and "ldconfig" is not. Patch by Pablo
  Galindo

* bpo-41943: Fix bug where TestCase.assertLogs doesn't correctly
  filter messages by level.

* bpo-41923: Implement **PEP 613**, introducing "typing.TypeAlias"
  annotation.

* bpo-41905: A new function in abc: *update_abstractmethods* to re-
  calculate an abstract class's abstract status. In addition,
  *dataclass* has been changed to call this function.

* bpo-23706: Added *newline* parameter to "pathlib.Path.write_text()".

* bpo-41876: Tkinter font class repr uses font name

* bpo-41831: "str()" for the "type" attribute of the "tkinter.Event"
  object always returns now the numeric code returned by Tk instead of
  the name of the event type.

* bpo-39337: "encodings.normalize_encoding()" now ignores non-ASCII
  characters.

* bpo-41747: Ensure all methods that generated from
  "dataclasses.dataclass()" objects now have the proper "__qualname__"
  attribute referring to the class they belong to. Patch by Batuhan
  Taskaya.

* bpo-30681: Handle exceptions caused by unparsable date headers when
  using email "default" policy.  Patch by Tim Bell, Georges Toth

* bpo-41586: Add F_SETPIPE_SZ and F_GETPIPE_SZ to fcntl module. Allow
  setting pipesize on subprocess.Popen.

* bpo-41229: Add "contextlib.aclosing" for deterministic cleanup of
  async generators which is analogous to "contextlib.closing" for non-
  async generators. Patch by Joongi Kim and John Belmonte.

* bpo-16396: Allow "ctypes.wintypes" to be imported on non-Windows
  systems.

* bpo-4356: Add a key function to the bisect module.

* bpo-40592: "shutil.which()" now ignores empty entries in "PATHEXT"
  instead of treating them as a match.

* bpo-40492: Fix "--outfile" for "cProfile" / "profile" not writing
  the output file in the original directory when the program being
  profiled changes the working directory.  PR by Anthony Sottile.

* bpo-34204: The "shelve" module now uses "pickle.DEFAULT_PROTOCOL" by
  default instead of "pickle" protocol "3".

* bpo-27321: Fixed KeyError exception when flattening an email to a
  string attempts to replace a non-existent Content-Transfer-Encoding
  header.

* bpo-38976: The "http.cookiejar" module now supports the parsing of
  cookies in CURL-style cookiejar files through MozillaCookieJar on
  all platforms. Previously, such cookie entries would be silently
  ignored when loading a cookiejar with such entries.

  Additionally, the HTTP Only attribute is persisted in the object,
  and will be correctly written to file if the MozillaCookieJar object
  is subsequently dumped.


Documentación
-------------

* bpo-42061: Document __format__ functionality for IP addresses.

* bpo-41910: Document the default implementation of "object.__eq__".

* bpo-42010: Clarify that subscription expressions are also valid for
  certain *classes* and *types* in the standard library, and for user-
  defined classes and types if the classmethod "__class_getitem__()"
  is provided.

* bpo-41805: Documented generic alias type and "types.GenericAlias".
  Also added an entry in glossary for *generic types*.

* bpo-39693: Fix tarfile's extractfile documentation

* bpo-39416: Document some restrictions on the default string
  representations of numeric classes.


Pruebas
-------

* bpo-41739: Fix
  test_logging.test_race_between_set_target_and_flush(): the test now
  waits until all threads complete to avoid leaking running threads.

* bpo-41970: Avoid a test failure in "test_lib2to3" if the module has
  already imported at the time the test executes. Patch by Pablo
  Galindo.

* bpo-41944: Tests for CJK codecs no longer call "eval()" on content
  received via HTTP.

* bpo-41306: Fixed a failure in "test_tk.test_widgets.ScaleTest"
  happening when executing the test with Tk 8.6.10.


Construir
---------

* bpo-38980: Add "-fno-semantic-interposition" to both the compile and
  link line when building with "--enable-optimizations". Patch by
  Victor Stinner and Pablo Galindo.


Ventanas
--------

* bpo-38439: Updates the icons for IDLE in the Windows Store package.

* bpo-38252: Use 8-byte step to detect ASCII sequence in 64-bit
  Windows build.

* bpo-39107: Update Tcl and Tk to 8.6.10 in Windows installer.

* bpo-41557: Update Windows installer to use SQLite 3.33.0.

* bpo-38324: Avoid Unicode errors when accessing certain locale data
  on Windows.


Mac OS
------

* bpo-41471: Ignore invalid prefix lengths in system proxy excludes.


INACTIVO
--------

* bpo-33987: Mostly finish using ttk widgets, mainly for editor,
  settings, and searches. Some patches by Mark Roseman.

* bpo-40511: Typing opening and closing parentheses inside the
  parentheses of a function call will no longer cause unnecessary
  "flashing" off and on of an existing open call-tip, e.g. when typed
  in a string literal.

* bpo-38439: Add a 256×256 pixel IDLE icon to the Windows .ico file.
  Created by Andrew Clover. Remove the low-color gif variations from
  the .ico file.


API C
-----

* bpo-42157: The private "_PyUnicode_Name_CAPI" structure of the
  PyCapsule API "unicodedata.ucnhash_CAPI" has been moved to the
  internal C API. Patch by Victor Stinner.

* bpo-42015: Fix potential crash in deallocating method objects when
  dynamically allocated "PyMethodDef"'s lifetime is managed through
  the "self" argument of a "PyCFunction".

* bpo-40423: The "subprocess" module and "os.closerange" will now use
  the "close_range(low, high, flags)" syscall when it is available for
  more efficient closing of ranges of descriptors.

* bpo-41845: "PyObject_GenericGetDict()" is available again in the
  limited API when targeting 3.10 or later.

* bpo-40422: Add "_Py_closerange" function to provide performant
  closing of a range of file descriptors.

* bpo-41986: "Py_FileSystemDefaultEncodeErrors" and "Py_UTF8Mode" are
  available again in limited API.

* bpo-41756: Add "PyIter_Send" function to allow sending value into
  generator/coroutine/iterator without raising StopIteration exception
  to signal return.

* bpo-41784: Added "PyUnicode_AsUTF8AndSize" to the limited C API.


Python 3.10.0 alpha 1
=====================

*Release date: 2020-10-05*


Seguridad
---------

* bpo-41304: Fixes "python3x._pth" being ignored on Windows, caused by
  the fix for bpo-29778 (CVE-2020-15801).

* bpo-41162: Audit hooks are now cleared later during finalization to
  avoid missing events.

* bpo-29778: Ensure "python3.dll" is loaded from correct locations
  when Python is embedded (CVE-2020-15523).

* bpo-41004: The __hash__() methods of  ipaddress.IPv4Interface and
  ipaddress.IPv6Interface incorrectly generated constant hash values
  of 32 and 128 respectively. This resulted in always causing hash
  collisions. The fix uses hash() to generate hash values for the
  tuple of (address, mask length, network address).

* bpo-39603: Prevent http header injection by rejecting control
  characters in http.client.putrequest(...).


Núcleo y elementos integrados
-----------------------------

* bpo-41909: Fixed stack overflow in "issubclass()" and "isinstance()"
  when getting the "__bases__" attribute leads to infinite recursion.

* bpo-41922: Speed up calls to "reversed()" by using the **PEP 590**
  "vectorcall" calling convention. Patch by Dong-hee Na.

* bpo-41873: Calls to "float()" are now faster due to the "vectorcall"
  calling convention. Patch by Dennis Sweeney.

* bpo-41870: Speed up calls to "bool()" by using the **PEP 590**
  "vectorcall" calling convention. Patch by Dong-hee Na.

* bpo-1635741: Port the "_bisect" module to the multi-phase
  initialization API (**PEP 489**).

* bpo-39934: Correctly count control blocks in 'except' in compiler.
  Ensures that a syntax error, rather a fatal error, occurs for deeply
  nested, named exception handlers.

* bpo-41780: Fix "__dir__()" of "types.GenericAlias". Patch by Batuhan
  Taskaya.

* bpo-1635741: Port the "_lsprof" extension module to multi-phase
  initialization (**PEP 489**).

* bpo-1635741: Port the "cmath" extension module to multi-phase
  initialization (**PEP 489**).

* bpo-1635741: Port the "_scproxy" extension module to multi-phase
  initialization (**PEP 489**).

* bpo-1635741: Port the "termios" extension module to multi-phase
  initialization (**PEP 489**).

* bpo-1635741: Convert the "_sha256" extension module types to heap
  types.

* bpo-41690: Fix a possible stack overflow in the parser when parsing
  functions and classes with a huge amount of arguments. Patch by
  Pablo Galindo.

* bpo-1635741: Port the "_overlapped" extension module to multi-phase
  initialization (**PEP 489**).

* bpo-1635741: Port the "_curses_panel" extension module to multi-
  phase initialization (**PEP 489**).

* bpo-1635741: Port the "_opcode" extension module to multi-phase
  initialization (**PEP 489**).

* bpo-41681: Fixes the wrong error description in the error raised by
  using 2 "," in format string in f-string and "str.format()".

* bpo-41675: The implementation of "signal.siginterrupt()" now uses
  "sigaction()" (if it is available in the system) instead of the
  deprecated "siginterrupt()". Patch by Pablo Galindo.

* bpo-41670: Prevent line trace being skipped on platforms not
  compiled with "USE_COMPUTED_GOTOS". Fixes issue where some lines
  nested within a try-except block were not being traced on Windows.

* bpo-41654: Fix a crash that occurred when destroying subclasses of
  "MemoryError". Patch by Pablo Galindo.

* bpo-1635741: Port the "zlib" extension module to multi-phase
  initialization (**PEP 489**).

* bpo-41631: The "_ast" module uses again a global state. Using a
  module state per module instance is causing subtle practical
  problems. For example, the Mercurial project replaces the
  "__import__()" function to implement lazy import, whereas Python
  expected that "import _ast" always return a fully initialized "_ast"
  module.

* bpo-40077: Convert "_operator" to use "PyType_FromSpec()".

* bpo-1653741: Port "_sha3" to multi-phase init.  Convert static types
  to heap types.

* bpo-1635741: Port the "_blake2" extension module to the multi-phase
  initialization API (**PEP 489**).

* bpo-41533: Free the stack allocated in "va_build_stack" if
  "do_mkstack" fails and the stack is not a "small_stack".

* bpo-41531: Fix a bug that was dropping keys when compiling dict
  literals with more than 0xFFFF elements. Patch by Pablo Galindo.

* bpo-41525: The output of "python --help" contains now only ASCII
  characters.

* bpo-1635741: Port the "_sha1", "_sha512", and "_md5" extension
  modules to multi-phase initialization API (**PEP 489**).

* bpo-41431: Optimize "dict_merge()" for copying dict (e.g. "dict(d)"
  and "{}.update(d)").

* bpo-41428: Implement PEP 604. This supports (int | str) etc. in
  place of Union[str, int].

* bpo-41340: Removed fallback implementation for "strdup".

* bpo-38156: Handle interrupts that come after EOF correctly in
  "PyOS_StdioReadline".

* bpo-41342: "round()" with integer argument is now faster (9--60%).

* bpo-41334: Constructors "str()", "bytes()" and "bytearray()" are now
  faster (around 30--40% for small objects).

* bpo-41295: Resolve a regression in CPython 3.8.4 where defining
  "__setattr__" in a multi-inheritance setup and calling up the
  hierarchy chain could fail if builtins/extension types were involved
  in the base types.

* bpo-41323: Bytecode optimizations are performed directly on the
  control flow graph. This will result in slightly more compact code
  objects in some circumstances.

* bpo-41247: Always cache the running loop holder when running
  "asyncio.set_running_loop".

* bpo-41252: Fix incorrect refcounting in _ssl.c's
  "_servername_callback()".

* bpo-1635741: Port "multiprocessing" to multi-phase initialization

* bpo-1635741: Port "winapi" to multiphase initialization

* bpo-41215: Use non-NULL default values in the PEG parser keyword
  list to overcome a bug that was preventing Python from being
  properly compiled when using the XLC compiler. Patch by Pablo
  Galindo.

* bpo-41218: Python 3.8.3 had a regression where compiling with
  ast.PyCF_ALLOW_TOP_LEVEL_AWAIT would aggressively mark list
  comprehension with CO_COROUTINE. Now only list comprehension making
  use of async/await will tagged as so.

* bpo-1635741: Port "faulthandler" to multiphase initialization.

* bpo-1635741: Port "sha256" to multiphase initialization

* bpo-41175: Guard against a NULL pointer dereference within
  bytearrayobject triggered by the "bytearray() + bytearray()"
  operation.

* bpo-41100: add arm64 to the allowable Mac OS arches in mpdecimal.h

* bpo-41094: Fix decoding errors with audit when open files with non-
  ASCII names on non-UTF-8 locale.

* bpo-39960: The "hackcheck" that prevents sneaking around a type's
  __setattr__() by calling the superclass method was rewritten to
  allow C implemented heap types.

* bpo-41084: Prefix the error message with 'f-string: ', when parsing
  an f-string expression which throws a "SyntaxError".

* bpo-40521: Empty frozensets are no longer singletons.

* bpo-41076: Pre-feed the parser with the location of the f-string
  expression, not the f-string itself, which allows us to skip the
  shifting of the AST node locations after the parsing is completed.

* bpo-41056: Fixes a reference to deallocated stack space during
  startup when constructing sys.path involving a relative symlink when
  code was supplied via -c.  (discovered via Coverity)

* bpo-41061: Fix incorrect expressions and asserts in hashtable code
  and tests.

* bpo-41052: Opt out serialization/deserialization for _random.Random

* bpo-40939: Rename "PyPegen*" functions to "PyParser*", so that we
  can remove the old set of "PyParser*" functions that were using the
  old parser, but keep everything backwards-compatible.

* bpo-35975: Stefan Behnel reported that cf_feature_version is used
  even when PyCF_ONLY_AST is not set. This is against the intention
  and against the documented behavior, so it's been fixed.

* bpo-40939: Remove the remaining files from the old parser and the
  "symbol" module.

* bpo-40077: Convert "_bz2" to use "PyType_FromSpec()".

* bpo-41006: The "encodings.latin_1" module is no longer imported at
  startup. Now it is only imported when it is the filesystem encoding
  or the stdio encoding.

* bpo-40636: "zip()" now supports **PEP 618**'s "strict" parameter,
  which raises a "ValueError" if the arguments are exhausted at
  different lengths. Patch by Brandt Bucher.

* bpo-1635741: Port "_gdbm" to multiphase initialization.

* bpo-40985: Fix a bug that caused the "SyntaxError" text to be empty
  when a file ends with a line ending in a line continuation character
  (i.e. backslash). The error text should contain the text of the last
  line.

* bpo-40958: Fix a possible buffer overflow in the PEG parser when
  gathering information for emitting syntax errors. Patch by Pablo
  Galindo.

* bpo-1635741: Port "_dbm" to multiphase initialization.

* bpo-40957: Fix refleak in _Py_fopen_obj() when PySys_Audit() fails

* bpo-40950: Add a state to the "nis" module (**PEP 3121**) and apply
  the multiphase initialization. Patch by Dong-hee Na.

* bpo-40947: The Python Path Configuration now takes
  "PyConfig.platlibdir" in account.

* bpo-40939: Remove the old parser, the "parser" module and all
  associated support code, command-line options and environment
  variables. Patch by Pablo Galindo.

* bpo-40847: Fix a bug where a line with only a line continuation
  character is not considered a blank line at tokenizer level. In such
  cases, more than a single "NEWLINE" token was emitted. The old
  parser was working around the issue, but the new parser threw a
  "SyntaxError" for valid input due to this. For example, an empty
  line following a line continuation character was interpreted as a
  "SyntaxError".

* bpo-40890: Each dictionary view now has a "mapping" attribute that
  provides a "types.MappingProxyType" wrapping the original
  dictionary.  Patch contributed by Dennis Sweeney.

* bpo-40889: Improved the performance of symmetric difference
  operations on dictionary item views.  Patch by Dennis Sweeney.

* bpo-40904: Fix possible segfault in the new PEG parser when parsing
  f-string containing yield statements with no value ("f"{yield}"").
  Patch by Pablo Galindo

* bpo-40903: Fixed a possible segfault in the new PEG parser when
  producing error messages for invalid assignments of the form "p=p=".
  Patch by Pablo Galindo

* bpo-40880: Fix invalid memory read in the new parser when checking
  newlines in string literals. Patch by Pablo Galindo.

* bpo-40883: Fix memory leak in when parsing f-strings in the new
  parser. Patch by Pablo Galindo

* bpo-40870: Raise "ValueError" when validating custom AST's where the
  constants "True", "False" and "None" are used within a "ast.Name"
  node.

* bpo-40854: Allow overriding "sys.platlibdir" via a new
  "PYTHONPLATLIBDIR" environment variable.

* bpo-40826: Fix GIL usage in "PyOS_Readline()": lock the GIL to set
  an exception and pass the Python thread state when checking if there
  is a pending signal.

* bpo-1635741: Port "fcntl" to multiphase initialization.

* bpo-19468: Delete unnecessary instance check in importlib.reload().
  Patch by Furkan Önder.

* bpo-40824: Unexpected errors in calling the "__iter__" method are no
  longer masked by "TypeError" in the "in" operator and functions
  "contains()", "indexOf()" and "countOf()" of the "operator" module.

* bpo-40792: Attributes "start", "stop" and "step" of the "range"
  object now always has exact type "int".  Previously, they could have
  been an instance of a subclass of "int".

* bpo-40780: Fix a corner case where g-style string formatting of a
  float failed to remove trailing zeros.

* bpo-38964: When there's a "SyntaxError" in the expression part of an
  fstring, the filename attribute of the "SyntaxError" gets correctly
  set to the name of the file the fstring resides in.

* bpo-40750: Support the "-d" debug flag in the new PEG parser. Patch
  by Pablo Galindo

* bpo-40217: Instances of types created with
  "PyType_FromSpecWithBases()" will no longer automatically visit
  their class object when traversing references in the garbage
  collector. The user is expected to manually visit the object's
  class. Patch by Pablo Galindo.

* bpo-39573: "Py_TYPE()" is changed to the inline static function.
  Patch by Dong-hee Na.

* bpo-40696: Fix a hang that can arise after "generator.throw()" due
  to a cycle in the exception context chain.

* bpo-40521: Each interpreter now its has own free lists, singletons
  and caches:

  * Free lists: float, tuple, list, dict, frame, context, asynchronous
    generator, MemoryError.

  * Singletons: empty tuple, empty bytes string, empty Unicode string,
    single byte character, single Unicode (latin1) character.

  * Slice cache.

  They are no longer shared by all interpreters.

* bpo-40679: Certain "TypeError" messages about missing or extra
  arguments now include the function's *qualified name*.  Patch by
  Dennis Sweeney.

* bpo-29590: Make the stack trace correct after calling
  "generator.throw()" on a generator that has yielded from a "yield
  from".

* bpo-4022: Improve performance of generators by not raising internal
  StopIteration.

* bpo-1635741: Port "mmap" to multiphase initialization.

* bpo-1635741: Port "_lzma" to multiphase initialization.

* bpo-37999: Builtin and extension functions that take integer
  arguments no longer accept "Decimal"s, "Fraction"s and other objects
  that can be converted to integers only with a loss (e.g. that have
  the "__int__()" method but do not have the "__index__()" method).

* bpo-29882: Add "int.bit_count()", counting the number of ones in the
  binary representation of an integer. Patch by Niklas Fiekas.

* bpo-36982: Use ncurses extended color functions when available to
  support terminals with 256 colors, and add the new function
  "curses.has_extended_color_support()" to indicate whether extended
  color support is provided by the underlying ncurses library.

* bpo-19569: Add the private macros "_Py_COMP_DIAG_PUSH",
  "_Py_COMP_DIAG_IGNORE_DEPR_DECLS", and "_Py_COMP_DIAG_POP".

* bpo-26680: The int type now supports the x.is_integer() method for
  compatibility with float.


Biblioteca
----------

* bpo-41900: C14N 2.0 serialisation in xml.etree.ElementTree failed
  for unprefixed attributes when a default namespace was defined.

* bpo-41887: Strip leading spaces and tabs on "ast.literal_eval()".
  Also document stripping of spaces and tabs for "eval()".

* bpo-41773: Note in documentation that "random.choices()" doesn't
  support non-finite weights, raise "ValueError" when given non-finite
  weights.

* bpo-41840: Fix a bug in the "symtable" module that was causing
  module-scope global variables to not be reported as both local and
  global. Patch by Pablo Galindo.

* bpo-41842: Add "codecs.unregister()" function to unregister a codec
  search function.

* bpo-40564: In "zipfile.Path", mutate the passed ZipFile object type
  instead of making a copy. Prevents issues when both the local copy
  and the caller’s copy attempt to close the same file handle.

* bpo-40670: More reliable validation of statements in "timeit.Timer".
  It now accepts "empty" statements (only whitespaces and comments)
  and rejects misindentent statements.

* bpo-41833: The "threading.Thread" constructor now uses the target
  name if the *target* argument is specified but the *name* argument
  is omitted.

* bpo-41817: fix "tkinter.EventType" Enum so all members are strings,
  and none are tuples

* bpo-41810: "types.EllipsisType", "types.NotImplementedType" and
  "types.NoneType" have been reintroduced, providing a new set of
  types readily interpretable by static type checkers.

* bpo-41815: Fix SQLite3 segfault when backing up closed database.
  Patch contributed by Peter David McCormick.

* bpo-41816: StrEnum added: it ensures that all members are already
  strings or string candidates

* bpo-41517: fix bug allowing Enums to be extended via multiple
  inheritance

* bpo-39587: use the correct mix-in data type when constructing Enums

* bpo-41792: Add is_typeddict function to typing.py to check if a type
  is a TypedDict class

  Previously there was no way to check that without using private API.
  See the "relevant issue in python/typing"

* bpo-41789: Honor "object" overrides in "Enum" class creation
  (specifically, "__str__", "__repr__", "__format__", and
  "__reduce_ex__").

* bpo-32218: "enum.Flag" and "enum.IntFlag" members are now iterable

* bpo-39651: Fix a race condition in the "call_soon_threadsafe()"
  method of "asyncio.ProactorEventLoop": do nothing if the self-pipe
  socket has been closed.

* bpo-1635741: Port the "mashal" extension module to the multi-phase
  initialization API (**PEP 489**).

* bpo-1635741: Port the "_string" extension module to the multi-phase
  initialization API (**PEP 489**).

* bpo-41732: Added an *iterator* to "memoryview".

* bpo-41720: Fixed "turtle.Vec2D.__rmul__()" for arguments which are
  not int or float.

* bpo-41696: Fix handling of debug mode in "asyncio.run()". This
  allows setting "PYTHONASYNCIODEBUG" or "-X dev" to enable asyncio
  debug mode when using "asyncio.run()".

* bpo-41687: Fix implementation of sendfile to be compatible with
  Solaris.

* bpo-41662: No longer override exceptions raised in "__len__()" of a
  sequence of parameters in "sqlite3" with "ProgrammingError".

* bpo-39010: Restarting a "ProactorEventLoop" on Windows no longer
  logs spurious "ConnectionResetErrors".

* bpo-41638: "ProgrammingError" message for absent parameter in
  "sqlite3" contains now the name of the parameter instead of its
  index when parameters are supplied as a dict.

* bpo-41662: Fixed crash when mutate list of parameters during
  iteration in "sqlite3".

* bpo-41513: Improved the accuracy of math.hypot().  Internally, each
  step is computed with extra precision so that the result is now
  almost always correctly rounded.

* bpo-41609: The pdb whatis command correctly reports instance methods
  as 'Method' rather than 'Function'.

* bpo-39994: Fixed pprint's handling of dict subclasses that override
  __repr__.

* bpo-32751: When cancelling the task due to a timeout,
  "asyncio.wait_for()" will now wait until the cancellation is
  complete also in the case when *timeout* is <= 0, like it does with
  positive timeouts.

* bpo-37658: "asyncio.wait_for()" now properly handles races between
  cancellation of itself and the completion of the wrapped awaitable.

* bpo-40782: Change the method
  asyncio.AbstractEventLoop.run_in_executor to not be a coroutine.

* bpo-41520: Fix "codeop" regression that prevented turning compile
  warnings into errors.

* bpo-41528: turtle uses math module functions to convert degrees to
  radians and vice versa and to calculate vector norm

* bpo-41513: Minor algorithmic improvement to math.hypot() and
  math.dist() giving small gains in speed and accuracy.

* bpo-41503: Fixed a race between setTarget and flush in
  logging.handlers.MemoryHandler.

* bpo-41497: Fix potential UnicodeDecodeError in dis module.

* bpo-41467: On Windows, fix asyncio "recv_into()" return value when
  the socket/pipe is closed ("BrokenPipeError"): return "0" rather
  than an empty byte string ("b''").

* bpo-41425: Make tkinter doc example runnable.

* bpo-41421: Make an algebraic simplification to
  random.paretovariate().  It now is slightly less subject to round-
  off error and is slightly faster. Inputs that used to cause
  ZeroDivisionError now cause an OverflowError instead.

* bpo-41440: Add "os.cpu_count()" support for VxWorks RTOS.

* bpo-41316: Fix the "tarfile" module to write only basename of TAR
  file to GZIP compression header.

* bpo-41384: Raise TclError instead of TypeError when an unknown
  option is passed to tkinter.OptionMenu.

* bpo-41317: Use add_done_callback() in asyncio.loop.sock_accept() to
  unsubscribe reader early on cancellation.

* bpo-41364: Reduce import overhead of "uuid".

* bpo-35328: Set the environment variable "VIRTUAL_ENV_PROMPT" at
  "venv" activation.

* bpo-41341: Recursive evaluation of "typing.ForwardRef" in
  "get_type_hints".

* bpo-41344: Prevent creating "shared_memory.SharedMemory" objects
  with "size=0".

* bpo-41333: "collections.OrderedDict.pop()" is now 2 times faster.

* bpo-41288: Unpickling invalid NEWOBJ_EX opcode with the C
  implementation raises now UnpicklingError instead of crashing.

* bpo-39017: Avoid infinite loop when reading specially crafted TAR
  files using the tarfile module (CVE-2019-20907).

* bpo-41273: Speed up any transport using "_ProactorReadPipeTransport"
  by calling "recv_into" instead of "recv", thus not creating a new
  buffer for each "recv" call in the transport's read loop.

* bpo-41235: Fix the error handling in
  "ssl.SSLContext.load_dh_params()".

* bpo-41207: In distutils.spawn, restore expectation that
  DistutilsExecError is raised when the command is not found.

* bpo-29727: Register "array.array" as a "MutableSequence". Patch by
  Pablo Galindo.

* bpo-39168: Remove the "__new__" method of "typing.Generic".

* bpo-41194: Fix a crash in the "_ast" module: it can no longer be
  loaded more than once. It now uses a global state rather than a
  module state.

* bpo-41195: Add read-only ssl.SSLContext.security_level attribute to
  retrieve the context's security level.

* bpo-41193: The "write_history()" atexit function of the readline
  completer now ignores any "OSError" to ignore error if the
  filesystem is read-only, instead of only ignoring
  "FileNotFoundError" and "PermissionError".

* bpo-41182: selector: use DefaultSelector based upon implementation

* bpo-41161: The decimal module now requires libmpdec-2.5.0. Users of
  --with-system-libmpdec should update their system library.

* bpo-40874: The decimal module now requires libmpdec-2.5.0.

* bpo-41138: Fixed the "trace" module CLI for Python source files with
  non-UTF-8 encoding.

* bpo-31082: Use the term "iterable" in the docstring for
  "functools.reduce()".

* bpo-40521: Remove freelist from collections.deque().

* bpo-31938: Fix default-value signatures of several functions in the
  "select" module - by Anthony Sottile.

* bpo-41068: Fixed reading files with non-ASCII names from ZIP archive
  directly after writing them.

* bpo-41058: "pdb.find_function()" now correctly determines the source
  file encoding.

* bpo-41056: Invalid file descriptor values are now prevented from
  being passed to os.fpathconf. (discovered by Coverity)

* bpo-41056: Fix a NULL pointer dereference within the ssl module
  during a MemoryError in the keylog callback. (discovered by
  Coverity)

* bpo-41056: Fixed an instance where a MemoryError within the zoneinfo
  module might not be reported or not reported at its source. (found
  by Coverity)

* bpo-41048: "mimetypes.read_mime_types()" function reads the rule
  file using UTF-8 encoding, not the locale encoding. Patch by
  Srinivas Reddy Thatiparthy.

* bpo-41043: Fixed the use of "glob()" in the stdlib: literal part of
  the path is now always correctly escaped.

* bpo-41025: Fixed an issue preventing the C implementation of
  "zoneinfo.ZoneInfo" from being subclassed.

* bpo-35018: Add the "xml.sax.handler.LexicalHandler" class that is
  present in other SAX XML implementations.

* bpo-41002: Improve performance of HTTPResponse.read with a given
  amount. Patch by Bruce Merry.

* bpo-40448: "ensurepip" now disables the use of "pip" cache when
  installing the bundled versions of "pip" and "setuptools".  Patch by
  Krzysztof Konopko.

* bpo-40967: Removed "asyncio.Task.current_task()" and
  "asyncio.Task.all_tasks()". Patch contributed by Rémi Lapeyre.

* bpo-40924: Ensure "importlib.resources.path" returns an extant path
  for the SourceFileLoader's resource reader. Avoids the regression
  identified in master while a long-term solution is devised.

* bpo-40955: Fix a minor memory leak in "subprocess" module when
  extra_groups was specified.

* bpo-40855: The standard deviation and variance functions in the
  statistics module were ignoring their mu and xbar arguments.

* bpo-40939: Use the new PEG parser when generating the stdlib
  "keyword" module.

* bpo-23427: Add "sys.orig_argv" attribute: the list of the original
  command line arguments passed to the Python executable.

* bpo-33689: Ignore empty or whitespace-only lines in .pth files. This
  matches the documentated behavior. Before, empty lines caused the
  site-packages dir to appear multiple times in sys.path. By Ido
  Michael, contributors Malcolm Smith and Tal Einat.

* bpo-40884: Added a "defaults" parameter to "logging.Formatter", to
  allow specifying default values for custom fields. Patch by Asaf
  Alon and Bar Harel.

* bpo-40876: Clarify error message in the "csv" module.

* bpo-39791: Refresh importlib.metadata from importlib_metadata 1.6.1.

* bpo-40807: Stop codeop._maybe_compile, used by
  code.InteractiveInterpreter (and IDLE). from emitting each warning
  three times.

* bpo-32604: Fix reference leak in the "select" module when the module
  is imported in a subinterpreter.

* bpo-39791: Built-in loaders (SourceFileLoader and ZipImporter) now
  supply "TraversableResources" implementations for "ResourceReader",
  and the fallback function has been removed.

* bpo-39314: "rlcompleter.Completer" and the standard Python shell now
  close the parenthesis for functions that take no arguments. Patch
  contributed by Rémi Lapeyre.

* bpo-17005: The topological sort functionality that was introduced
  initially in the "functools" module has been moved to a new
  "graphlib" module to better accommodate the new tools and keep the
  original scope of the "functools" module. Patch by Pablo Galindo

* bpo-40834: Fix truncate when sending str object
  with_xxsubinterpreters.channel_send.

* bpo-40755: Add rich comparisons to collections.Counter().

* bpo-26407: Unexpected errors in calling the "__iter__" method are no
  longer masked by "TypeError" in "csv.reader()",
  "csv.writer.writerow()" and "csv.writer.writerows()".

* bpo-39384: Fixed email.contentmanager to allow set_content() to set
  a null string.

* bpo-40744: The "sqlite3" module uses SQLite API functions that
  require SQLite v3.7.3 or higher.  This patch removes support for
  older SQLite versions, and explicitly requires SQLite 3.7.3 both at
  build, compile and runtime.  Patch by Sergey Fedoseev and Erlend E.
  Aasland.

* bpo-40777: Initialize PyDateTime_IsoCalendarDateType.tp_base at run-
  time to avoid errors on some compilers.

* bpo-38488: Update ensurepip to install pip 20.1.1 and setuptools
  47.1.0.

* bpo-40792: The result of "operator.index()" now always has exact
  type "int". Previously, the result could have been an instance of a
  subclass of "int".

* bpo-40767: "webbrowser" now properly finds the default browser in
  pure Wayland systems by checking the WAYLAND_DISPLAY environment
  variable. Patch contributed by Jérémy Attali.

* bpo-40791: "hashlib.compare_digest()" uses OpenSSL's
  "CRYPTO_memcmp()" function when OpenSSL is available.

* bpo-40795: "ctypes" module: If ctypes fails to convert the result of
  a callback or if a ctypes callback function raises an exception,
  sys.unraisablehook is now called with an exception set. Previously,
  the error was logged into stderr by "PyErr_Print()".

* bpo-16995: Add "base64.b32hexencode()" and "base64.b32hexdecode()"
  to support the Base32 Encoding with Extended Hex Alphabet.

* bpo-30008: Fix "ssl" code to be compatible with OpenSSL 1.1.x builds
  that use "no-deprecated" and "--api=1.1.0".

* bpo-30064: Fix asyncio "loop.sock_*" race condition issue

* bpo-40759: Deprecate the "symbol" module.

* bpo-40756: The second argument (extra) of "LoggerAdapter.__init__"
  now defaults to None.

* bpo-37129: Add a new "os.RWF_APPEND" flag for "os.pwritev()".

* bpo-40737: Fix possible reference leak for "sqlite3" initialization.

* bpo-40726: Handle cases where the "end_lineno" is "None" on
  "ast.increment_lineno()".

* bpo-40698: "distutils" upload creates SHA2-256 and Blake2b-256
  digests. MD5 digests is skipped if platform blocks MD5.

* bpo-40695: "hashlib" no longer falls back to builtin hash
  implementations when OpenSSL provides a hash digest and the
  algorithm is blocked by security policy.

* bpo-9216: func:"hashlib.new" passed "usedforsecurity" to OpenSSL EVP
  constructor "_hashlib.new()". test_hashlib and test_smtplib handle
  strict security policy better.

* bpo-40614: "ast.parse()" will not parse self documenting expressions
  in f-strings when passed "feature_version" is less than "(3, 8)".

* bpo-40626: Add h5 file extension as MIME Type application/x-hdf5, as
  per HDF Group recommendation for HDF5 formatted data files. Patch
  contributed by Mark Schwab.

* bpo-25920: On macOS, when building Python for macOS 10.4 and older,
  which wasn't the case for python.org macOS installer,
  "socket.getaddrinfo()" no longer uses an internal lock to prevent
  race conditions when calling "getaddrinfo()" which is thread-safe
  since macOS 10.5. Python 3.9 requires macOS 10.6 or newer. The
  internal lock caused random hang on fork when another thread was
  calling "socket.getaddrinfo()". The lock was also used on FreeBSD
  older than 5.3, OpenBSD older than 201311 and NetBSD older than 4.

* bpo-40671: Prepare "_hashlib" for **PEP 489** and use
  "PyModule_AddType()".

* bpo-32309: Added a new *coroutine* "asyncio.to_thread()". It is
  mainly used for running IO-bound functions in a separate thread to
  avoid blocking the event loop, and essentially works as a high-level
  version of "run_in_executor()" that can directly take keyword
  arguments.

* bpo-36543: Restored the deprecated "xml.etree.cElementTree" module.

* bpo-40611: "MAP_POPULATE" constant has now been added to the list of
  exported "mmap" module flags.

* bpo-39881: PEP 554 for use in the test suite. (Patch By Joannah
  Nanjekye)

* bpo-13097: "ctypes" now raises an "ArgumentError" when a callback is
  invoked with more than 1024 arguments.

* bpo-39385: A new test assertion context-manager,
  "unittest.assertNoLogs()" will ensure a given block of code emits no
  log messages using the logging module. Contributed by Kit Yan Choi.

* bpo-23082: Updated the error message and docs of
  PurePath.relative_to() to better reflect the function behaviour.

* bpo-40318: Use SQLite3 trace v2 API, if it is available.

* bpo-40105: ZipFile truncates files to avoid corruption when a
  shorter comment is provided in append ("a") mode. Patch by Jan
  Mazur.

* bpo-40084: Fix "Enum.__dir__": dir(Enum.member) now includes
  attributes as well as methods.

* bpo-31122: ssl.wrap_socket() now raises ssl.SSLEOFError rather than
  OSError when peer closes connection during TLS negotiation

* bpo-39728: fix default "_missing_" so a duplicate "ValueError" is
  not set as the "__context__" of the original "ValueError"

* bpo-39244: Fixed "multiprocessing.context.get_all_start_methods" to
  properly return the default method first on macOS.

* bpo-39040: Fix parsing of invalid mime headers parameters by
  collapsing whitespace between encoded words in a bare-quote-string.

* bpo-38731: Add "--quiet" option to command-line interface of
  "py_compile". Patch by Gregory Schevchenko.

* bpo-35714: "struct.error" is now raised if there is a null character
  in a "struct" format string.

* bpo-38144: Added the *root_dir* and *dir_fd* parameters in
  "glob.glob()".

* bpo-26543: Fix "IMAP4.noop()" when debug mode is enabled (ex:
  "imaplib.Debug = 3").

* bpo-12178: "csv.writer()" now correctly escapes *escapechar* when
  input contains *escapechar*.  Patch by Catalin Iacob, Berker Peksag,
  and Itay Elbirt.

* bpo-36290: AST nodes are now raising "TypeError" on conflicting
  keyword arguments. Patch contributed by Rémi Lapeyre.

* bpo-33944: Added site.py site-packages tracing in verbose mode.

* bpo-35078: Refactor formatweekday, formatmonthname methods in
  LocaleHTMLCalendar and LocaleTextCalendar classes in calendar module
  to call the base class methods.This enables customizable CSS classes
  for LocaleHTMLCalendar. Patch by Srinivas Reddy Thatiparthy

* bpo-29620: "assertWarns()" no longer raises a "RuntimeException"
  when accessing a module's "__warningregistry__" causes importation
  of a new module, or when a new module is imported in another thread.
  Patch by Kernc.

* bpo-31844: Remove "ParserBase.error()" method from the private and
  undocumented "_markupbase" module.  "html.parser.HTMLParser" is the
  only subclass of "ParserBase" and its "error()" implementation was
  deprecated in Python 3.4 and removed in Python 3.5.

* bpo-34226: Fix "cgi.parse_multipart" without content_length. Patch
  by Roger Duran

* bpo-33660: Fix pathlib.PosixPath to resolve a relative path located
  on the root directory properly.

* bpo-28557: Improve the error message for a misbehaving
  "rawio.readinto"

* bpo-26680: The d.is_integer() method is added to the Decimal type,
  for compatibility with other number types.

* bpo-26680: The x.is_integer() method is incorporated into the
  abstract types of the numeric tower, Real, Rational and Integral,
  with appropriate default implementations.


Documentación
-------------

* bpo-41428: Add documentation for **PEP 604** (Allow writing union
  types as "X | Y").

* bpo-41774: In Programming FAQ "Sequences (Tuples/Lists)" section,
  add "How do you remove multiple items from a list".

* bpo-35293: Fix RemovedInSphinx40Warning when building the
  documentation. Patch by Dong-hee Na.

* bpo-37149: Change Shipman tkinter doc link from archive.org to
  TkDocs. (The doc has been removed from the NMT server.)  The new
  link responds much faster and includes a short explanatory note.

* bpo-41726: Update the refcounts info of "PyType_FromModuleAndSpec".

* bpo-41624: Fix the signature of "typing.Coroutine".

* bpo-40204: Enable Sphinx 3.2 "c_allow_pre_v3" option and disable
  "c_warn_on_allowed_pre_v3" option to make the documentation
  compatible with Sphinx 2 and Sphinx 3.

* bpo-41045: Add documentation for debug feature of f-strings.

* bpo-41314: Changed the release when "from __future__ import
  annotations" becomes the default from "4.0" to "3.10" (following a
  change in PEP 563).

* bpo-40979: Refactored typing.rst, arranging more than 70 classes,
  functions, and decorators into new sub-sections.

* bpo-40552: Fix in tutorial section 4.2. Code snippet is now correct.

* bpo-39883: Make code, examples, and recipes in the Python
  documentation be licensed under the more permissive BSD0 license in
  addition to the existing Python 2.0 license.

* bpo-37703: Updated Documentation to comprehensively elaborate on the
  behaviour of gather.cancel()


Pruebas
-------

* bpo-41939: Fix test_site.test_license_exists_at_url(): call
  "urllib.request.urlcleanup()" to reset the global
  "urllib.request._opener". Patch by Victor Stinner.

* bpo-41731: Make test_cmd_line_script pass with option '-vv'.

* bpo-41602: Add tests for SIGINT handling in the runpy module.

* bpo-41521: "test.support": Rename "blacklist" parameter of
  "check__all__()" to "not_exported".

* bpo-41477: Make ctypes optional in test_genericalias.

* bpo-41085: Fix integer overflow in the "array.array.index()" method
  on 64-bit Windows for index larger than "2**31".

* bpo-41069: "test.support.TESTFN" and the current directory for tests
  when run via "test.regrtest" contain now non-ascii characters if
  possible.

* bpo-38377: On Linux, skip tests using multiprocessing if the current
  user cannot create a file in "/dev/shm/" directory. Add the
  "skip_if_broken_multiprocessing_synchronize()" function to the
  "test.support" module.

* bpo-41009: Fix use of
  "support.require_{linux|mac|freebsd}_version()" decorators as class
  decorator.

* bpo-41003: Fix "test_copyreg" when "numpy" is installed:
  "test.pickletester" now saves/restores warnings filters when
  importing "numpy", to ignore filters installed by "numpy".

* bpo-40964: Disable remote "imaplib" tests, host cyrus.andrew.cmu.edu
  is blocking incoming connections.

* bpo-40927: Fix test_binhex when run twice: it now uses
  import_fresh_module() to ensure that it raises DeprecationWarning
  each time.

* bpo-17258: Skip some "multiprocessing" tests when MD5 hash digest is
  blocked.

* bpo-31904: Increase LOOPBACK_TIMEOUT to 10 for VxWorks RTOS.

* bpo-38169: Increase code coverage for SharedMemory and ShareableList

* bpo-34401: Make test_gdb properly run on HP-UX. Patch by Michael
  Osipov.


Construir
---------

* bpo-38249: Update "Py_UNREACHABLE" to use __builtin_unreachable() if
  only the compiler is able to use it. Patch by Dong-hee Na.

* bpo-41617: Fix "pycore_bitutils.h" header file to support old clang
  versions: "__builtin_bswap16()" is not available in LLVM clang 3.0.

* bpo-40204: Pin Sphinx version to 2.3.1 in "Doc/Makefile".

* bpo-36020: The C99 functions "snprintf()" and "vsnprintf()" are now
  required to build Python.

* bpo-40684: "make install" now uses the "PLATLIBDIR" variable for the
  destination "lib-dynload/" directory when "./configure --with-
  platlibdir" is used.

* bpo-40683: Fixed an issue where the "zoneinfo" module and its tests
  were not included when Python is installed with "make".


Ventanas
--------

* bpo-41744: Fixes automatic import of props file when using the Nuget
  package.

* bpo-41627: The user site directory for 32-bit now includes a "-32"
  suffix to distinguish it from the 64-bit interpreter's directory.

* bpo-41526: Fixed layout of final page of the installer by removing
  the special thanks to Mark Hammond (with his permission).

* bpo-41492: Fixes the description that appears in UAC prompts.

* bpo-40948: Improve post-install message to direct people to the "py"
  command.

* bpo-41412: The installer will now fail to install on Windows 7 and
  Windows 8. Further, the UCRT dependency is now always downloaded on
  demand.

* bpo-40741: Update Windows release to include SQLite 3.32.3.

* bpo-41142: "msilib" now supports creating CAB files with non-ASCII
  file path and adding files with non-ASCII file path to them.

* bpo-41074: Fixed support of non-ASCII names in functions
  "msilib.OpenDatabase()" and "msilib.init_database()" and non-ASCII
  SQL in method "msilib.Database.OpenView()".

* bpo-41039: Stable ABI redirection DLL (python3.dll) now uses
  "#pragma comment(linker)" for re-exporting.

* bpo-40164: Updates Windows OpenSSL to 1.1.1g

* bpo-39631: Changes the registered MIME type for ".py" files on
  Windows to "text/x-python" instead of "text/plain".

* bpo-40677: Manually define IO_REPARSE_TAG_APPEXECLINK in case some
  old Windows SDK doesn't have it.

* bpo-37556: Extend py.exe help to mention overrides via venv,
  shebang, environmental variables & ini files.


Mac OS
------

* bpo-41557: Update macOS installer to use SQLite 3.33.0.

* bpo-39580: Avoid opening Finder window if running installer from the
  command line. Patch contributed by Rick Heil.

* bpo-41100: Fix configure error when building on macOS 11. Note that
  the current Python release was released shortly after the first
  developer preview of macOS 11 (Big Sur); there are other known
  issues with building and running on the developer preview. Big Sur
  is expected to be fully supported in a future bugfix release of
  Python 3.8.x and with 3.9.0.

* bpo-40741: Update macOS installer to use SQLite 3.32.3.

* bpo-41005: fixed an XDG settings issue not allowing macos to open
  browser in webbrowser.py

* bpo-40741: Update macOS installer to use SQLite 3.32.2.


INACTIVO
--------

* bpo-41775: Use 'IDLE Shell' as shell title

* bpo-35764: Rewrite the Calltips doc section.

* bpo-40181: In calltips, stop reminding that '/' marks the end of
  positional-only arguments.

* bpo-41468: Improve IDLE run crash error message (which users should
  never see).

* bpo-41373: Save files loaded with no line ending, as when blank, or
  different line endings, by setting its line ending to the system
  default. Fix regression in 3.8.4 and 3.9.0b4.

* bpo-41300: Save files with non-ascii chars. Fix regression released
  in 3.9.0b4 and 3.8.4.

* bpo-37765: Add keywords to module name completion list.  Rewrite
  Completions section of IDLE doc.

* bpo-41152: The encoding of "stdin", "stdout" and "stderr" in IDLE is
  now always UTF-8.

* bpo-41144: Make Open Module open a special module such as os.path.

* bpo-39885: Make context menu Cut and Copy work again when right-
  clicking within a selection.

* bpo-40723: Make test_idle pass when run after import.


API C
-----

* bpo-41936: Removed undocumented macros "Py_ALLOW_RECURSION" and
  "Py_END_ALLOW_RECURSION" and the "recursion_critical" field of the
  "PyInterpreterState" structure.

* bpo-41692: The "PyUnicode_InternImmortal()" function is now
  deprecated and will be removed in Python 3.12: use
  "PyUnicode_InternInPlace()" instead. Patch by Victor Stinner.

* bpo-41842: Add "PyCodec_Unregister()" function to unregister a codec
  search function.

* bpo-41834: Remove the "_Py_CheckRecursionLimit" variable: it has
  been replaced by "ceval.recursion_limit" of the "PyInterpreterState"
  structure. Patch by Victor Stinner.

* bpo-41689: Types created with "PyType_FromSpec()" now make any
  signature in their "tp_doc" slot accessible from
  "__text_signature__".

* bpo-41524: Fix bug in PyOS_mystrnicmp and PyOS_mystricmp that
  incremented pointers beyond the end of a string.

* bpo-41324: Add a minimal decimal capsule API.  The API supports fast
  conversions between Decimals up to 38 digits and their triple
  representation as a C struct.

* bpo-30155: Add "PyDateTime_DATE_GET_TZINFO()" and
  "PyDateTime_TIME_GET_TZINFO()" macros for accessing the "tzinfo"
  attributes of "datetime.datetime" and "datetime.time" objects.

* bpo-40170: Revert "PyType_HasFeature()" change: it reads again
  directly the "PyTypeObject.tp_flags" member when the limited C API
  is not used, rather than always calling "PyType_GetFlags()" which
  hides implementation details.

* bpo-41123: Remove "PyUnicode_AsUnicodeCopy".

* bpo-41123: Removed "PyLong_FromUnicode()".

* bpo-41123: Removed "PyUnicode_GetMax()".

* bpo-41123: Removed "Py_UNICODE_str*" functions manipulating
  "Py_UNICODE*" strings.

* bpo-41103: "PyObject_AsCharBuffer()", "PyObject_AsReadBuffer()",
  "PyObject_CheckReadBuffer()", and "PyObject_AsWriteBuffer()" are
  removed. Please migrate to new buffer protocol;
  "PyObject_GetBuffer()" and "PyBuffer_Release()".

* bpo-36346: Raises DeprecationWarning for
  "PyUnicode_FromUnicode(NULL, size)" and
  "PyUnicode_FromStringAndSize(NULL, size)" with "size > 0".

* bpo-36346: Mark "Py_UNICODE_COPY", "Py_UNICODE_FILL",
  "PyUnicode_WSTR_LENGTH", "PyUnicode_FromUnicode",
  "PyUnicode_AsUnicode", and "PyUnicode_AsUnicodeAndSize" as
  deprecated in C. Remove "Py_UNICODE_MATCH" which was deprecated and
  broken since Python 3.3.

* bpo-40989: The "PyObject_INIT()" and "PyObject_INIT_VAR()" macros
  become aliases to, respectively, "PyObject_Init()" and
  "PyObject_InitVar()" functions.

* bpo-36020: On Windows, "#include "pyerrors.h"" no longer defines
  "snprintf" and "vsnprintf" macros.

* bpo-40943: The "PY_SSIZE_T_CLEAN" macro must now be defined to use
  "PyArg_ParseTuple()" and "Py_BuildValue()" formats which use "#":
  "es#", "et#", "s#", "u#", "y#", "z#", "U#" and "Z#". See Parsing
  arguments and building values and the **PEP 353**.

* bpo-40910: Export explicitly the "Py_GetArgcArgv()" function to the
  C API and document the function. Previously, it was exported
  implicitly which no longer works since Python is built with
  "-fvisibility=hidden".

* bpo-40724: Allow defining buffer slots in type specs.

* bpo-40679: Fix a "_PyEval_EvalCode()" crash if *qualname* argument
  is NULL.

* bpo-40839: Calling "PyDict_GetItem()" without *GIL* held had been
  allowed for historical reason. It is no longer allowed.

* bpo-40826: "PyOS_InterruptOccurred()" now fails with a fatal error
  if it is called with the GIL released.

* bpo-40792: The result of "PyNumber_Index()" now always has exact
  type "int". Previously, the result could have been an instance of a
  subclass of "int".

* bpo-39573: Convert "Py_REFCNT()" and "Py_SIZE()" macros to static
  inline functions. They cannot be used as l-value anymore: use
  "Py_SET_REFCNT()" and "Py_SET_SIZE()" to set an object reference
  count and size. This change is backward incompatible on purpose, to
  prepare the C API for an opaque "PyObject" structure.

* bpo-40703: The PyType_FromSpec*() functions no longer overwrite the
  type's "__module__" attribute if it is set via "Py_tp_members" or
  "Py_tp_getset".

* bpo-39583: Remove superfluous "extern C" declarations from
  "Include/cpython/*.h".


Python 3.9.0 beta 1
===================

*Release date: 2020-05-19*


Seguridad
---------

* bpo-40501: "uuid" no longer uses "ctypes" to load "libuuid" or
  "rpcrt4.dll" at runtime.


Núcleo y elementos integrados
-----------------------------

* bpo-40663: Correctly generate annotations where parentheses are
  omitted but required (e.g: "Type[(str, int, *other))]".

* bpo-40596: Fixed "str.isidentifier()" for non-canonicalized strings
  containing non-BMP characters on Windows.

* bpo-40593: Improved syntax errors for invalid characters in source
  code.

* bpo-40585: Fixed a bug when using "codeop.compile_command()" that
  was causing exceptions to be swallowed with the new parser. Patch by
  Pablo Galindo

* bpo-40566: Apply **PEP 573** to "abc".

* bpo-40502: Initialize "n->n_col_offset". (Patch by Joannah Nanjekye)

* bpo-40527: Fix command line argument parsing: no longer write errors
  multiple times into stderr.

* bpo-1635741: Port "errno" to multiphase initialization (**PEP
  489**).

* bpo-40523: Add pass-throughs for "hash()" and "reversed()" to
  "weakref.proxy" objects. Patch by Pablo Galindo.

* bpo-1635741: Port "syslog" to multiphase initialization (**PEP
  489**).

* bpo-40246: Reporting a specialised error message for invalid string
  prefixes, which was introduced in bpo-40246, is being reverted due
  to backwards compatibility concerns for strings that immediately
  follow a reserved keyword without whitespace between them.
  Constructs like "bg="#d00" if clear else"#fca"" were failing to
  parse, which is not an acceptable breakage on such short notice.

* bpo-40417: Fix imp module deprecation warning when
  PyImport_ReloadModule is called. Patch by Robert Rouhani.

* bpo-40408: Fixed support of nested type variables in GenericAlias
  (e.g. "list[list[T]]").

* bpo-1635741: Port _stat module to multiphase initialization (**PEP
  489**).

* bpo-29587: Enable implicit exception chaining when calling
  "generator.throw()".

* bpo-40328: Add tools for generating mappings headers for CJKCodecs.

* bpo-40228: Setting frame.f_lineno is now robust w.r.t. changes in
  the source-to-bytecode compiler

* bpo-38880: Added the ability to list interpreters associated with
  channel ends in the internal subinterpreters module.

* bpo-37986: Improve performance of "PyLong_FromDouble()" for values
  that fit into "long".


Biblioteca
----------

* bpo-40662: Fixed "ast.get_source_segment()" for ast nodes that have
  incomplete location information. Patch by Irit Katriel.

* bpo-40665: Convert "bisect" to use Argument Clinic.

* bpo-40536: Added the "available_timezones()" function to the
  "zoneinfo" module. Patch by Paul Ganssle.

* bpo-40645: The "hmac.HMAC" exposes internal implementation details.
  The attributes "digest_cons", "inner", and "outer" are deprecated
  and will be removed in the future.

* bpo-40645: The internal module "_hashlib" wraps and exposes
  OpenSSL's HMAC API. The new code will be used in Python 3.10 after
  the internal implementation details of the pure Python HMAC module
  are no longer part of the public API.

* bpo-40637: Builtin hash modules can now be disabled or selectively
  enabled with "configure --with-builtin-hashlib-hashes=sha3,blake1"
  or "--without-builtin-hashlib-hashes".

* bpo-37630: The "hashlib" module can now use SHA3 hashes and SHAKE
  XOF from OpenSSL when available.

* bpo-40479: The "hashlib" now compiles with OpenSSL 3.0.0-alpha2.

* bpo-40257: Revert changes to "inspect.getdoc()".

* bpo-40607: When cancelling a task due to timeout,
  "asyncio.wait_for()" will now propagate the exception if an error
  happens during cancellation. Patch by Roman Skurikhin.

* bpo-40612: Fix edge cases in SyntaxError formatting. If the offset
  is <= 0, no caret is printed. If the offset is > line length, the
  caret is printed pointing just after the last character.

* bpo-40597: If text content lines are longer than
  policy.max_line_length, always use a content-encoding to make sure
  they are wrapped.

* bpo-40571: Added functools.cache() as a simpler, more discoverable
  way to access the unbounded cache variant of
  lru_cache(maxsize=None).

* bpo-40503: **PEP 615**, the "zoneinfo" module. Adds support for the
  IANA time zone database.

* bpo-40397: Removed attributes "__args__" and "__parameters__" from
  special generic aliases like "typing.List" (not subscripted).

* bpo-40549: Convert posixmodule.c ("posix" or "nt" module) to the
  multiphase initialization (PEP 489).

* bpo-31033: Add a "msg" argument to "Future.cancel()" and
  "Task.cancel()".

* bpo-40541: Added an optional *counts* parameter to random.sample().

* bpo-40515: The "ssl" and "hashlib" modules now actively check that
  OpenSSL is build with thread support. Python 3.7.0 made thread
  support mandatory and no longer works safely with a no-thread
  builds.

* bpo-31033: When a "asyncio.Task" is cancelled, the exception
  traceback now chains all the way back to where the task was first
  interrupted.

* bpo-40504: "functools.lru_cache()" objects can now be the targets of
  weakrefs.

* bpo-40559: Fix possible memory leak in the C implementation of
  "asyncio.Task".

* bpo-40480: "fnmatch.fnmatch()" could take exponential time in the
  presence of multiple "*" pattern characters.  This was repaired by
  generating more elaborate regular expressions to avoid futile
  backtracking.

* bpo-40495: "compileall" is now able to use hardlinks to prevent
  duplicates in a case when ".pyc" files for different optimization
  levels have the same content.

* bpo-40457: The ssl module now support OpenSSL builds without TLS 1.0
  and 1.1 methods.

* bpo-40355: Improve error reporting in "ast.literal_eval()" in the
  presence of malformed "ast.Dict" nodes instead of silently ignoring
  any non-conforming elements. Patch by Curtis Bucher.

* bpo-40465: Deprecated the optional *random* argument to
  *random.shuffle()*.

* bpo-40459: "platform.win32_ver()" now produces correct *ptype*
  strings instead of empty strings.

* bpo-39435: The first argument of "pickle.loads()" is now positional-
  only.

* bpo-39305: Update "nntplib" to merge "nntplib.NNTP" and
  "nntplib._NNTPBase". Patch by Dong-hee Na.

* bpo-32494: Update "dbm.gnu" to use gdbm_count if possible when
  calling "len()". Patch by Dong-hee Na.

* bpo-40453: Add "isolated=True" keyword-only parameter to
  "_xxsubinterpreters.create()". An isolated subinterpreter cannot
  spawn threads, spawn a child process or call "os.fork()".

* bpo-40286: Remove "_random.Random.randbytes()": the C implementation
  of "randbytes()". Implement the method in Python to ease
  subclassing: "randbytes()" now directly reuses "getrandbits()".

* bpo-40394: Added default arguments to
  "difflib.SequenceMatcher.find_longest_match()".

* bpo-39995: Fix a race condition in concurrent.futures._ThreadWakeup:
  access to _ThreadWakeup is now protected with the shutdown lock.

* bpo-30966: "Process.shutdown(wait=True)" of "concurrent.futures" now
  closes explicitly the result queue.

* bpo-30966: Add a new "close()" method to the "SimpleQueue" class to
  explicitly close the queue.

* bpo-39966: Revert bpo-25597. "unittest.mock.MagicMock" with wraps'
  set uses default return values for magic methods.

* bpo-39791: Added "files()" function to importlib.resources with
  support for subdirectories in package data, matching backport in
  importlib_resources 1.5.

* bpo-40375: "imaplib.IMAP4.unselect()" is added. Patch by Dong-hee
  Na.

* bpo-40389: "repr()" now returns "typing.Optional[T]" when called for
  "typing.Union" of two types, one of which is "NoneType".

* bpo-40291: Add support for CAN_J1939 sockets (available on Linux
  5.4+)

* bpo-40273: "types.MappingProxyType" is now reversible.

* bpo-39075: The repr for "types.SimpleNamespace" is now insertion
  ordered rather than alphabetical.

* bpo-40192: On AIX, "thread_time()" is now implemented with
  "thread_cputime()" which has nanosecond resolution, rather than
  "clock_gettime(CLOCK_THREAD_CPUTIME_ID)" which has a resolution of
  10 ms. Patch by Batuhan Taskaya.

* bpo-40025: Raise TypeError when _generate_next_value_ is defined
  after members. Patch by Ethan Onstott.

* bpo-39058: In the argparse module, the repr for Namespace() and
  other argument holders now displayed in the order attributes were
  added. Formerly, it displayed in alphabetical order even though
  argument order is preserved the user visible parts of the module.

* bpo-24416: The "isocalendar()" methods of "datetime.date" and
  "datetime.datetime" now return a *named tuple* instead of a "tuple".


Documentación
-------------

* bpo-34790: Add version of removal for explicit passing of coros to
  "asyncio.wait()"'s documentation

* bpo-40561: Provide docstrings for webbrowser open functions.

* bpo-40499: Mention that "asyncio.wait()" requires a non-empty set of
  awaitables.

* bpo-39705: Tutorial example for sorted() in the Loop Techniques
  section is given a better explanation. Also a new example is
  included to explain sorted()'s basic behavior.

* bpo-39435: Fix an incorrect signature for "pickle.loads()" in the
  docs


Pruebas
-------

* bpo-40055: distutils.tests now saves/restores warnings filters to
  leave them unchanged. Importing tests imports docutils which imports
  pkg_resources which adds a warnings filter.

* bpo-40436: test_gdb and test.pythoninfo now check gdb command exit
  code.


Construir
---------

* bpo-40653: Move _dirnameW out of HAVE_SYMLINK to fix a potential
  compiling issue.

* bpo-40514: Add "--with-experimental-isolated-subinterpreters" build
  option to "configure": better isolate subinterpreters, experimental
  build mode.


Ventanas
--------

* bpo-40650: Include winsock2.h in pytime.c for timeval.

* bpo-40458: Increase reserved stack space to prevent overflow crash
  on Windows.

* bpo-39148: Add IPv6 support to "asyncio" datagram endpoints in
  ProactorEventLoop. Change the raised exception for unknown address
  families to ValueError as it's not coming from Windows API.


Mac OS
------

* bpo-34956: When building Python on macOS from source, "_tkinter" now
  links with non-system Tcl and Tk frameworks if they are installed in
  "/Library/Frameworks", as had been the case on older releases of
  macOS. If a macOS SDK is explicitly configured, by using "--enable-
  universalsdk=" or "-isysroot", only the SDK itself is searched. The
  default behavior can still be overridden with "--with-tcltk-
  includes" and "--with-tcltk-libs".

* bpo-35569: Expose RFC 3542 IPv6 socket options.


Herramientas / Demos
--------------------

* bpo-40479: Update multissltest helper to test with latest OpenSSL
  1.0.2, 1.1.0, 1.1.1, and 3.0.0-alpha.

* bpo-40431: Fix a syntax typo in "turtledemo" that now raises a
  "SyntaxError".

* bpo-40163: Fix multissltest tool. OpenSSL has changed download URL
  for old releases. The multissltest tool now tries to download from
  current and old download URLs.


API C
-----

* bpo-39465: Remove the "_PyUnicode_ClearStaticStrings()" function
  from the C API.

* bpo-38787: Add PyCFunction_CheckExact() macro for exact type checks
  now that we allow subtypes of PyCFunction, as well as
  PyCMethod_CheckExact() and PyCMethod_Check() for the new PyCMethod
  subtype.

* bpo-40545: Declare "_PyErr_GetTopmostException()" with
  "PyAPI_FUNC()" to properly export the function in the C API. The
  function remains private ("_Py") prefix.

* bpo-40412: Nullify inittab_copy during finalization, preventing
  future interpreter initializations in an embedded situation from
  crashing. Patch by Gregory Szorc.

* bpo-40429: The "PyThreadState_GetFrame()" function now returns a
  strong reference to the frame.

* bpo-40428: Remove the following functions from the C API. Call
  "PyGC_Collect()" explicitly to free all free lists.

  * "PyAsyncGen_ClearFreeLists()"

  * "PyContext_ClearFreeList()"

  * "PyDict_ClearFreeList()"

  * "PyFloat_ClearFreeList()"

  * "PyFrame_ClearFreeList()"

  * "PyList_ClearFreeList()"

  * "PySet_ClearFreeList()"

  * "PyTuple_ClearFreeList()"

* bpo-40421: New "PyFrame_GetBack()" function: get the frame next
  outer frame.

* bpo-40421: New "PyFrame_GetCode()" function: return a borrowed
  reference to the frame code.

* bpo-40217: Ensure that instances of types created with
  "PyType_FromSpecWithBases()" will visit its class object when
  traversing references in the garbage collector (implemented as an
  extension of the provided "tp_traverse"). Patch by Pablo Galindo.

* bpo-38787: Module C state is now accessible from C-defined heap type
  methods (**PEP 573**). Patch by Marcel Plch and Petr Viktorin.


Python 3.9.0 alpha 6
====================

*Release date: 2020-04-27*


Seguridad
---------

* bpo-40121: Fixes audit events raised on creating a new socket.

* bpo-39073: Disallow CR or LF in email.headerregistry.Address
  arguments to guard against header injection attacks.

* bpo-39503: CVE-2020-8492: The "AbstractBasicAuthHandler" class of
  the "urllib.request" module uses an inefficient regular expression
  which can be exploited by an attacker to cause a denial of service.
  Fix the regex to prevent the catastrophic backtracking.
  Vulnerability reported by Ben Caller and Matt Schwager.


Núcleo y elementos integrados
-----------------------------

* bpo-40313: Improve the performance of bytes.hex().

* bpo-40334: Switch to a new parser, based on PEG.  For more details
  see PEP 617. To temporarily switch back to the old parser, use "-X
  oldparser" or "PYTHONOLDPARSER=1".  In Python 3.10 we will remove
  the old parser completely, including the "parser" module (already
  deprecated) and anything that depends on it.

* bpo-40267: Fix the tokenizer to display the correct error message,
  when there is a SyntaxError on the last input character and no
  newline follows. It used to be "unexpected EOF while parsing", while
  it should be "invalid syntax".

* bpo-39522: Correctly unparse explicit "u" prefix for strings when
  postponed evaluation for annotations activated. Patch by Batuhan
  Taskaya.

* bpo-40246: Report a specialized error message, "invalid string
  prefix", when the tokenizer encounters a string with an invalid
  prefix.

* bpo-40082: Fix the signal handler: it now always uses the main
  interpreter, rather than trying to get the current Python thread
  state.

* bpo-37388: str.encode() and str.decode() no longer check the
  encoding and errors in development mode or in debug mode during
  Python finalization. The codecs machinery can no longer work on very
  late calls to str.encode() and str.decode().

* bpo-40077: Fix possible refleaks in "_json", memo of PyScannerObject
  should be traversed.

* bpo-37207: Speed up calls to "dict()" by using the **PEP 590**
  "vectorcall" calling convention.

* bpo-40141: Add column and line information to "ast.keyword" nodes.
  Patch by Pablo Galindo.

* bpo-1635741: Port "resource" to multiphase initialization (**PEP
  489**).

* bpo-1635741: Port "math" to multiphase initialization (**PEP 489**).

* bpo-1635741: Port _uuid module to multiphase initialization (**PEP
  489**).

* bpo-40077: Convert json module to use "PyType_FromSpec()".

* bpo-40067: Improve the error message for multiple star expressions
  in an assignment. Patch by Furkan Onder

* bpo-1635741: Port _functools module to multiphase initialization
  (PEP 489). Patch by Paulo Henrique Silva.

* bpo-1635741: Port operator module to multiphase initialization (PEP
  489). Patch by Paulo Henrique Silva.

* bpo-20526: Fix "PyThreadState_Clear()". "PyThreadState.frame" is a
  borrowed reference, not a strong reference: "PyThreadState_Clear()"
  must not call "Py_CLEAR(tstate->frame)".

* bpo-1635741: Port time module to multiphase initialization (**PEP
  489**). Patch by Paulo Henrique Silva.

* bpo-1635741: Port _weakref extension module to multiphase
  initialization (**PEP 489**).

* bpo-40020: Fix a leak and subsequent crash in parsetok.c caused by
  realloc misuse on a rare codepath.

* bpo-39939: Added str.removeprefix and str.removesuffix methods and
  corresponding bytes, bytearray, and collections.UserString methods
  to remove affixes from a string if present. See **PEP 616** for a
  full description. Patch by Dennis Sweeney.

* bpo-39481: Implement PEP 585. This supports list[int], tuple[str,
  ...] etc.

* bpo-32894: Support unparsing of infinity numbers in postponed
  annotations. Patch by Batuhan Taşkaya.

* bpo-37207: Speed up calls to "list()" by using the **PEP 590**
  "vectorcall" calling convention. Patch by Mark Shannon.


Biblioteca
----------

* bpo-40398: "typing.get_args()" now always returns an empty tuple for
  special generic aliases.

* bpo-40396: Functions "typing.get_origin()", "typing.get_args()" and
  "typing.get_type_hints()" support now generic aliases like
  "list[int]".

* bpo-38061: Optimize the "subprocess" module on FreeBSD using
  "closefrom()". A single "close(fd)" syscall is cheap, but when
  "sysconf(_SC_OPEN_MAX)" is high, the loop calling "close(fd)" on
  each file descriptor can take several milliseconds.

  The workaround on FreeBSD to improve performance was to load and
  mount the fdescfs kernel module, but this is not enabled by default.

  Initial patch by Ed Maste (emaste), Conrad Meyer (cem), Kyle Evans
  (kevans) and Kubilay Kocak (koobs):
  https://bugs.freebsd.org/bugzilla/show_bug.cgi?id=242274

* bpo-38061: On FreeBSD, "os.closerange(fd_low, fd_high)" now calls
  "closefrom(fd_low)" if *fd_high* is greater than or equal to
  "sysconf(_SC_OPEN_MAX)".

  Initial patch by Ed Maste (emaste), Conrad Meyer (cem), Kyle Evans
  (kevans) and Kubilay Kocak (koobs):
  https://bugs.freebsd.org/bugzilla/show_bug.cgi?id=242274

* bpo-40360: The "lib2to3" module is pending deprecation due to **PEP
  617**.

* bpo-40138: Fix the Windows implementation of "os.waitpid()" for exit
  code larger than "INT_MAX >> 8". The exit status is now interpreted
  as an unsigned number.

* bpo-39942: Set "__main__" as the default module name when "__name__"
  is missing in "typing.TypeVar". Patch by Weipeng Hong.

* bpo-40275: The "logging" package is now imported lazily in
  "unittest" only when the "assertLogs()" assertion is used.

* bpo-40275: The "asyncio" package is now imported lazily in
  "unittest" only when the "IsolatedAsyncioTestCase" class is used.

* bpo-40330: In "ShareableList.__setitem__()", check the size of a new
  string item after encoding it to utf-8, not before.

* bpo-40148: Added "pathlib.Path.with_stem()" to create a new Path
  with the stem replaced.

* bpo-40325: Deprecated support for set objects in random.sample().

* bpo-40257: Improved help for the "typing" module. Docstrings are now
  shown for all special forms and special generic aliases (like
  "Union" and "List"). Using "help()" with generic alias like
  "List[int]" will show the help for the correspondent concrete type
  ("list" in this case).

* bpo-40257: func:"inspect.getdoc" no longer returns docstring
  inherited from the type of the object or from parent class if it is
  a class if it is not defined in the object itself. In "pydoc" the
  documentation string is now shown not only for class, function,
  method etc, but for any object that has its own "__doc__" attribute.

* bpo-40287: Fixed "SpooledTemporaryFile.seek()" to return the
  position.

* bpo-40290: Added zscore() to statistics.NormalDist().

* bpo-40282: Allow "random.getrandbits(0)" to succeed and to return 0.

* bpo-40286: Add "random.randbytes()" function and
  "random.Random.randbytes()" method to generate random bytes.

* bpo-40277: "collections.namedtuple()" now provides a human-readable
  repr for its field accessors.

* bpo-40270: The included copy of sqlite3 on Windows is now compiled
  with the json extension. This allows the use of functions such as
  "json_object".

* bpo-29255: Wait in "KqueueSelector.select" when no fds are
  registered

* bpo-40260: Ensure "modulefinder" uses "io.open_code()" and respects
  coding comments.

* bpo-40234: Allow again to spawn daemon threads in subinterpreters
  (revert change which denied them).

* bpo-39207: Workers in "ProcessPoolExecutor" are now spawned on
  demand, only when there are no available idle workers to reuse. This
  optimizes startup overhead and reduces the amount of lost CPU time
  to idle workers. Patch by Kyle Stanley.

* bpo-40091: Fix a hang at fork in the logging module: the new private
  _at_fork_reinit() method is now used to reinitialize locks at fork
  in the child process.

* bpo-40149: Implement traverse and clear slots in _abc._abc_data
  type.

* bpo-40208: Remove deprecated "symtable.SymbolTable.has_exec()".

* bpo-40196: Fix a bug in the "symtable" module that was causing
  incorrectly report global variables as local. Patch by Pablo
  Galindo.

* bpo-40190: Add support for "_SC_AIX_REALMEM" to "posix.sysconf()".

* bpo-40182: Removed the "_field_types" attribute of the
  "typing.NamedTuple" class.

* bpo-36517: Multiple inheritance with "typing.NamedTuple" now raises
  an error instead of silently ignoring other types.

* bpo-40126: Fixed reverting multiple patches in unittest.mock.
  Patcher's "__exit__()" is now never called if its "__enter__()" is
  failed. Returning true from "__exit__()" silences now the exception.

* bpo-40094: CGIHTTPRequestHandler of http.server now logs the CGI
  script exit code, rather than the CGI script exit status of
  os.waitpid(). For example, if the script is killed by signal 11, it
  now logs: "CGI script exit code -11."

* bpo-40108: Improve the error message when triying to import a module
  using "runpy" and incorrently use the ".py" extension at the end of
  the module name. Patch by Pablo Galindo.

* bpo-40094: Add "os.waitstatus_to_exitcode()" function: convert a
  wait status to an exit code.

* bpo-40089: Fix threading._after_fork(): if fork was not called by a
  thread spawned by threading.Thread, threading._after_fork() now
  creates a _MainThread instance for _main_thread, instead of a
  _DummyThread instance.

* bpo-40089: Add a private "_at_fork_reinit()" method to
  "_thread.Lock", "_thread.RLock", "threading.RLock" and
  "threading.Condition" classes: reinitialize the lock at fork in the
  child process, reset the lock to the unlocked state. Rename also the
  private "_reset_internal_locks()" method of "threading.Event" to
  "_at_fork_reinit()".

* bpo-25780: Expose "CAN_RAW_JOIN_FILTERS" in the "socket" module.

* bpo-39503: "AbstractBasicAuthHandler" of "urllib.request" now parses
  all WWW-Authenticate HTTP headers and accepts multiple challenges
  per header: use the realm of the first Basic challenge.

* bpo-39812: Removed daemon threads from "concurrent.futures" by
  adding an internal "threading._register_atexit()", which calls
  registered functions prior to joining all non-daemon threads. This
  allows for compatibility with subinterpreters, which don't support
  daemon threads.

* bpo-40050: Fix "importlib._bootstrap_external": avoid creating a new
  "winreg" builtin module if it's already available in "sys.modules",
  and remove redundant imports.

* bpo-40014: Fix "os.getgrouplist()": if "getgrouplist()" function
  fails because the group list is too small, retry with a larger group
  list. On failure, the glibc implementation of "getgrouplist()" sets
  "ngroups" to the total number of groups. For other implementations,
  double the group list size.

* bpo-40017: Add "time.CLOCK_TAI" constant if the operating system
  support it.

* bpo-40016: In re docstring, clarify the relationship between inline
  and argument compile flags.

* bpo-39953: Update internal table of OpenSSL error codes in the "ssl"
  module.

* bpo-36144: Added **PEP 584** operators to
  "weakref.WeakValueDictionary".

* bpo-36144: Added **PEP 584** operators to
  "weakref.WeakKeyDictionary".

* bpo-38891: Fix linear runtime behaviour of the "__getitem__" and
  "__setitem__" methods in
  "multiprocessing.shared_memory.ShareableList". This avoids quadratic
  performance when iterating a "ShareableList". Patch by Thomas
  Krennwallner.

* bpo-39682: Remove undocumented support for *closing* a
  "pathlib.Path" object via its context manager. The context manager
  magic methods remain, but they are now a no-op, making "Path"
  objects immutable.

* bpo-36144: Added **PEP 584** operators ("|" and "|=") to
  "collections.ChainMap".

* bpo-39011: Normalization of line endings in ElementTree attributes
  was removed, as line endings which were replaced by entity numbers
  should be preserved in original form.

* bpo-38410: Properly handle "sys.audit()" failures in
  "sys.set_asyncgen_hooks()".

* bpo-36541: lib2to3 now recognizes named assignment expressions (the
  walrus operator, ":=")

* bpo-35967: In platform, delay the invocation of 'uname -p' until the
  processor attribute is requested.

* bpo-35113: "inspect.getsource()" now returns correct source code for
  inner class with same name as module level class. Decorators are
  also returned as part of source of the class. Patch by Karthikeyan
  Singaravelan.

* bpo-33262: Deprecate passing None as an argument for
  "shlex.split()"'s "s" parameter.  Patch by Zackery Spytz.

* bpo-31758: Prevent crashes when using an uninitialized
  "_elementtree.XMLParser" object. Patch by Oren Milman.


Documentación
-------------

* bpo-27635: The pickle documentation incorrectly claimed that
  "__new__" isn't called by default when unpickling.

* bpo-39879: Updated Modelo de datos docs to include "dict()"
  insertion order preservation. Patch by Furkan Onder and Samy Lahfa.

* bpo-38387: Document "PyDoc_STRVAR" macro in the C-API reference.

* bpo-13743: Some methods within xml.dom.minidom.Element class are now
  better documented.


Pruebas
-------

* bpo-31904: Set expected default encoding in
  test_c_locale_coercion.py for VxWorks RTOS.

* bpo-40162: Update Travis CI configuration to OpenSSL 1.1.1f.

* bpo-40146: Update OpenSSL to 1.1.1f in Azure Pipelines.

* bpo-40094: Add "test.support.wait_process()" function.

* bpo-40003: "test.bisect_cmd" now copies Python command line options
  like "-O" or "-W". Moreover, emit a warning if "test.bisect_cmd" is
  used with "-w"/"--verbose2" option.

* bpo-39380: Add the encoding in "ftplib.FTP" and "ftplib.FTP_TLS" to
  the constructor as keyword-only and change the default from
  "latin-1" to "utf-8" to follow **RFC 2640**.

* bpo-39793: Use the same domain when testing "make_msgid". Patch by
  Batuhan Taskaya.

* bpo-1812: Fix newline handling in doctest.testfile when loading from
  a package whose loader has a get_data method. Patch by Peter Donis.


Construir
---------

* bpo-38360: Support single-argument form of macOS -isysroot flag.

* bpo-40158: Fix CPython MSBuild Properties in NuGet Package
  (build/native/python.props)

* bpo-38527: Fix configure check on Solaris for "float word ordering":
  sometimes, the correct "grep" command was not being used. Patch by
  Arnon Yaari.


Ventanas
--------

* bpo-40164: Updates Windows to OpenSSL 1.1.1f

* bpo-8901: Ignore the Windows registry when the "-E" option is used.


Mac OS
------

* bpo-38329: python.org macOS installers now update the Current
  version symlink of /Library/Frameworks/Python.framework/Versions for
  3.9 installs. Previously, Current was only updated for Python 2.x
  installs. This should make it easier to embed Python 3 into other
  macOS applications.

* bpo-40164: Update macOS installer builds to use OpenSSL 1.1.1g.


INACTIVO
--------

* bpo-38439: Add a 256×256 pixel IDLE icon to support more modern
  environments. Created by Andrew Clover. Delete the unused macOS
  idle.icns icon file.

* bpo-38689: IDLE will no longer freeze when inspect.signature fails
  when fetching a calltip.


Herramientas / Demos
--------------------

* bpo-40385: Removed the checkpyc.py tool. Please see compileall
  without force mode as a potential alternative.

* bpo-40179: Fixed translation of "#elif" in Argument Clinic.

* bpo-40094: Fix "which.py" script exit code: it now uses
  "os.waitstatus_to_exitcode()" to convert "os.system()" exit status
  into an exit code.


API C
-----

* bpo-40241: Move the "PyGC_Head" structure to the internal C API.

* bpo-40170: Convert "PyObject_IS_GC()" macro to a function to hide
  implementation details.

* bpo-40241: Add the functions "PyObject_GC_IsTracked()" and
  "PyObject_GC_IsFinalized()" to the public API to allow to query if
  Python objects are being currently tracked or have been already
  finalized by the garbage collector respectively. Patch by Pablo
  Galindo.

* bpo-40170: The "PyObject_NEW()" macro becomes an alias to the
  "PyObject_New()" macro, and the "PyObject_NEW_VAR()" macro becomes
  an alias to the "PyObject_NewVar()" macro, to hide implementation
  details. They no longer access directly the
  "PyTypeObject.tp_basicsize" member.

* bpo-40170: "PyType_HasFeature()" now always calls
  "PyType_GetFlags()" to hide implementation details. Previously, it
  accessed directly the "PyTypeObject.tp_flags" member when the
  limited C API was not used.

* bpo-40170: Convert the "PyObject_GET_WEAKREFS_LISTPTR()" macro to a
  function to hide implementation details: the macro accessed directly
  to the "PyTypeObject.tp_weaklistoffset" member.

* bpo-40170: Convert "PyObject_CheckBuffer()" macro to a function to
  hide implementation details: the macro accessed directly the
  "PyTypeObject.tp_as_buffer" member.

* bpo-40170: Always declare "PyIndex_Check()" as an opaque function to
  hide implementation details: remove "PyIndex_Check()" macro. The
  macro accessed directly the "PyTypeObject.tp_as_number" member.

* bpo-39947: Add "PyThreadState_GetID()" function: get the unique
  identifier of a Python thread state.


Python 3.9.0 alpha 5
====================

*Release date: 2020-03-23*


Seguridad
---------

* bpo-38576: Disallow control characters in hostnames in http.client,
  addressing CVE-2019-18348. Such potentially malicious header
  injection URLs now cause a InvalidURL to be raised.


Núcleo y elementos integrados
-----------------------------

* bpo-40010: Optimize pending calls in multithreaded applications. If
  a thread different than the main thread schedules a pending call
  ("Py_AddPendingCall()"), the bytecode evaluation loop is no longer
  interrupted at each bytecode instruction to check for pending calls
  which cannot be executed. Only the main thread can execute pending
  calls.

  Previously, the bytecode evaluation loop was interrupted at each
  instruction until the main thread executes pending calls.

* bpo-1635741: Port _weakref extension module to multiphase
  initialization (**PEP 489**).

* bpo-1635741: Port _collections module to multiphase initialization
  (**PEP 489**).

* bpo-40010: Optimize signal handling in multithreaded applications.
  If a thread different than the main thread gets a signal, the
  bytecode evaluation loop is no longer interrupted at each bytecode
  instruction to check for pending signals which cannot be handled.
  Only the main thread of the main interpreter can handle signals.

  Previously, the bytecode evaluation loop was interrupted at each
  instruction until the main thread handles signals.

* bpo-39984: If "Py_AddPendingCall()" is called in a subinterpreter,
  the function is now scheduled to be called from the subinterpreter,
  rather than being called from the main interpreter. Each
  subinterpreter now has its own list of scheduled calls.

* bpo-1635741: Port _heapq module to multiphase initialization.

* bpo-1635741: Port itertools module to multiphase initialization
  (**PEP 489**).

* bpo-37207: Speed up calls to "frozenset()" by using the **PEP 590**
  "vectorcall" calling convention. Patch by Dong-hee Na.

* bpo-39984: subinterpreters: Move
  "_PyRuntimeState.ceval.tracing_possible" to
  "PyInterpreterState.ceval.tracing_possible": each interpreter now
  has its own variable.

* bpo-37207: Speed up calls to "set()" by using the **PEP 590**
  "vectorcall" calling convention. Patch by Dong-hee Na.

* bpo-1635741: Port _statistics module to multiphase initialization
  (**PEP 489**).

* bpo-39968: Use inline function to replace extension modules'
  get_module_state macros.

* bpo-39965: Correctly raise "SyntaxError" if *await* is used inside
  non-async functions and "PyCF_ALLOW_TOP_LEVEL_AWAIT" is set (like in
  the asyncio REPL). Patch by Pablo Galindo.

* bpo-39562: Allow executing asynchronous comprehensions on the top
  level when the "PyCF_ALLOW_TOP_LEVEL_AWAIT" flag is given. Patch by
  Batuhan Taskaya.

* bpo-37207: Speed up calls to "tuple()" by using the **PEP 590**
  "vectorcall" calling convention. Patch by Dong-hee Na.

* bpo-38373: Changed list overallocation strategy. It no longer
  overallocates if the new size is closer to overallocated size than
